"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Accordion;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireWildcard(require("react"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
function Accordion(param) {
    var children = param.children;
    var ref = _slicedToArray((0, _react).useState(function() {
        return children && children.findIndex(function(child) {
            return child.props.expanded;
        });
    }), 2), expanded1 = ref[0], setExpanded = ref[1];
    if (!children) {
        return null;
    }
    return(// wrapped in a Fragment so react-docgen recognizes this as a Component:
    /*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, _react.default.Children.map(children, function(child, i) {
        return(/*#__PURE__*/ _react.default.cloneElement(child, {
            expanded: expanded1 === i,
            onChange: function(e, expanded) {
                e.preventDefault();
                setExpanded(expanded ? i : null);
            }
        }));
    })));
}
Accordion.propTypes = {
    /**
   * A list of `ExpandableSection`s that will be controlled.
   */ children: _propTypes.default.node
};

//# sourceMappingURL=Accordion.js.map