"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFActionButton';
var defaultClasses = {
    label: "".concat(PREFIX, "-label"),
    caption: "".concat(PREFIX, "-caption"),
    button: "".concat(PREFIX, "-button"),
    value: "".concat(PREFIX, "-value")
};
var _obj;
var StyledButton = (0, _styles).styled(_material.Button)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles passed through to the [`Button`](https://mui.com/api/button/#css) element's
   * `label` CSS rule.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.label), {
        justifyContent: 'space-between',
        alignItems: 'baseline',
        textTransform: 'none'
    }), /**
   * Styles applied to the label container.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.caption), {
        textTransform: 'none',
        fontWeight: 'bold'
    }), /**
   * Styles passed through to the [`Button`](https://mui.com/api/button/#css) element's
   * `contained` CSS rule.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.button), {
        boxShadow: 'none',
        backgroundColor: theme.palette.grey[200]
    }), /**
   * Styles applied to the values container.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.value), {
        color: theme.palette.text.primary,
        whiteSpace: 'nowrap',
        textOverflow: 'ellipses',
        marginLeft: '10px'
    }), _obj;
});
/**
 * This button class displays a label and value.
 *
 * Example:
 *
 * ```js
 *  <ActionButton label="Sort" value="Lowest Price" onClick={openSortMenu} />
 * ```
 */ var ActionButton = /*#__PURE__*/ (0, _react).forwardRef(function(_param, ref) {
    var label = _param.label, value = _param.value, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, props = _objectWithoutProperties(_param, [
        "label",
        "value",
        "classes"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var caption = classes.caption, valueClasses = classes.value, button = classes.button, labelClasses = classes.label, otherClasses = _objectWithoutProperties(classes, [
        "caption",
        "value",
        "button",
        "label"
    ]);
    return(/*#__PURE__*/ _react.default.createElement(StyledButton, _extends({
        ref: ref,
        variant: "contained",
        color: "primary",
        classes: _objectSpread({
            contained: button,
            label: labelClasses
        }, otherClasses)
    }, props), /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "button",
        className: caption
    }, label), /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "caption",
        className: valueClasses
    }, value)));
});
ActionButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The label to display on the left side of the button.
   */ label: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ]),
    /**
   * The value to display on the right side of the button.
   */ value: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ])
};
var _default = ActionButton;
exports.default = _default;

//# sourceMappingURL=ActionButton.js.map