"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = BackToTop;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _throttle = _interopRequireDefault(require("lodash/throttle"));
var _iconsMaterial = require("@mui/icons-material");
var _material = require("@mui/material");
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFBackToTop';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    fab: "".concat(PREFIX, "-fab"),
    icon: "".concat(PREFIX, "-icon")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        zIndex: 1,
        position: 'fixed',
        bottom: 24,
        right: 16
    }), /**
   * Styles applied to the floating action button element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.fab), {
        background: 'rgba(0,0,0,.85)',
        '&:hover': {
            background: 'rgb(0,0,0)'
        }
    }), /**
   * Styles applied to the icon element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.icon), {
        color: 'white'
    }), _obj;
});
function BackToTop(param) {
    var Icon = param.Icon, showUnderY = param.showUnderY, instantBehaviorUnderY = param.instantBehaviorUnderY, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, fadeTime = param.fadeTime, size = param.size;
    var ref = _slicedToArray((0, _react).useState(false), 2), visible = ref[0], setVisible = ref[1];
    var el = (0, _react).useRef();
    var classes = _objectSpread({
    }, defaultClasses, c);
    (0, _react).useEffect(function() {
        var onScroll = (0, _throttle).default(function() {
            setVisible(getScrollY() > showUnderY && el.current.parentElement && el.current.parentElement.offsetParent != null);
        }, 200);
        window.addEventListener('scroll', onScroll, {
            passive: true
        });
        return function() {
            return window.removeEventListener('scroll', onScroll);
        };
    }, []);
    var scrollToTop = function() {
        var behavior = getScrollY() > instantBehaviorUnderY ? 'auto' : 'smooth';
        window.scrollTo({
            top: 0,
            left: 0,
            behavior: behavior
        });
    };
    Icon = Icon || _iconsMaterial.ArrowUpward;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root,
        ref: el
    }, /*#__PURE__*/ _react.default.createElement(_material.Fade, {
        in: visible,
        timeout: fadeTime
    }, /*#__PURE__*/ _react.default.createElement(_material.Fab, {
        className: classes.fab,
        size: size,
        onClick: scrollToTop,
        title: "back to top"
    }, /*#__PURE__*/ _react.default.createElement(Icon, {
        className: classes.icon
    })))));
}
BackToTop.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The icon to use within the `Fab` component.
   */ Icon: _propTypes.default.elementType,
    /**
   * Value which controls where along the Y position the `BackToTop` component is shown.
   */ showUnderY: _propTypes.default.number,
    /**
   * When the scroll position is less than this value, the page will smoothly scroll back up. If
   * the scroll position is more than this value, the page will immediately scroll back up.
   */ instantBehaviorUnderY: _propTypes.default.number,
    /**
   * Duration of the fade in/out animation for the icon.
   */ fadeTime: _propTypes.default.number,
    /**
   * Controls size of component.
   */ size: _propTypes.default.oneOf([
        'small',
        'medium',
        'large'
    ])
};
BackToTop.defaultProps = {
    showUnderY: 250,
    instantBehaviorUnderY: 3000,
    fadeTime: 320,
    size: 'medium'
};
function getScrollY() {
    return window.scrollY || window.pageYOffset;
}

//# sourceMappingURL=BackToTop.js.map