"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Box;
exports.Vbox = exports.Hbox = void 0;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'Box';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    split: "".concat(PREFIX, "-split")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        display: 'flex'
    }), /**
   * Styles applied to the root element if [`split`](#prop-split) is `true`.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.split), {
        justifyContent: 'space-between',
        alignItems: 'center'
    }), _obj;
});
function Box(_param) {
    var className = _param.className, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, _split = _param.split, split = _split === void 0 ? false : _split, children = _param.children, style = _param.style, align = _param.align, justify = _param.justify, other = _objectWithoutProperties(_param, [
        "className",
        "classes",
        "split",
        "children",
        "style",
        "align",
        "justify"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: (0, _clsx).default(classes.root, className, _defineProperty({
        }, classes.split, split)),
        style: _objectSpread({
            alignItems: align,
            justifyContent: justify
        }, other, style)
    }, children));
}
Box.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * If `true`, split items on opposite sides of the box by applying justify-content: 'space-between'
   */ split: _propTypes.default.bool,
    /**
   * CSS value for align-items
   */ align: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'stretch',
        'baseline'
    ]),
    /**
   * CSS value for justify-content
   */ justify: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'space-around',
        'space-between',
        'initial',
        'inherit',
        'stretch',
        'baseline', 
    ]),
    className: _propTypes.default.string,
    style: _propTypes.default.object
};
Box.defaultProps = {
    align: 'center',
    justify: 'flex-start'
};
var Hbox = function Hbox(props) {
    return(/*#__PURE__*/ _react.default.createElement(Box, _extends({
    }, props, {
        flexDirection: "row"
    })));
};
exports.Hbox = Hbox;
Hbox.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * True to split items on opposite sides of the box by applying `justify-content: 'space-between'`.
   */ split: _propTypes.default.bool,
    /**
   * CSS value for `align-items` style.
   */ align: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'stretch',
        'baseline'
    ]),
    /**
   * CSS value for `justify-content` style
   */ justify: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'space-around',
        'space-between',
        'initial',
        'inherit',
        'stretch',
        'baseline', 
    ])
};
Hbox.defaultProps = {
    align: 'center',
    justify: 'flex-start'
};
var Vbox = function Vbox(props) {
    props = _objectSpread({
    }, props, {
        flexDirection: 'column'
    });
    return(/*#__PURE__*/ _react.default.createElement(Box, _extends({
    }, props)));
};
exports.Vbox = Vbox;
Vbox.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * CSS value for `align-items` style.
   */ align: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'stretch',
        'baseline'
    ]),
    /**
   * CSS value for `justify-content` style.
   */ justify: _propTypes.default.oneOf([
        'flex-start',
        'flex-end',
        'center',
        'space-around',
        'space-between',
        'initial',
        'inherit',
        'stretch',
        'baseline', 
    ]),
    className: _propTypes.default.string,
    style: _propTypes.default.object
};
Vbox.defaultProps = {
    align: 'center',
    justify: 'flex-start'
};

//# sourceMappingURL=Box.js.map