"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = CartButton;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _iconsMaterial = require("@mui/icons-material");
var _material = require("@mui/material");
var _clsx = _interopRequireDefault(require("clsx"));
var _toolbarButton = _interopRequireDefault(require("./ToolbarButton"));
var _link = _interopRequireDefault(require("./link/Link"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFCartButton';
var defaultClasses = {
    link: "".concat(PREFIX, "-link"),
    badge: "".concat(PREFIX, "-badge"),
    icon: "".concat(PREFIX, "-icon")
};
var _obj;
var StyledLink = (0, _styles).styled(_link.default)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the [`Link`](/apiReference/link/Link) element used as the root.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.link), {
    }), /**
   * Styles passed through to the [`Badge`](https://mui.com/api/badge/#css) element's
   * `badge` CSS rule.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.badge), {
        border: '2px solid white',
        padding: '0 4px'
    }), /**
   * Styles applied to the button icon.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.icon), {
        color: theme.palette.action.active
    }), _obj;
});
function CartButton(param) {
    var href = param.href, as = param.as, onClick = param.onClick, icon = param.icon, quantity = param.quantity, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, linkProps = param.linkProps, badgeProps = param.badgeProps, buttonProps = param.buttonProps;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var cartIcon = icon || /*#__PURE__*/ _react.default.createElement(_iconsMaterial.ShoppingCart, {
        className: classes.icon
    });
    return(/*#__PURE__*/ _react.default.createElement(StyledLink, _extends({
    }, linkProps.anchorProps, {
        className: (0, _clsx).default(classes.link, linkProps.className),
        href: href,
        as: as,
        onClick: onClick
    }), /*#__PURE__*/ _react.default.createElement(_toolbarButton.default, _extends({
    }, buttonProps), /*#__PURE__*/ _react.default.createElement(_material.Badge, _extends({
        badgeContent: quantity
    }, badgeProps, {
        classes: _objectSpread({
        }, badgeProps.classes, {
            badge: classes.badge
        })
    }), cartIcon))));
}
CartButton.propTypes = {
    /**
   * The url path to the cart page.
   */ href: _propTypes.default.string,
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Optional custom cart icon.
   */ icon: _propTypes.default.node,
    /**
   * Props passed through to the [`ToolbarButton`](/apiReference/ToolbarButton#props) element.
   */ buttonProps: _propTypes.default.object,
    /**
   * Props passed through to the [`Badge`](https://mui.com/api/badge/#props) element.
   */ badgeProps: _propTypes.default.object,
    /**
   * Props passed through to the [`Link`](/apiReference/link/Link#props) element.
   */ linkProps: _propTypes.default.object,
    as: _propTypes.default.string,
    onClick: _propTypes.default.func,
    quantity: _propTypes.default.number
};
CartButton.defaultProps = {
    href: '/cart',
    badgeProps: {
        color: 'primary'
    },
    buttonProps: {
        'aria-label': 'Cart',
        color: 'inherit'
    },
    linkProps: {
        anchorProps: {
            'data-th': 'cart-link'
        }
    }
};

//# sourceMappingURL=CartButton.js.map