"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.classes = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _lazyLoadImages = _interopRequireDefault(require("./utils/lazyLoadImages"));
var _serviceWorker = require("./serviceWorker");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFCmsSlot';
var classes = {
    inline: "".concat(PREFIX, "-inline"),
    block: "".concat(PREFIX, "-block"),
    root: "".concat(PREFIX, "-root")
};
var _obj;
var Root = (0, _styles).styled('span')(function() {
    return _obj = {
    }, _defineProperty(_obj, "& .".concat(classes.inline), {
        display: 'inline'
    }), _defineProperty(_obj, "& .".concat(classes.block), {
        display: 'block'
    }), _defineProperty(_obj, "& .".concat(classes.root), {
        '& .rsf-presized-img': {
            position: 'relative',
            '& img': {
                position: 'absolute',
                height: '100%',
                width: '100%',
                top: 0,
                left: 0
            }
        },
        '& img[data-src]': {
            visibility: 'hidden'
        }
    }), _obj;
});
exports.classes = classes;
var _obj1;
/**
 * A container for HTML blob content from a CMS.  Content is dangerously inserted into the DOM.
 * Pass the html as a string as the child of this component. Additional props are spread to the
 * rendered span element.
 */ var CmsSlot = function(_param) {
    var children = _param.children, className = _param.className, inline = _param.inline, lazyLoadImages = _param.lazyLoadImages, prefetchLinks = _param.prefetchLinks, others = _objectWithoutProperties(_param, [
        "children",
        "className",
        "inline",
        "lazyLoadImages",
        "prefetchLinks"
    ]);
    var el = (0, _react).useRef();
    (0, _react).useEffect(function() {
        try {
            if (!el.current) return;
            if (lazyLoadImages) {
                (0, _lazyLoadImages).default(el.current);
            }
            if (prefetchLinks) {
                var links = Array.from(el.current.querySelectorAll('a[data-rsf-prefetch="always"]'));
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = links[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var link = _step.value;
                        (0, _serviceWorker).prefetchJsonFor(link.getAttribute('href'));
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        } catch (e) {
            console.warn('error running side effects on CmsSlot', e);
        }
    }, [
        children
    ]);
    return children ? /*#__PURE__*/ _react.default.createElement(Root, _extends({
    }, others, {
        ref: el,
        className: (0, _clsx).default(className, classes.root, (_obj1 = {
        }, _defineProperty(_obj1, classes.inline, inline), _defineProperty(_obj1, classes.block, !inline), _obj1)),
        dangerouslySetInnerHTML: {
            __html: children
        }
    })) : null;
};
CmsSlot.propTypes = {
    /**
   * If `true`, will use `display: inline` style.
   */ inline: _propTypes.default.bool,
    /**
   * If `true` to lazy load images that have been preprocessed with `$.lazyLoadImages()`.
   */ lazyLoadImages: _propTypes.default.bool,
    /**
   * If `true`, prefetch links that have a `data-rsf-prefetch` attribute.
   */ prefetchLinks: _propTypes.default.bool,
    className: _propTypes.default.string
};
CmsSlot.defaultProps = {
    lazyLoadImages: false
};
var _default = CmsSlot;
exports.default = _default;

//# sourceMappingURL=CmsSlot.js.map