"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Fill;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'Fill';
var classes = {
    root: "".concat(PREFIX, "-root"),
    child: "".concat(PREFIX, "-child")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(classes.root), {
        position: 'relative',
        width: '100%'
    }), /**
   * Styles applied to the wrapper element for the children.
   */ _defineProperty(_obj, "& .".concat(classes.child), {
        position: 'absolute',
        top: 0,
        left: 0,
        width: '100%',
        height: '100%',
        '& > *': {
            width: '100%',
            height: '100%'
        }
    }), _obj;
});
function Fill(_param) {
    var height = _param.height, children = _param.children, className = _param.className, props = _objectWithoutProperties(_param, [
        "height",
        "children",
        "className"
    ]);
    children = _react.Children.only(children);
    if (height == null) {
        return children;
    }
    return(/*#__PURE__*/ _react.default.createElement(Root, _extends({
        className: (0, _clsx).default(classes.root, className)
    }, props), /*#__PURE__*/ _react.default.createElement("div", {
        style: {
            paddingTop: height
        }
    }), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.child
    }, children)));
}
Fill.propTypes = {
    /**
   * The height as a percentage of the width in a css compatible expression.  For example:
   * `"100%"` or `"calc(100% + 50px)"`, etc...  If omitted, this component does nothing except render
   * the provided child.
   */ height: _propTypes.default.string,
    className: _propTypes.default.string
};

//# sourceMappingURL=Fill.js.map