"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = ForwardThumbnail;
var _react = _interopRequireWildcard(require("react"));
var _pwacontext = _interopRequireDefault(require("./PWAContext"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function ForwardThumbnail(param) {
    var children = param.children;
    var ref = (0, _react).useRef(null);
    var context = (0, _react).useContext(_pwacontext.default);
    var srcRef = (0, _react).useRef(null);
    var setSrcRef = (0, _react).useCallback(function() {
        if (ref.current.querySelector('img')) {
            srcRef.current = ref.current.querySelector('img').getAttribute('src');
        }
    }, []);
    (0, _react).useEffect(setSrcRef, [
        children
    ]);
    var handleClick = (0, _react).useCallback(function() {
        if (!srcRef.current) {
            setSrcRef();
        }
        context.thumbnail.current = {
            src: srcRef.current
        };
    }, []);
    return(/*#__PURE__*/ _react.default.createElement("div", {
        ref: ref,
        onClick: handleClick
    }, children));
}

//# sourceMappingURL=ForwardThumbnail.js.map