"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Highlight;
var _react = _interopRequireDefault(require("react"));
var _amp = require("next/amp");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var escapeHtml = function(unsafe) {
    return unsafe.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;').replace(/'/g, '&#039;');
};
var addHighlight = function(query, text) {
    var className = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : '';
    if (!text) return '';
    return escapeHtml(text).replace(new RegExp(query, 'gi'), function(match) {
        return "<span class=\"".concat(className, "\">").concat(match, "</span>");
    });
};
function Highlight(_param) {
    var query = _param.query, text = _param.text, _classes = _param.classes, classes = _classes === void 0 ? {
    } : _classes, props = _objectWithoutProperties(_param, [
        "query",
        "text",
        "classes"
    ]);
    if ((0, _amp).useAmp()) {
        return(/*#__PURE__*/ _react.default.createElement(_material.Typography, _extends({
        }, props), text));
    }
    return(/*#__PURE__*/ _react.default.createElement(_material.Typography, _extends({
    }, props, {
        dangerouslySetInnerHTML: {
            __html: addHighlight(query, text, classes.highlight)
        }
    })));
}
Highlight.propTypes = {
    query: _propTypes.default.string,
    text: _propTypes.default.string,
    classes: _propTypes.default.object
};

//# sourceMappingURL=Highlight.js.map