"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Image;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _reactVisibilitySensor = _interopRequireDefault(require("react-visibility-sensor"));
var _pwacontext = _interopRequireDefault(require("./PWAContext"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFImage';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    image: "".concat(PREFIX, "-image"),
    fit: "".concat(PREFIX, "-fit"),
    contain: "".concat(PREFIX, "-contain"),
    fill: "".concat(PREFIX, "-fill")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        position: 'relative',
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        // Without a minimum height and width, the container will not fire
        // the visibility change
        minHeight: 1,
        minWidth: 1
    }), /**
   * Styles applied to the image element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.image), {
    }), /**
   * Styles applied to the image element when [`aspectRatio`](#prop-aspectRatio) is defined.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.fit), {
        position: 'absolute',
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        display: 'block',
        width: '100%',
        height: '100%'
    }), /**
   * Styles applied to the root element when [`contain`](#prop-contain) is `true`.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.contain), {
        '& img': {
            objectFit: 'contain',
            maxHeight: '100%',
            maxWidth: '100%'
        }
    }), /**
   * Styles applied to the root element when [`fill`](#prop-fill) is `true`.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.fill), {
        width: '100%',
        height: '100%',
        '& img': {
            display: 'block',
            objectFit: 'contain',
            maxHeight: '100%',
            maxWidth: '100%',
            width: '100%',
            height: '100%'
        }
    }), _obj;
});
var _obj1, _obj2;
function Image(_param) {
    var lazyLoad = function lazyLoad(visible) {
        if (!loaded && visible) {
            setLoaded(true);
        }
    };
    var lazy = _param.lazy, lazyOffset = _param.lazyOffset, notFoundSrc = _param.notFoundSrc, height = _param.height, width = _param.width, fill = _param.fill, bind = _param.bind, contain = _param.contain, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, className = _param.className, aspectRatio = _param.aspectRatio, alt = _param.alt, src = _param.src, amp = _param.amp, optimize = _param.optimize, onChange = _param.onChange, onSrcChange = _param.onSrcChange, onAltChange = _param.onAltChange, value = _param.value, ImgElement = _param.ImgElement, imgAttributes = _objectWithoutProperties(_param, [
        "lazy",
        "lazyOffset",
        "notFoundSrc",
        "height",
        "width",
        "fill",
        "bind",
        "contain",
        "classes",
        "className",
        "aspectRatio",
        "alt",
        "src",
        "amp",
        "optimize",
        "onChange",
        "onSrcChange",
        "onAltChange",
        "value",
        "ImgElement"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var hydrating = ((0, _react).useContext(_pwacontext.default) || {
    }).hydrating;
    var ref = _slicedToArray((0, _react).useState(lazy === false || lazy === 'ssr' && !hydrating), 2), loaded = ref[0], setLoaded = ref[1];
    var ref1 = _slicedToArray((0, _react).useState(false), 2), primaryNotFound = ref1[0], setPrimaryNotFound = ref1[1];
    var ref2 = (0, _react).useRef();
    (0, _react).useEffect(function() {
        var img = ref2.current;
        if (img && img.complete && img.naturalWidth === 0) {
            setPrimaryNotFound(true);
        }
    }, []);
    if (src == null) return null;
    contain = contain || aspectRatio;
    if (primaryNotFound && notFoundSrc) {
        src = notFoundSrc;
    }
    var result = /*#__PURE__*/ _react.default.createElement(Root, {
        className: (0, _clsx).default(className, (_obj1 = {
        }, _defineProperty(_obj1, classes.root, true), _defineProperty(_obj1, classes.contain, contain), _defineProperty(_obj1, classes.fill, fill), _obj1))
    }, aspectRatio && /*#__PURE__*/ _react.default.createElement("div", {
        style: {
            paddingTop: "".concat(aspectRatio * 100, "%")
        }
    }), loaded && /*#__PURE__*/ _react.default.createElement(ImgElement, _extends({
        ref: ref2,
        src: src,
        key: src,
        height: height,
        width: width,
        alt: alt,
        className: (0, _clsx).default((_obj2 = {
        }, _defineProperty(_obj2, classes.image, true), _defineProperty(_obj2, classes.fit, aspectRatio != null), _obj2))
    }, imgAttributes, {
        // prevent render "onerror" as a DOM prop in case of amp-img tag
        onError: ImgElement !== 'amp-img' ? function() {
            return setPrimaryNotFound(true);
        } : /* istanbul ignore next */ undefined
    })));
    result = /*#__PURE__*/ _react.default.createElement(_reactVisibilitySensor.default, {
        active: !loaded,
        onChange: lazyLoad,
        partialVisibility: true,
        offset: {
            top: -lazyOffset,
            bottom: -lazyOffset
        }
    }, result);
    return result;
}
Image.propTypes = {
    /**
   * The URL for the image.
   */ src: _propTypes.default.string,
    /**
   * The URL of the image to use in case the primary image fails to load.
   */ notFoundSrc: _propTypes.default.string,
    /**
   * The ratio of height/width as a float.  For example: `1` when the height and width match,
   * `0.5` when height is half of the width.
   */ aspectRatio: _propTypes.default.number,
    /**
   * Set to `true` to apply object-fit:contain to the image so that it automatically
   * fits within the element's height and width.
   */ contain: _propTypes.default.bool,
    /**
   * The same as `contain`, except images are stretched to fill the element's height and width.
   */ fill: _propTypes.default.bool,
    /**
   * Set to `true` to wait until the image enters the viewport before loading it. Set to `"ssr"` to
   * only lazy load images during server side rendering.
   */ lazy: _propTypes.default.oneOf([
        'ssr',
        true,
        false
    ]),
    /**
   * Sets the minimum amount of pixels the image can be scrolled out of view before it
   * is lazy loaded.  You must set `lazy` in order for this setting to take effect.
   */ lazyOffset: _propTypes.default.number
};
Image.defaultProps = {
    contain: false,
    fill: false,
    lazy: false,
    lazyOffset: 100,
    ImgElement: 'img'
};

//# sourceMappingURL=Image.js.map