"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Lazy;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _reactVisibilitySensor = _interopRequireDefault(require("react-visibility-sensor"));
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _amp = require("next/amp");
var _pwacontext = _interopRequireDefault(require("./PWAContext"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFLazy';
var defaultClasses = {
    root: "".concat(PREFIX, "-root")
};
var Root = (0, _styles).styled('div')(function() {
    return(/**
   * Styles applied to the root element.
   */ _defineProperty({
    }, "&.".concat(defaultClasses.root), {
        minHeight: 1,
        minWidth: 1
    }));
});
function Lazy(_param) {
    var onChange = function onChange(v) {
        if (!visible && v) {
            setVisible(true);
        }
    };
    var ssrOnly = _param.ssrOnly, className = _param.className, children = _param.children, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, otherProps = _objectWithoutProperties(_param, [
        "ssrOnly",
        "className",
        "children",
        "classes"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var amp = (0, _amp).useAmp();
    var hydrating = (0, _react).useContext(_pwacontext.default).hydrating;
    var ref = _slicedToArray((0, _react).useState(amp || ssrOnly && !hydrating), 2), visible = ref[0], setVisible = ref[1];
    return(/*#__PURE__*/ _react.default.createElement(_reactVisibilitySensor.default, {
        onChange: onChange,
        active: !visible,
        partialVisibility: true
    }, /*#__PURE__*/ _react.default.createElement(Root, _extends({
        className: (0, _clsx).default(classes.root, className)
    }, otherProps), visible && children)));
}
Lazy.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * CSS class to apply to the root element
   */ className: _propTypes.default.string,
    /**
   * Set to `true` to render children immediately when this component is mounted after initial hydration.
   */ ssrOnly: _propTypes.default.bool
};
Lazy.defaultProps = {
    ssrOnly: false
};

//# sourceMappingURL=Lazy.js.map