"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getRegistryCount = getRegistryCount;
exports.LazyStyles = LazyStyles;
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _useIntersectionObserver = _interopRequireDefault(require("./hooks/useIntersectionObserver"));
var _styles = require("@mui/styles");
var _jss = require("jss");
var _router = _interopRequireDefault(require("next/router"));
var _isBrowser = _interopRequireDefault(require("./utils/isBrowser"));
var _minifyStyles = _interopRequireDefault(require("./utils/minifyStyles"));
var _amp = require("next/amp");
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var fuiEvents = [
    'mouseover',
    'touchstart',
    'scroll'
];
var touchEvents = [
    'touchstart',
    'mouseover'
];
var eventOptions = {
    once: true,
    capture: true,
    passive: true
};
var registries = [];
function getRegistryCount() {
    return registries.length;
}
if ((0, _isBrowser).default()) {
    window.__lazyHydrateNavigated = false;
}
function LazyStyles() {
    /* istanbul ignore next */ if ((0, _amp).useAmp()) return null;
    var styles = null;
    try {
        styles = /*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, registries.map(function(registry) {
            function applyScope(sheet) {
                var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                try {
                    for(var _iterator = sheet.rules.index[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        var rule = _step.value;
                        if (rule.type === 'conditional') {
                            applyScope(rule);
                        } else {
                            rule.selectorText = "#".concat(registry.id, " ").concat(rule.selectorText);
                        }
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                            _iterator.return();
                        }
                    } finally{
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
            var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
            try {
                // Apply these styles only to the wrapped component
                for(var _iterator1 = registry.registry[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                    var sheet1 = _step1.value;
                    applyScope(sheet1);
                }
            } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                        _iterator1.return();
                    }
                } finally{
                    if (_didIteratorError1) {
                        throw _iteratorError1;
                    }
                }
            }
            return(/*#__PURE__*/ _react.default.createElement("style", {
                key: registry.id,
                id: registry.id,
                dangerouslySetInnerHTML: {
                    __html: (0, _minifyStyles).default(registry.toString())
                }
            }));
        }));
    } finally{
        // Clear registeries so we do not leak memory
        registries = [];
    }
    return styles;
}
function LazyStylesProvider(param) {
    var id = param.id, children = param.children;
    var generateClassName = (0, _styles).createGenerateClassName({
        seed: id
    });
    var registry = new _jss.SheetsRegistry();
    registry.id = id;
    registries.push(registry);
    return(/*#__PURE__*/ _react.default.createElement(_styles.StylesProvider, {
        sheetsManager: new Map(),
        serverGenerateClassName: generateClassName,
        sheetsRegistry: registry
    }, children));
}
_router.default.events.on('routeChangeStart', function() {
    window.__lazyHydrateNavigated = true;
});
function LazyHydrateInstance(_param) {
    var isHydrated = function isHydrated() {
        if ((0, _isBrowser).default()) {
            // If rendering after client side navigation
            if (window.__lazyHydrateNavigated) return true;
            // return true
            if (ssrOnly) return false;
            return !!props.hydrated;
        } else {
            return true;
        }
    };
    var hydrate = function hydrate() {
        if (!hydrated) {
            setHydrated(true);
            removeSSRStyles();
        }
    };
    var removeSSRStyles = function removeSSRStyles() {
        // Remove the server side generated stylesheet
        var stylesheet = window.document.getElementById(id);
        if (stylesheet) {
            stylesheet.remove();
        }
    };
    var id = _param.id, className = _param.className, ssrOnly = _param.ssrOnly, children = _param.children, on = _param.on, props = _objectWithoutProperties(_param, [
        "id",
        "className",
        "ssrOnly",
        "children",
        "on"
    ]);
    var childRef = (0, _react).useRef(null);
    var ref = _slicedToArray((0, _react).useState(isHydrated()), 2), hydrated = ref[0], setHydrated = ref[1];
    // hydrate if the hydrated prop is changed to true
    (0, _react).useEffect(function() {
        if (props.hydrated) {
            hydrate();
        }
    }, [
        props.hydrated,
        ssrOnly
    ]);
    if (on === 'visible') {
        (0, _useIntersectionObserver).default(// As root node does not have any box model, it cannot intersect.
        function() {
            return childRef.current.children[0];
        }, function(visible, disconnect) {
            if (visible) {
                hydrate();
                disconnect();
            }
        }, [], // Fallback to eager hydration
        /* istanbul ignore next */ function() {
            return hydrate();
        });
    }
    (0, _react).useEffect(function() {
        if (hydrated) return;
        var handler = function() {
            hydrate();
            clearEventListeners();
        };
        var clearEventListeners = function() {
            if (on === 'touch') {
                touchEvents.forEach(function(type) {
                    childRef.current.removeEventListener(type, handler, eventOptions);
                });
            } else if (on === 'fui') {
                fuiEvents.forEach(function(type) {
                    window.removeEventListener(type, handler, eventOptions);
                });
            }
        };
        var onUnmount = function() {
            // remove the SSR styles since the next time this component renders it will already be hydrated
            removeSSRStyles();
            clearEventListeners();
        };
        if (on === 'fui') {
            fuiEvents.forEach(function(type) {
                return window.addEventListener(type, handler, eventOptions);
            });
        } else if (on === 'touch') {
            touchEvents.forEach(function(type) {
                return childRef.current.addEventListener(type, handler, eventOptions);
            });
        }
        return onUnmount;
    }, [
        on
    ]);
    if (hydrated) {
        return(/*#__PURE__*/ _react.default.createElement("div", {
            ref: childRef,
            id: id,
            className: className,
            style: {
                display: 'contents'
            }
        }, children));
    } else {
        return(/*#__PURE__*/ _react.default.createElement("div", {
            ref: childRef,
            id: id,
            className: className,
            style: {
                display: 'contents'
            },
            suppressHydrationWarning: true,
            dangerouslySetInnerHTML: {
                __html: ''
            }
        }));
    }
}
/**
 * LazyHydrate a component based on a specified trigger
 *
 * Example usage:
 *
 *  <LazyHydrate id="foo">
 *    <div>some expensive component</div>
 *  </LazyHydrate>
 *
 */ function LazyHydrate(_param) {
    var children = _param.children, props = _objectWithoutProperties(_param, [
        "children"
    ]);
    /* istanbul ignore next */ if ((0, _amp).useAmp()) return children;
    return(/*#__PURE__*/ _react.default.createElement(LazyHydrateInstance, _extends({
    }, props), (0, _isBrowser).default() ? children : /*#__PURE__*/ _react.default.createElement(LazyStylesProvider, _extends({
    }, props), children)));
}
LazyHydrate.defaultProps = {
    on: 'visible'
};
LazyHydrate.propTypes = {
    // Identification of component
    id: _propTypes.default.string.isRequired,
    // Control the hydration of the component externally with this prop
    hydrated: _propTypes.default.bool,
    // Force component to never hydrate
    ssrOnly: _propTypes.default.bool,
    /* 
    Event to trigger hydration
    eventOptions
      - `visible` triggers hydration when component comes into the viewport
      - `touch` triggers hydration on touchstart or mouseover
      - `fui` (default) triggers hydration when user first interacts with page
  */ on: _propTypes.default.oneOf([
        'visible',
        'touch',
        'fui'
    ])
};
var _default = LazyHydrate;
exports.default = _default;

//# sourceMappingURL=LazyHydrate.js.map