"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Offline;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _iconsMaterial = require("@mui/icons-material");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFOffline';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    icon: "".concat(PREFIX, "-icon"),
    heading: "".concat(PREFIX, "-heading"),
    message: "".concat(PREFIX, "-message")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        display: 'flex',
        flexDirection: 'column',
        width: '100%',
        alignItems: 'center',
        marginTop: '40px',
        color: '#999'
    }), /**
   * Styles applied to the icon element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.icon), {
        fontSize: 60,
        color: '#999'
    }), /**
   * Styles applied to the heading element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.heading), {
    }), /**
   * Styles applied to the message element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.message), {
    }), _obj;
});
function Offline(param) {
    var tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, heading = param.heading, message = param.message, Icon = param.Icon;
    var classes = _objectSpread({
    }, defaultClasses, c);
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(Icon, {
        className: classes.icon
    }), /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "h6",
        component: "h1",
        className: classes.heading
    }, heading), /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "caption",
        className: classes.message
    }, message)));
}
Offline.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Text (or an element) to display as the heading.
   */ heading: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ]),
    /**
   * Text (or an element) to display as the message.
   */ message: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ]),
    /**
   * An icon to display.
   */ Icon: _propTypes.default.elementType
};
Offline.defaultProps = {
    heading: "You're offline",
    message: 'Please check your internet connection',
    Icon: function() {
        /*#__PURE__*/ return _react.default.createElement(_iconsMaterial.CloudOff, null);
    }
};

//# sourceMappingURL=Offline.js.map