"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = QuantitySelector;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _iconsMaterial = require("@mui/icons-material");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFQuantitySelector';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    icon: "".concat(PREFIX, "-icon"),
    button: "".concat(PREFIX, "-button"),
    subtract: "".concat(PREFIX, "-subtract"),
    add: "".concat(PREFIX, "-add"),
    input: "".concat(PREFIX, "-input")
};
var _obj;
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        backgroundColor: theme.palette.divider,
        border: 'none',
        width: '110px',
        padding: 0
    }), /**
   * Styles applied to the icon elements.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.icon), {
        fontSize: '1.3125rem',
        position: 'relative'
    }), /**
   * Styles applied to the icon button elements.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.button), {
        height: '36px',
        width: '36px',
        padding: 0
    }), /**
   * Styles applied to the subtract icon button element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.subtract), {
        marginRight: theme.spacing(-4.5)
    }), /**
   * Styles applied to the add icon button element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.add), {
        marginLeft: theme.spacing(-4.5)
    }), /**
   * Styles applied to the text input element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.input), {
        width: 100,
        color: theme.palette.text.primary,
        backgroundColor: theme.palette.grey[200],
        textAlign: 'center',
        padding: theme.spacing(1, 0, 1, 0),
        border: 'none',
        fontSize: theme.spacing(2),
        outline: 'none',
        '&::before': {
            display: 'none'
        }
    }), _obj;
});
function QuantitySelector(param) {
    var name = param.name, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, addIcon = param.addIcon, addButtonProps = param.addButtonProps, subtractIcon = param.subtractIcon, subtractButtonProps = param.subtractButtonProps, value1 = param.value, minValue = param.minValue, maxValue = param.maxValue, onChange = param.onChange, inputProps = param.inputProps, ariaLabel = param.ariaLabel;
    var handleChange = function handleChange(value) {
        if (value >= minValue && value <= maxValue) {
            onChange(value);
        }
    };
    var classes = _objectSpread({
    }, defaultClasses, c);
    var quantitySelector = classes.quantitySelector, icon = classes.icon, button = classes.button, inputClasses = _objectWithoutProperties(classes, [
        "quantitySelector",
        "icon",
        "button"
    ]);
    if (!value1) value1 = 1;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(_material.IconButton, _extends({
        size: "small",
        color: "primary",
        classes: {
            root: button
        },
        className: classes.subtract,
        onClick: function() {
            return handleChange(value1 - 1);
        },
        "aria-label": "add one ".concat(ariaLabel)
    }, subtractButtonProps), subtractIcon || /*#__PURE__*/ _react.default.createElement(_iconsMaterial.Remove, {
        classes: {
            root: icon
        }
    })), /*#__PURE__*/ _react.default.createElement("input", _extends({
        onChange: handleChange,
        value: value1,
        name: name
    }, {
        'aria-label': ariaLabel
    }, {
        className: (0, _clsx).default([
            classes.input,
            inputClasses
        ])
    }, inputProps, {
        readOnly: true
    })), /*#__PURE__*/ _react.default.createElement(_material.IconButton, _extends({
        size: "small",
        classes: {
            root: button
        },
        color: "primary",
        className: classes.add,
        onClick: function() {
            return handleChange(value1 + 1);
        },
        "aria-label": "subtract one ".concat(ariaLabel)
    }, addButtonProps), addIcon || /*#__PURE__*/ _react.default.createElement(_iconsMaterial.Add, {
        classes: {
            root: icon
        }
    }))));
}
QuantitySelector.propTypes = {
    /**
   * The name to apply to the input when rendering AMP.
   */ name: _propTypes.default.string,
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The plus icon.
   */ addIcon: _propTypes.default.element,
    /**
   * The minus icon.
   */ subtractIcon: _propTypes.default.element,
    /**
   * The current value.
   */ value: _propTypes.default.number,
    /**
   * The minimum value.
   */ minValue: _propTypes.default.number,
    /**
   * The maximum value.
   */ maxValue: _propTypes.default.number,
    /**
   * Called when the value is changed.  The new value is passed as the only argument
   */ onChange: _propTypes.default.func,
    /**
   * The accessibility label.  Add and subtract button `aria-label` values are derived from this as
   * `"add one {ariaLabel}"` and `"subtract one {ariaLabel}"`.
   */ ariaLabel: _propTypes.default.string,
    addButtonProps: _propTypes.default.object,
    inputProps: _propTypes.default.object,
    subtractButtonProps: _propTypes.default.object
};
QuantitySelector.defaultProps = {
    name: 'quantity',
    onChange: Function.prototype,
    addButtonProps: {
    },
    subtractButtonProps: {
    },
    inputProps: {
    },
    minValue: 1,
    maxValue: 100,
    ariaLabel: 'quantity'
};

//# sourceMappingURL=QuantitySelector.js.map