"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = TabPanel;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFTabPanel';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    panel: "".concat(PREFIX, "-panel"),
    hidden: "".concat(PREFIX, "-hidden")
};
var _obj;
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
    }), /**
   * Styles applied to the wrapper around each panel element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.panel), {
        margin: "".concat(theme.spacing(2), " 0")
    }), /**
   * Styles applied to the wrapper around each panel element when that panel is hidden.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.hidden), {
        display: 'none'
    }), _obj;
});
var _obj1;
function TabPanel(param) {
    var children = param.children, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, scrollable = param.scrollable, selectedProp = param.selected, onChange = param.onChange, tabsProps = param.tabsProps, tabProps = param.tabProps, panelProps = param.panelProps, renderPanels = param.renderPanels;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = _slicedToArray((0, _react).useState(selectedProp), 2), selected1 = ref[0], setSelected = ref[1];
    var tabs = [];
    var panels = [];
    var onChangeHandler = function(event, selected) {
        setSelected(selected);
        if (onChange) {
            onChange(selected);
        }
    };
    _react.default.Children.forEach(children, function(child, index) {
        tabs.push(/*#__PURE__*/ _react.default.createElement(_material.Tab, _extends({
            key: index,
            label: child.props.label
        }, tabProps({
            child: child,
            index: index,
            selected: selected1
        }))));
        var _ref = panelProps({
            child: child,
            index: index,
            selected: selected1
        }) || {
        }, className = _ref.className, others = _objectWithoutProperties(_ref, [
            "className"
        ]);
        panels.push(/*#__PURE__*/ _react.default.createElement("div", _extends({
            key: index,
            role: "tabpanel",
            className: (0, _clsx).default(classes.panel, (_obj1 = {
            }, _defineProperty(_obj1, classes.hidden, index !== selected1), _defineProperty(_obj1, className, true), _obj1))
        }, others), /*#__PURE__*/ _react.default.cloneElement(child, {
            label: null
        })));
    });
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(_material.Tabs, _extends({
        indicatorColor: "primary",
        textColor: "inherit",
        variant: scrollable ? 'scrollable' : null,
        value: selected1,
        onChange: onChangeHandler
    }, tabsProps), tabs), renderPanels(panels)));
}
TabPanel.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Set to false to prevent the tabs from scrolling.
   */ scrollable: _propTypes.default.bool,
    /**
   * Selected tab index.
   */ selected: _propTypes.default.number,
    /**
   * Called when the selected tab is changed.
   */ onChange: _propTypes.default.func,
    /**
   * A function that takes an object containing:
   *
   * - child: The child element
   * - index: The index of the child
   * - selected: The index of the currently selected element
   *
   * ... and returns props for the corresponding Material UI `Tab` element.
   */ tabProps: _propTypes.default.func,
    /**
   * A function that takes an object containing:
   *
   * - child: The child element
   * - index: The index of the child
   * - selected: The index of the currently selected element
   *
   * ... and returns props for the corresponding panel `div` element.
   */ panelProps: _propTypes.default.func,
    /**
   * Props for the Material UI `Tabs` element.
   */ tabsProps: _propTypes.default.object,
    /**
   * A function that takes the panels as an argument and returns a react element to render.
   */ renderPanels: _propTypes.default.func
};
TabPanel.defaultProps = {
    scrollable: true,
    selected: 0,
    tabProps: Function.prototype,
    panelProps: Function.prototype,
    renderPanels: function(panels) {
        return panels;
    }
};

//# sourceMappingURL=TabPanel.js.map