"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFToolbarButton';
var defaultClasses = {
    wrap: "".concat(PREFIX, "-wrap")
};
var StyledIconButton = (0, _styles).styled(_material.IconButton)(function(param) {
    var theme = param.theme;
    return(/**
   * Styles applied to the content wrapper element inside the button
   */ _defineProperty({
    }, "& .".concat(defaultClasses.wrap), _objectSpread({
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center'
    }, theme.typography.caption)));
});
/**
 * A toolbar button with optional label.  Use these in your AppBar. All additional
 * props are spread to the underlying mui IconButton.
 */ var ToolbarButton = /*#__PURE__*/ (0, _react).forwardRef(function(_param, ref) {
    var icon = _param.icon, label = _param.label, children = _param.children, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, others = _objectWithoutProperties(_param, [
        "icon",
        "label",
        "children",
        "classes"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var wrap = classes.wrap, buttonClasses = _objectWithoutProperties(classes, [
        "wrap"
    ]);
    return(/*#__PURE__*/ _react.default.createElement(StyledIconButton, _extends({
        ref: ref,
        classes: buttonClasses
    }, others, {
        size: "large"
    }), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.wrap
    }, icon, /*#__PURE__*/ _react.default.createElement("div", null, label)), children));
});
ToolbarButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The icon to use for the button.
   */ icon: _propTypes.default.element,
    /**
   * The label text for the button.
   */ label: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ])
};
var _default = ToolbarButton;
exports.default = _default;

//# sourceMappingURL=ToolbarButton.js.map