"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.AutoPlayVirtualizeSwipeableViews = exports.VirtualizeSwipeableViews = exports.AutoPlaySwipeableViews = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _reactSwipeableViews = _interopRequireDefault(require("react-swipeable-views"));
var _reactSwipeableViewsUtils = require("react-swipeable-views-utils");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _carouselDots = _interopRequireDefault(require("./CarouselDots"));
var _carouselArrows = _interopRequireDefault(require("./CarouselArrows"));
var _mod = _interopRequireDefault(require("../utils/mod"));
var _fill = _interopRequireDefault(require("../Fill"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFCarousel';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    swipeWrap: "".concat(PREFIX, "-swipeWrap"),
    autoPlaySwipeableViews: "".concat(PREFIX, "-autoPlaySwipeableViews"),
    hideTouchArrows: "".concat(PREFIX, "-hideTouchArrows")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'stretch',
        position: 'relative',
        flexBasis: '100%',
        '& img': {
            display: 'block'
        }
    }), /**
   * Styles applied to wrapper element of the swipe container.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.swipeWrap), {
        position: 'relative',
        overflow: 'hidden',
        flex: 1,
        height: '100%',
        '& .react-swipeable-view-container, & .react-swipeable-view-container > div': {
            height: '100%'
        }
    }), _defineProperty(_obj, "& .".concat(defaultClasses.autoPlaySwipeableViews), {
        overflowY: 'hidden',
        height: '100%'
    }), _defineProperty(_obj, "& .".concat(defaultClasses.hideTouchArrows), {
        '@media not all and (hover:none)': {
            display: 'none'
        }
    }), _obj;
});
var AutoPlaySwipeableViews = (0, _reactSwipeableViewsUtils).autoPlay(_reactSwipeableViews.default);
exports.AutoPlaySwipeableViews = AutoPlaySwipeableViews;
var VirtualizeSwipeableViews = (0, _reactSwipeableViewsUtils).virtualize(_reactSwipeableViews.default);
exports.VirtualizeSwipeableViews = VirtualizeSwipeableViews;
var AutoPlayVirtualizeSwipeableViews = (0, _reactSwipeableViewsUtils).autoPlay(VirtualizeSwipeableViews);
exports.AutoPlayVirtualizeSwipeableViews = AutoPlayVirtualizeSwipeableViews;
function useSelected(props) {
    var ref = _slicedToArray((0, _react).useState(0), 2), selected = ref[0], setSelected = ref[1];
    if (props.setSelected) {
        return props;
    }
    return {
        selected: selected,
        setSelected: setSelected
    };
}
/**
 * A grouped display of elements that shows one element at a time, and changes to peer elements by
 * swiping to the left or right, or by clicking arrows on the sides of the component. Generally used
 * as a non-Amp option for the [`CarouselComponent`](/apiReference/carousel/MediaCarousel#prop-CarouselComponent)
 * prop within a [`MediaCarousel`](/apiReference/carousel/MediaCarousel).
 */ var Carousel = /*#__PURE__*/ _react.default.forwardRef(function(props, ref) {
    var height = props.height, children = props.children, tmp = props.classes, c = tmp === void 0 ? {
    } : tmp, className = props.className, style = props.style, swipeStyle = props.swipeStyle, slideStyle = props.slideStyle, arrows = props.arrows, aboveAdornments = props.aboveAdornments, belowAdornments = props.belowAdornments, onMouseEnter = props.onMouseEnter, onMouseLeave = props.onMouseLeave, onClick = props.onClick, indicators = props.indicators, autoplay = props.autoplay, interval = props.interval, infinite = props.infinite;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref1 = useSelected(props), selected = ref1.selected, setSelected = ref1.setSelected;
    var count = !!children ? children.length : 0;
    var Tag = infinite ? VirtualizeSwipeableViews : _reactSwipeableViews.default;
    Tag = autoplay ? AutoPlaySwipeableViews : Tag;
    Tag = infinite && autoplay ? AutoPlayVirtualizeSwipeableViews : Tag;
    var slideRenderer = function(param) {
        var index = param.index;
        var key = "slide-renderer-".concat(index);
        var child = children[(0, _mod).default(index, count)];
        if (!child) return null;
        var slide = /*#__PURE__*/ _react.default.cloneElement(child);
        return(/*#__PURE__*/ _react.default.createElement(_react.Fragment, {
            key: key
        }, slide));
    };
    var onChangeIndex = (0, _react).useCallback(function(index) {
        if (!infinite) {
            setSelected(index);
            return;
        }
        // carousel loop-around calculations
        var nextSelectedIndex = index;
        if (nextSelectedIndex + 1 > count) {
            nextSelectedIndex = 0;
        } else if (nextSelectedIndex < 0) {
            nextSelectedIndex = count - 1;
        }
        setSelected(nextSelectedIndex);
    }, [
        infinite,
        count,
        selected,
        setSelected
    ]);
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        ref: ref,
        className: (0, _clsx).default(className, defaultClasses.root),
        style: style,
        onMouseEnter: onMouseEnter,
        onMouseLeave: onMouseLeave,
        onClick: onClick,
        height: height
    }, aboveAdornments, /*#__PURE__*/ _react.default.createElement(_fill.default, {
        height: height
    }, /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.swipeWrap
    }, /*#__PURE__*/ _react.default.createElement(Tag, {
        index: selected,
        onChangeIndex: onChangeIndex,
        className: classes.autoPlaySwipeableViews,
        style: swipeStyle,
        slideStyle: slideStyle,
        slideRenderer: props.slideRenderer || slideRenderer,
        interval: interval,
        containerStyle: {
            alignItems: 'center'
        }
    }), arrows !== false ? /*#__PURE__*/ _react.default.createElement(_carouselArrows.default, {
        className: arrows === 'desktop' ? classes.hideTouchArrows : null,
        selected: selected,
        setSelected: setSelected,
        count: count,
        infinite: infinite
    }) : /*#__PURE__*/ _react.default.createElement("div", null), indicators && /*#__PURE__*/ _react.default.createElement(_carouselDots.default, {
        count: count,
        selected: selected
    }))), belowAdornments));
});
Carousel.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Set to `false` to hide arrows, `'desktop'` to only show them
   * on non-touch devices, `'all'` to always show arrows.
   */ arrows: _propTypes.default.oneOf([
        false,
        'desktop',
        'all'
    ]),
    /**
   * Nodes to render above the Carousel.
   */ aboveAdornments: _propTypes.default.arrayOf(_propTypes.default.element),
    /**
   * Nodes to render below the Carousel.
   */ belowAdornments: _propTypes.default.arrayOf(_propTypes.default.element),
    /**
   * If `true`, the Carousel will automatically cycle through the media elements.
   */ autoplay: _propTypes.default.bool,
    /**
   * If true, scrolling past the last slide will cycle back to the first
   */ infinite: _propTypes.default.bool,
    /**
   * The interval time (in milliseconds) for [`autoplay`](#prop-autoplay).
   */ interval: _propTypes.default.number,
    height: _propTypes.default.string,
    className: _propTypes.default.string,
    slideRenderer: _propTypes.default.func,
    style: _propTypes.default.object,
    swipeStyle: _propTypes.default.object,
    slideStyle: _propTypes.default.object,
    onMouseEnter: _propTypes.default.func,
    onMouseLeave: _propTypes.default.func,
    onClick: _propTypes.default.func,
    indicators: _propTypes.default.bool
};
Carousel.defaultProps = {
    indicators: true,
    arrows: 'desktop',
    autoplay: false,
    interval: 3000,
    infinite: true
};
var _default = Carousel;
exports.default = _default;

//# sourceMappingURL=Carousel.js.map