"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFCarouselDots';
var defaultClasses = {
    dots: "".concat(PREFIX, "-dots"),
    dot: "".concat(PREFIX, "-dot"),
    dotSelected: "".concat(PREFIX, "-dotSelected")
};
var Dots = (0, _styles).styled('div')(function() {
    return(/**
   * Styles applied to the root element.
   */ _defineProperty({
    }, "&.".concat(defaultClasses.dots), {
        position: 'absolute',
        bottom: '5px',
        textAlign: 'center',
        width: '100%'
    }));
});
var _obj;
var Dot = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to each dot element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.dot), {
        backgroundColor: (0, _styles).alpha(theme.palette.text.primary, 0.25),
        width: 8,
        height: 8,
        borderWidth: '1px',
        borderStyle: 'solid',
        borderColor: theme.palette.background.paper,
        borderRadius: '50%',
        display: 'inline-block',
        margin: '0 2px',
        // Same duration as SwipeableViews animation
        transitionDuration: '0.35s'
    }), /**
   * Styles applied to the dot representing the selected slide.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.dotSelected), {
        backgroundColor: theme.palette.text.primary
    }), _obj;
});
var _obj1;
/**
 * An overlay shown at the bottom of a [`Carousel`](/apiReference/carousel/Carousel) that shows a
 * sequence of dots representing the slides in the Carousel.
 */ var CarouselDots = function CarouselDots(param) {
    var selected = param.selected, count = param.count, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var dots = [];
    for(var i = 0; i < count; i++){
        dots.push(/*#__PURE__*/ _react.default.createElement(Dot, {
            key: i,
            className: (0, _clsx).default((_obj1 = {
            }, _defineProperty(_obj1, classes.dot, true), _defineProperty(_obj1, classes.dotSelected, selected === i), _obj1))
        }));
    }
    return(/*#__PURE__*/ _react.default.createElement(Dots, {
        className: classes.dots
    }, dots));
};
CarouselDots.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The total number of dots to show.
   */ count: _propTypes.default.number,
    /**
   * The index of the selected dot.
   */ selected: _propTypes.default.number.isRequired
};
var _default = /*#__PURE__*/ _react.default.memo(CarouselDots);
exports.default = _default;

//# sourceMappingURL=CarouselDots.js.map