"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = exports.classes = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireDefault(require("react"));
var _clsx = _interopRequireDefault(require("clsx"));
var _tabs = _interopRequireDefault(require("@mui/material/Tabs"));
var _tab = _interopRequireDefault(require("@mui/material/Tab"));
var _useMediaQuery = _interopRequireDefault(require("@mui/material/useMediaQuery"));
var _mod = _interopRequireDefault(require("../utils/mod"));
var _image = _interopRequireDefault(require("../Image"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFCarouselThumbnails';
var defaultClasses = {
    thumbs: "".concat(PREFIX, "-thumbs"),
    thumb: "".concat(PREFIX, "-thumb"),
    tabsIndicator: "".concat(PREFIX, "-tabsIndicator"),
    tabsRoot: "".concat(PREFIX, "-tabsRoot"),
    tabsVertical: "".concat(PREFIX, "-tabsVertical"),
    tabsRootLeft: "".concat(PREFIX, "-tabsRootLeft"),
    tabsRootRight: "".concat(PREFIX, "-tabsRootRight"),
    tabsRootTop: "".concat(PREFIX, "-tabsRootTop"),
    tabsRootBottom: "".concat(PREFIX, "-tabsRootBottom"),
    tabRoot: "".concat(PREFIX, "-tabRoot"),
    selectedTab: "".concat(PREFIX, "-selectedTab"),
    tabWrapper: "".concat(PREFIX, "-tabWrapper")
};
var _obj, _obj1, _obj2;
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj2 = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj2, "&.".concat(defaultClasses.thumbs), {
        display: 'flex',
        justifyContent: 'center'
    }), /**
   * Styles applied to each thumbnail element.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.thumb), {
        width: 50,
        height: 50,
        boxSizing: 'content-box'
    }), /**
   * Styles passed through to the [`Tabs`](https://mui.com/api/tabs/#css) element's
   * `indicator` CSS rule.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabsIndicator), {
        display: 'none',
        backgroundColor: theme.palette.primary.main,
        height: '3px',
        transition: 'left 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms'
    }), /**
   * Styles applied to the root element of the Tabs element
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabsRoot), {
    }), /**
   * Styles applied the to the root element of the Tabs element when `thumbnailPosition` is `left` or `right`.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabsVertical), _defineProperty({
    }, theme.breakpoints.up('sm'), {
        flexDirection: 'column'
    })), _defineProperty(_obj2, "& .".concat(defaultClasses.tabsRootLeft), (_obj = {
    }, _defineProperty(_obj, theme.breakpoints.down('sm'), {
        marginTop: theme.spacing(2)
    }), _defineProperty(_obj, theme.breakpoints.up('sm'), {
        marginRight: theme.spacing(2)
    }), _obj)), _defineProperty(_obj2, "& .".concat(defaultClasses.tabsRootRight), (_obj1 = {
    }, _defineProperty(_obj1, theme.breakpoints.down('sm'), {
        marginTop: theme.spacing(2)
    }), _defineProperty(_obj1, theme.breakpoints.up('sm'), {
        marginLeft: theme.spacing(2)
    }), _obj1)), /**
   * Styles applied to the root element of the Tabs element when `thumbnailPosition` is `top`.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabsRootTop), {
        marginBottom: theme.spacing(2)
    }), /**
   * Styles applied to the root element of the Tabs element when `thumbnailPosition` is `bottom`.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabsRootBottom), {
        marginTop: theme.spacing(2)
    }), /**
   * Styles passed through to each [`Tab`](https://mui.com/api/tabs/#css) element's
   * `root` CSS rule.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabRoot), {
        minWidth: 'auto',
        padding: 0,
        outline: 'none',
        opacity: 0.7,
        transition: 'opacity linear 100ms',
        '&:hover': {
            opacity: 0.9
        }
    }), /**
   * Styles passed through to each [`Tab`](https://mui.com/api/tabs/#css) element's
   * `selected` CSS rule.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.selectedTab), {
        opacity: 1
    }), /**
   * Styles passed through to each [`Tab`](https://mui.com/api/tabs/#css) element's
   * `wrapper` CSS rule.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.tabWrapper), {
        margin: '0 2px',
        border: '1px solid transparent',
        '$selectedTab &': {
            border: '1px solid rgba(0,0,0,0.3)'
        }
    }), _obj2;
});
exports.classes = defaultClasses;
var _obj3;
/**
 * A set of thumbnails to show below a [`Carousel`](/apiReference/carousel/Carousel). Thumbnails can
 * be clicked to switch to the given slide. Internally, `CarouselThumbnails` uses MaterialUI's
 * [`Tabs`](https://mui.com/api/tabs) component to indicate which slide is selected
 */ var CarouselThumbnails = function CarouselThumbnails(param1) {
    var thumbnails = param1.thumbnails, selected = param1.selected, setSelected = param1.setSelected, tmp = param1.classes, c = tmp === void 0 ? {
    } : tmp, className = param1.className, thumbnailPosition = param1.thumbnailPosition, ImageComponent = param1.ImageComponent;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var theme = (0, _styles).useTheme();
    var isSmall = (0, _useMediaQuery).default(theme.breakpoints.down('sm'));
    var isVertical = !isSmall && [
        'left',
        'right'
    ].includes(thumbnailPosition);
    var count = thumbnails.length;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: (0, _clsx).default(className, classes.thumbs)
    }, /*#__PURE__*/ _react.default.createElement(_tabs.default, {
        indicatorColor: "primary",
        textColor: "inherit",
        value: selected !== false ? (0, _mod).default(selected, count) : false,
        variant: "scrollable",
        onChange: function(_, index) {
            return setSelected(index);
        },
        orientation: isVertical ? 'vertical' : 'horizontal',
        classes: {
            root: (0, _clsx).default(classes.tabsRoot, (_obj3 = {
            }, _defineProperty(_obj3, classes.tabsVertical, isVertical), _defineProperty(_obj3, classes.tabsRootLeft, thumbnailPosition === 'left'), _defineProperty(_obj3, classes.tabsRootRight, thumbnailPosition === 'right'), _defineProperty(_obj3, classes.tabsRootTop, thumbnailPosition === 'top'), _defineProperty(_obj3, classes.tabsRootBottom, thumbnailPosition === 'bottom'), _obj3)),
            indicator: classes.tabsIndicator
        }
    }, thumbnails.map(function(param, i) {
        var src = param.src, alt = param.alt;
        var icon = /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.tabWrapper
        }, /*#__PURE__*/ _react.default.createElement(ImageComponent, {
            contain: true,
            className: classes.thumb,
            src: src,
            alt: alt
        }));
        return(/*#__PURE__*/ _react.default.createElement(_tab.default, {
            classes: {
                root: classes.tabRoot,
                selected: classes.selectedTab
            },
            key: i,
            icon: icon
        }));
    }))));
};
CarouselThumbnails.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * CSS class to apply to the root element.
   */ className: _propTypes.default.string,
    /**
   * Index of the currently selected slide in the [`Carousel`](/apiReference/carousel/Carousel).
   */ selected: _propTypes.default.number,
    /**
   * Function to change the value of [`selected`](#prop-selected).
   */ setSelected: _propTypes.default.func,
    /**
   * Array of objects containing the data for an image to be used for each thumbnail.
   */ thumbnails: _propTypes.default.arrayOf(_propTypes.default.shape({
        src: _propTypes.default.string,
        alt: _propTypes.default.string
    })),
    /**
   * Position of the thumbnails, relative to the main carousel image.
   */ thumbnailPosition: _propTypes.default.oneOf([
        'bottom',
        'top',
        'left',
        'right'
    ]),
    /**
   * The component type to use to display images.
   */ ImageComponent: _propTypes.default.elementType
};
CarouselThumbnails.defaultProps = {
    ImageComponent: _image.default
};
var _default = CarouselThumbnails;
exports.default = _default;

//# sourceMappingURL=CarouselThumbnails.js.map