"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _close = _interopRequireDefault(require("@mui/icons-material/Close"));
var _material = require("@mui/material");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
var PREFIX = 'RSFLightbox';
var classes = {
    root: "".concat(PREFIX, "-root"),
    content: "".concat(PREFIX, "-content"),
    paper: "".concat(PREFIX, "-paper")
};
var _obj;
var StyledDialog = (0, _styles).styled(_material.Dialog)(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(classes.root), {
    }), /**
   * Styles passed through to the `paper` CSS rule of the [`Dialog`](https://mui.com/api/dialog/#css)
   * root element.
   */ _defineProperty(_obj, "& .".concat(classes.paper), {
        flex: 1,
        background: 'rgba(255,255,255,0.9)'
    }), _obj;
});
var StyledDialogContent = (0, _styles).styled(_material.DialogContent)(function() {
    return(/**
   * Styles applied to the content element of the modal.
   */ _defineProperty({
    }, "& .".concat(classes.content), {
        padding: 0,
        display: 'flex',
        flexDirection: 'column'
    }));
});
var Transition = /*#__PURE__*/ _react.default.forwardRef(function(props, ref) {
    return(/*#__PURE__*/ _react.default.createElement(_material.Zoom, _extends({
        duration: 500,
        ref: ref
    }, props)));
});
/**
 * A modal that opens to give a full-screen view of the elements within a
 * [`Carousel`](/apiReference/carousel/Carousel).
 */ var Lightbox = function Lightbox(param) {
    var children = param.children, onClose = param.onClose, open = param.open, TransitionComponent = param.TransitionComponent;
    var theme = (0, _styles).useTheme();
    return(/*#__PURE__*/ _react.default.createElement(StyledDialog, {
        open: open,
        fullScreen: true,
        classes: {
            paper: classes.paper
        },
        TransitionComponent: TransitionComponent,
        className: classes.root,
        style: {
            zIndex: theme.zIndex.modal + 10
        }
    }, /*#__PURE__*/ _react.default.createElement(_material.DialogActions, null, /*#__PURE__*/ _react.default.createElement(_material.IconButton, {
        onClick: onClose,
        size: "large"
    }, /*#__PURE__*/ _react.default.createElement(_close.default, null))), /*#__PURE__*/ _react.default.createElement(StyledDialogContent, {
        className: classes.content
    }, children)));
};
Lightbox.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Child nodes to show inside the Lightbox.
   */ children: _propTypes.default.node.isRequired,
    /**
   * A function to call when the Lightbox is closed.
   */ onClose: _propTypes.default.func,
    /**
   * If `true`, the Lightbox is open.
   */ open: _propTypes.default.bool.isRequired,
    /**
   * The component used for the [transition](https://mui.com/components/transitions/#transitioncomponent-prop).
   */ TransitionComponent: _propTypes.default.elementType
};
Lightbox.defaultProps = {
    TransitionComponent: Transition
};
var _default = /*#__PURE__*/ _react.default.memo(Lightbox);
exports.default = _default;

//# sourceMappingURL=Lightbox.js.map