"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireDefault(require("react"));
var _reactImageMagnify = _interopRequireDefault(require("react-image-magnify"));
var _clsx = _interopRequireDefault(require("clsx"));
var _image = _interopRequireDefault(require("../Image"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'Media';
var classes = {
    rimRoot: "".concat(PREFIX, "-rimRoot"),
    rimSmallImage: "".concat(PREFIX, "-rimSmallImage")
};
var _obj;
/**
 * An element that determines the proper tag to use for a media node within a
 * [`Carousel`](/apiReference/carousel/Carousel).
 */ var Media = function Media(param) {
    var magnifyProps = param.magnifyProps, imageProps = param.imageProps, videoProps = param.videoProps, src = param.src, alt = param.alt, magnify = param.magnify, sources = param.sources, _type = param.type, type = _type === void 0 ? 'image' : _type, ImageComponent = param.ImageComponent, ImageMagnifyComponent = param.ImageMagnifyComponent;
    var adjustMagnifyProps = function() {
        var appliedMagnifyProps = _objectSpread({
        }, magnifyProps || {
        });
        appliedMagnifyProps.style = _objectSpread({
        }, magnifyProps && magnifyProps.style || {
        }, {
            display: 'block',
            objectFit: 'contain'
        });
        appliedMagnifyProps.imageStyle = _objectSpread({
        }, magnifyProps && magnifyProps.imageStyle || {
        }, {
            objectFit: 'contain'
        });
        appliedMagnifyProps.className = (0, _clsx).default(magnifyProps && magnifyProps.className, classes.rimRoot);
        appliedMagnifyProps.imageClassName = (0, _clsx).default(magnifyProps && magnifyProps.imageClassName, classes.rimSmallImage);
        appliedMagnifyProps.enlargedImageStyle = _objectSpread({
        }, magnifyProps && magnifyProps.enlargedImageStyle || {
        }, {
            height: '100%'
        });
        return appliedMagnifyProps;
    };
    if (type === 'video') {
        if (sources && sources.length) {
            return(/*#__PURE__*/ _react.default.createElement("video", _extends({
                alt: alt
            }, videoProps), sources.map(function(source) {
                /*#__PURE__*/ return _react.default.createElement("source", {
                    key: source.src,
                    src: source.src,
                    type: source.type
                });
            })));
        }
        return(/*#__PURE__*/ _react.default.createElement("video", _extends({
            src: src,
            alt: alt
        }, videoProps)));
    }
    if (magnify) {
        var StyledImageMagnifyComponent = (0, _styles).styled(ImageMagnifyComponent)(function() {
            return _obj = {
            }, _defineProperty(_obj, "& .".concat(classes.rimRoot), {
                height: '100% !important',
                width: '100% !important'
            }), _defineProperty(_obj, "& .".concat(classes.rimSmallImage), {
                height: '100% !important',
                width: '100% !important'
            }), _obj;
        });
        return(/*#__PURE__*/ _react.default.createElement(StyledImageMagnifyComponent, _extends({
            enlargedImagePosition: "over"
        }, adjustMagnifyProps(), {
            smallImage: {
                src: src,
                alt: alt,
                isFluidWidth: true
            },
            largeImage: magnify
        })));
    }
    return(/*#__PURE__*/ _react.default.createElement(ImageComponent, _extends({
        key: src,
        src: src,
        alt: alt,
        fill: true
    }, imageProps)));
};
Media.propTypes = {
    /**
   * The type of media to display.
   */ type: _propTypes.default.oneOf([
        'image',
        'video'
    ]),
    /**
   * Props passed to the [`ReactImageMagnify`](https://github.com/ethanselzer/react-image-magnify#usage)
   * element for an `'image'` type when [`magnify`](#prop-magnify) is defined.
   */ magnifyProps: _propTypes.default.object,
    /**
   * Other props to pass to the video component.
   */ videoProps: _propTypes.default.object,
    /**
   * Other props to pass to the [`Image`](/apiReference/Image) for an `'image'` type.
   */ imageProps: _propTypes.default.object,
    /**
   * Used as the `alt` attribute for the `<img>` or `<video>`.
   */ alt: _propTypes.default.string,
    /**
   * Used as the `src` attribute for the `<img>` or `<video>`.
   */ src: _propTypes.default.string,
    /**
   * Used as the source inside the video `<video>`.
   */ sources: _propTypes.default.array,
    /**
   * An object to pass to pass to `ReactImageMagnify` containing the data for the magnified image.
   * If `false`, the media is not able to be magnified.
   */ magnify: _propTypes.default.oneOfType([
        _propTypes.default.bool,
        _propTypes.default.object
    ]),
    /**
   * The component type to use to display images.
   */ ImageComponent: _propTypes.default.elementType,
    /**
   * The component type to use to display magnified images.
   */ ImageMagnifyComponent: _propTypes.default.elementType
};
Media.defaultProps = {
    ImageComponent: _image.default,
    ImageMagnifyComponent: _reactImageMagnify.default
};
var _default = Media;
exports.default = _default;

//# sourceMappingURL=Media.js.map