"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireWildcard(require("react"));
var _clsx = _interopRequireDefault(require("clsx"));
var _useMediaQuery = _interopRequireDefault(require("@mui/material/useMediaQuery"));
var _get = _interopRequireDefault(require("lodash/get"));
var _carousel = _interopRequireDefault(require("./Carousel"));
var _image = _interopRequireDefault(require("../Image"));
var _lightbox = _interopRequireDefault(require("./Lightbox"));
var _media = _interopRequireDefault(require("./Media"));
var _magnifyHint = _interopRequireDefault(require("./MagnifyHint"));
var _carouselThumbnails = _interopRequireDefault(require("./CarouselThumbnails"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFMediaCarousel';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    rootSideThumbs: "".concat(PREFIX, "-rootSideThumbs"),
    mediaWrap: "".concat(PREFIX, "-mediaWrap"),
    thumbnail: "".concat(PREFIX, "-thumbnail"),
    thumbnailsLeft: "".concat(PREFIX, "-thumbnailsLeft"),
    thumbnailsTop: "".concat(PREFIX, "-thumbnailsTop"),
    lightboxCarousel: "".concat(PREFIX, "-lightboxCarousel"),
    lightboxThumbs: "".concat(PREFIX, "-lightboxThumbs")
};
var _obj;
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root component.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), _defineProperty({
        display: 'flex',
        flexDirection: 'column',
        flex: 1
    }, theme.breakpoints.up('sm'), {
        overflow: 'hidden'
    })), /**
   * Styles applied to the root component when `thumbnailPosition` is `left` or `right`.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.rootSideThumbs), _defineProperty({
    }, theme.breakpoints.up('sm'), {
        flexDirection: 'row'
    })), /**
   * Styles applied to the wrapper element of each media component.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.mediaWrap), {
        height: '100%',
        width: '100%',
        display: 'flex',
        justifyContent: 'center',
        alignItems: 'stretch',
        '& img': {
            maxHeight: '100%',
            maxWidth: '100%',
            objectFit: 'contain'
        }
    }), /**
   * Styles applied to each of the thumbnail elements.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.thumbnail), {
        position: 'absolute',
        top: 0,
        left: 0,
        height: '100%',
        width: '100%'
    }), /**
   * Styles applied to the thumbnail component when thumbnailPosition is `left`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.thumbnailsLeft), _defineProperty({
    }, theme.breakpoints.up('sm'), {
        order: -1
    })), /**
   * Styles applied to the thumbnail component when thumbnailPosition is `top`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.thumbnailsTop), {
        order: -1
    }), /**
   * Styles applied to the carousel component when the lightbox is shown.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.lightboxCarousel), {
        flex: 1,
        justifyContent: 'center',
        overflow: 'hidden'
    }), /**
   * Styles applied to the thumbnails in the lightbox.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.lightboxThumbs), {
        paddingBottom: theme.spacing(2)
    }), _obj;
});
var THUMBNAIL_IMAGE_ID = '__rsf-placeholder-thumbnail';
/**
 * A carousel that displays images and videos for a product.  Specify
 * images and videos via the media prop, which should be of the form:
 *
 * ```js
 *  <MediaCarousel
 *    media={[
 *      { src: 'https://domain.com/path/to/image.jpg', alt: 'Red Shirt', type: 'image' },
 *      { src: 'https://domain.com/path/to/image.mpeg', alt: 'Demonstration', type: 'video' },
 *    ]}
 *    thumbnail={{
 *      src: 'https://domain.com/path/to/thumbnail.jpg', alt: 'thumbnail'
 *    }}
 *  />
 * ```
 *
 * To display a low-res thumbnail while high res images are loading, specify a `thumbnail` prop with `src` and `alt`
 *
 * Alternatively, you can provide a `product` prop as an object with `media` and `thumbnail` values that
 * adhere to the formats described above.
 *
 * ```js
 *  <MediaCarousel
 *      media={[
 *        { src: 'https://domain.com/path/to/image.jpg', alt: 'Red Shirt', type: 'image' },
 *        { src: 'https://domain.com/path/to/image.mpeg', alt: 'Demonstration', type: 'video' },
 *      ],
 *      thumbnail: {
 *        src: 'https://domain.com/path/to/thumbnail.jpg', alt: 'thumbnail'
 *      }
 *    }]}
 *  />
 * ```
 */ var MediaCarousel = function MediaCarousel(props) {
    var thumbnails = props.thumbnails, thumbnail = props.thumbnail, thumbsClassName = props.thumbsClassName, thumbnailPosition = props.thumbnailPosition, magnifyHintClassName = props.magnifyHintClassName, videoProps = props.videoProps, imageProps = props.imageProps, lightboxProps = props.lightboxProps, lightboxClassName = props.lightboxClassName, tmp = props.classes, c = tmp === void 0 ? {
    } : tmp, media = props.media, magnifyProps = props.magnifyProps, id = props.id, CarouselComponent = props.CarouselComponent, ImageComponent = props.ImageComponent, MediaComponent = props.MediaComponent, CarouselThumbnailsComponent = props.CarouselThumbnailsComponent, others = _objectWithoutProperties(props, [
        "thumbnails",
        "thumbnail",
        "thumbsClassName",
        "thumbnailPosition",
        "magnifyHintClassName",
        "videoProps",
        "imageProps",
        "lightboxProps",
        "lightboxClassName",
        "classes",
        "media",
        "magnifyProps",
        "id",
        "CarouselComponent",
        "ImageComponent",
        "MediaComponent",
        "CarouselThumbnailsComponent"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = _slicedToArray((0, _react).useState(false), 2), imagesLoaded = ref[0], setImagesLoaded = ref[1];
    var ref1 = (0, _react).useRef(null);
    var ref2 = _slicedToArray((0, _react).useState(false), 2), over = ref2[0], setOver = ref2[1];
    var ref3 = _slicedToArray((0, _react).useState(0), 2), selected = ref3[0], setSelected = ref3[1];
    var ref4 = _slicedToArray((0, _react).useState(false), 2), video = ref4[0], setVideo = ref4[1];
    var ref5 = _slicedToArray((0, _react).useState(), 2), lightboxActive = ref5[0], setLightboxActive = ref5[1];
    var theme = (0, _styles).useTheme();
    var isSmall = (0, _useMediaQuery).default(theme.breakpoints.down('sm'));
    var isThumbsSide = [
        'right',
        'left'
    ].includes(thumbnailPosition);
    (0, _react).useEffect(function() {
        // Reset selection index when media changes
        setSelected(0);
    }, [
        media
    ]);
    (0, _react).useEffect(function() {
        if (media && media.full && media.full[selected] && media.full[selected].type === 'video') {
            setVideo(true);
        } else {
            setVideo(false);
        }
    }, [
        selected
    ]);
    var timeout = (0, _react).useRef(null);
    var handleMouseEnter = (0, _react).useCallback(function() {
        timeout.current = window.setTimeout(function() {
            setOver(true);
            timeout.current = null;
        }, 250);
    }, []);
    var handleMouseLeave = (0, _react).useCallback(function() {
        setOver(false);
        if (timeout.current) {
            window.clearTimeout(timeout.current);
        }
    }, []);
    var onFullSizeImagesLoaded = (0, _react).useCallback(function() {
        setImagesLoaded(true);
    }, []);
    var onClickCarousel = (0, _react).useCallback(function(evt) {
        if (!evt.defaultPrevented && !video) {
            setLightboxActive(true);
        }
    });
    (0, _react).useEffect(function() {
        if (!ref1.current || imagesLoaded || !thumbnail) return;
        var firstImage = ref1.current.querySelector('img');
        if (firstImage && firstImage.id !== THUMBNAIL_IMAGE_ID) {
            firstImage.addEventListener('load', onFullSizeImagesLoaded);
            return function() {
                return firstImage.removeEventListener('load', onFullSizeImagesLoaded);
            };
        }
    }, [
        media,
        imagesLoaded,
        thumbnail
    ]);
    var belowAdornments = [];
    if (thumbnail && !imagesLoaded) {
        belowAdornments.push(/*#__PURE__*/ _react.default.createElement(ImageComponent, _extends({
            id: THUMBNAIL_IMAGE_ID,
            key: "thumbnail",
            className: classes.thumbnail,
            fill: true
        }, thumbnail)));
    }
    if (media && media.full && media.full.some(function(item) {
        return item.magnify;
    })) {
        // we use the media's magnify.width prop to test if the image is larger than the screen size, and
        // hide the magnify hint if so. this is a magic large number just used to ensure that the hint is
        // shown if the width property is not defined for the given media
        var MAX_WIDTH = 10000;
        var showHint = true;
        if (lightboxActive) {
            var innerWidth = window.innerWidth;
            var mediaWidth = (0, _get).default(media.full[selected], 'magnify.width', MAX_WIDTH);
            if (mediaWidth <= innerWidth) {
                showHint = false;
            }
        }
        if (showHint && !video) {
            belowAdornments.push(/*#__PURE__*/ _react.default.createElement(_magnifyHint.default, {
                key: "magnify-hint",
                over: over,
                disableExpand: lightboxActive,
                className: magnifyHintClassName
            }));
        }
    }
    if (lightboxActive) {
        Object.assign(others, {
            autoplay: false,
            className: (0, _clsx).default(others.className, classes.lightboxCarousel, lightboxActive && lightboxClassName),
            height: isSmall ? '100%' : null,
            slideStyle: _objectSpread({
            }, others.slideStyle || {
            }, {
                display: 'flex',
                justifyContent: 'center'
            })
        });
    }
    var handleLightboxClose = (0, _react).useCallback(function() {
        setLightboxActive(false);
    }, []);
    var body = /*#__PURE__*/ _react.default.createElement(Root, {
        className: (0, _clsx).default(classes.root, _defineProperty({
        }, classes.rootSideThumbs, !lightboxActive && isThumbsSide))
    }, /*#__PURE__*/ _react.default.createElement(CarouselComponent, _extends({
        id: id,
        ref: ref1,
        belowAdornments: belowAdornments,
        classes: classes,
        onMouseEnter: handleMouseEnter,
        onMouseLeave: handleMouseLeave,
        onClick: onClickCarousel,
        selected: selected,
        setSelected: setSelected,
        height: "100%"
    }, others), (0, _get).default(media, 'full', []).map(function(item, i) {
        var magnifySrc = (0, _get).default(item, 'magnify.src', item.src);
        return(/*#__PURE__*/ _react.default.createElement(MediaComponent, _extends({
            key: i,
            magnifyProps: magnifyProps
        }, item, {
            src: lightboxActive ? magnifySrc : item.src,
            imageProps: lightboxActive ? {
                fill: false,
                contain: true,
                src: magnifySrc
            } : imageProps,
            videoProps: videoProps
        })));
    })), thumbnails && media && /*#__PURE__*/ _react.default.createElement(CarouselThumbnailsComponent, {
        className: (0, _clsx).default(thumbsClassName, lightboxActive && classes.lightboxThumbs, !lightboxActive && thumbnailPosition === 'left' && classes.thumbnailsLeft, !lightboxActive && thumbnailPosition === 'top' && classes.thumbnailsTop),
        bind: "".concat(id, ".index"),
        carouselId: id,
        selected: selected,
        setSelected: setSelected,
        thumbnails: media.thumbnails,
        thumbnailPosition: lightboxActive ? 'bottom' : thumbnailPosition
    }));
    return(/*#__PURE__*/ _react.default.createElement(Root, null, body, /*#__PURE__*/ _react.default.createElement(_lightbox.default, _extends({
    }, lightboxProps, {
        open: !!lightboxActive,
        onClose: handleLightboxClose
    }), body)));
};
MediaCarousel.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * If `true`, the carousel will have thumbnails below it.
   */ thumbnails: _propTypes.default.bool,
    /**
   * Data for an image to be used for a thumbnail when the images are not yet loaded.
   */ thumbnail: _propTypes.default.shape({
        src: _propTypes.default.string,
        alt: _propTypes.default.string
    }),
    /**
   * An optional `className` to use for the thumbnails component.
   */ thumbsClassName: _propTypes.default.string,
    /**
   * An optional `className` to use for the carousel component when the lightbox is open.
   */ lightboxClassName: _propTypes.default.string,
    /**
   * Position of thumbnails, relative to the main carousel image. For small screens, the position
   * will revert to `top` when this value is set to `left` or `right`.
   *
   * This property will have no effect in Amp.
   */ thumbnailPosition: _propTypes.default.oneOf([
        'bottom',
        'top',
        'left',
        'right'
    ]),
    /**
   * A component type to use for the thumbnails.
   */ CarouselThumbnailsComponent: _propTypes.default.elementType,
    /**
   * An optional `className` to use for the [`MagnifyHint`](/apiReference/carousel/MagnifyHint) component.
   */ magnifyHintClassName: _propTypes.default.string,
    /**
   * Props passed through to each [`Media`](/apiReference/carousel/Media)'s video component.
   */ videoProps: _propTypes.default.object,
    /**
   * Props passed through to each [`Media`](/apiReference/carousel/Media)'s
   * [`imageProps`](/apiReference/carousel/Media#prop-imageProps).
   */ imageProps: _propTypes.default.object,
    /**
   * Data for all the media objects to show in the carousel.
   */ media: _propTypes.default.shape({
        full: _propTypes.default.arrayOf(_propTypes.default.object),
        thumbnails: _propTypes.default.arrayOf(_propTypes.default.object)
    }),
    /**
   * Props passed through to each [`Media`](/apiReference/carousel/Media)'s
   * [`magnifyProps`](/apiReference/carousel/Media#prop-magnifyProps).
   */ magnifyProps: _propTypes.default.object,
    /**
   * A component type to use for each media object in the carousel.
   */ MediaComponent: _propTypes.default.elementType,
    /**
   * Props passed through to the [`Lightbox`](/apiReference/carousel/Lightbox).
   */ lightboxProps: _propTypes.default.object,
    /**
   * An `id` attribute to use for the carousel's root element.
   */ id: _propTypes.default.string,
    /**
   * A component type to use for the main carousel component.
   */ CarouselComponent: _propTypes.default.elementType,
    /**
   * The component type to use to display images.
   */ ImageComponent: _propTypes.default.elementType
};
MediaCarousel.defaultProps = {
    lightboxProps: {
    },
    magnifyProps: {
    },
    thumbnails: true,
    thumbnailPosition: 'bottom',
    MediaComponent: _media.default,
    ImageComponent: _image.default,
    CarouselComponent: _carousel.default,
    CarouselThumbnailsComponent: _carouselThumbnails.default,
    videoProps: {
        controls: true,
        autoPlay: false
    }
};
var _default = MediaCarousel;
exports.default = _default;

//# sourceMappingURL=MediaCarousel.js.map