"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Drawer;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _resizeObserverPolyfill = _interopRequireDefault(require("resize-observer-polyfill"));
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _drawerCloseButton = _interopRequireDefault(require("./DrawerCloseButton"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFDrawer';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    closeButton: "".concat(PREFIX, "-closeButton"),
    paper: "".concat(PREFIX, "-paper"),
    fullscreen: "".concat(PREFIX, "-fullscreen"),
    container: "".concat(PREFIX, "-container"),
    header: "".concat(PREFIX, "-header"),
    content: "".concat(PREFIX, "-content"),
    title: "".concat(PREFIX, "-title")
};
var _obj;
var StyledMUIDrawer = (0, _styles).styled(_material.Drawer)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
    }), /**
   * Styles applied to the close button element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.closeButton), {
    }), /**
   * Styles applied to the drawer's `Paper` component.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.paper), {
        overflowY: 'visible'
    }), /**
   * Styles applied to the drawer's `Paper` component if [`fullscreen`](#prop-fullscreen) is `true`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.fullscreen), {
        height: '100vh'
    }), /**
   * Styles applied to the drawer's wrapper element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.container), {
        height: '100%',
        boxSizing: 'border-box',
        flexWrap: 'nowrap',
        display: 'flex',
        flexDirection: 'column'
    }), /**
   * Styles applied to the drawer's header element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.header), {
        position: 'relative'
    }), /**
   * Styles applied to the wrapper around the drawer's children.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.content), {
        flexBasis: '100%',
        overflow: 'auto'
    }), /**
   * Styles applied to the drawer's title element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.title), {
        flexBasis: 'auto',
        flexGrow: 0,
        flexShrink: 1,
        width: '100%',
        height: '72px',
        lineHeight: '72px',
        textAlign: 'center',
        borderBottom: "1px solid ".concat(theme.palette.divider)
    }), _obj;
});
var _obj1;
function Drawer(_param) {
    var variant = _param.variant, showCloseButton = _param.showCloseButton, open = _param.open, _onClose = _param.onClose, onClose = _onClose === void 0 ? function() {
    } : _onClose, title = _param.title, children = _param.children, className = _param.className, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, autoAdjustBodyPadding = _param.autoAdjustBodyPadding, anchor = _param.anchor, fullscreen = _param.fullscreen, rest = _objectWithoutProperties(_param, [
        "variant",
        "showCloseButton",
        "open",
        "onClose",
        "title",
        "children",
        "className",
        "classes",
        "autoAdjustBodyPadding",
        "anchor",
        "fullscreen"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var theme = (0, _styles).useTheme();
    var drawer = (0, _react).useRef(null);
    var drawerResize = (0, _react).useRef(null);
    var setPadding = (0, _react).useCallback(function() {
        if (autoAdjustBodyPadding) {
            requestAnimationFrame(function() {
                var el = drawer.current;
                document.body.style.paddingBottom = el && "".concat(el.clientHeight, "px");
            });
        }
    }, [
        autoAdjustBodyPadding
    ]);
    var closeDrawer = (0, _react).useCallback(function() {
        if (onClose) {
            onClose();
        }
        document.body.style.paddingBottom = 0;
    }, [
        onClose
    ]);
    (0, _react).useEffect(function() {
        var el = drawer.current;
        setPadding();
        if (autoAdjustBodyPadding && el) {
            drawerResize.current = new _resizeObserverPolyfill.default(function() {
                document.body.style.paddingBottom = el && "".concat(el.clientHeight, "px");
            });
            drawerResize.current.observe(el);
        }
        return function() {
            if (drawerResize.current && el) {
                drawerResize.current.unobserve(el);
            }
        };
    }, []);
    return(/*#__PURE__*/ _react.default.createElement(StyledMUIDrawer, _extends({
        elevation: 2,
        anchor: anchor,
        style: {
            zIndex: theme.zIndex.modal + 20
        },
        classes: {
            root: (0, _clsx).default(_defineProperty({
                className: className
            }, classes.root, true)),
            paper: (0, _clsx).default((_obj1 = {
            }, _defineProperty(_obj1, classes.paper, true), _defineProperty(_obj1, classes.fullscreen, fullscreen), _obj1))
        },
        open: open,
        variant: variant,
        onClose: onClose
    }, rest), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.container,
        ref: drawer
    }, /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.header
    }, title && /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        className: classes.title,
        variant: "h6",
        component: "div"
    }, title), showCloseButton && /*#__PURE__*/ _react.default.createElement(_drawerCloseButton.default, {
        onClick: closeDrawer,
        fullscreen: fullscreen,
        open: open,
        className: (0, _clsx).default(classes.closeButton)
    })), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.content
    }, children))));
}
Drawer.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * CSS class to apply to the root element.
   */ className: _propTypes.default.string,
    /**
   * Child nodes to show inside the Drawer.
   */ children: _propTypes.default.node.isRequired,
    /**
   * If `false`, the close button will be hidden.
   */ showCloseButton: _propTypes.default.bool,
    /**
   * If `true`, the drawer will cover the whole screen.
   */ fullscreen: _propTypes.default.bool,
    /**
   * A function that is called when the user closes the drawer.
   */ onClose: _propTypes.default.func.isRequired,
    /**
   * The title to display at the top of the drawer.
   */ title: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ]),
    /**
   * If `true`, padding will be automatically added to the body when the drawer
   * is open so that the user is able to scroll and see all of the body content.
   */ autoAdjustBodyPadding: _propTypes.default.bool,
    /**
   * Side from which the drawer will appear (top, left, right, bottom).
   */ anchor: _propTypes.default.oneOf([
        'top',
        'bottom',
        'left',
        'right'
    ]),
    /**
   * The variant to use for the MaterialUI [`Drawer`)(https://mui.com/api/drawer/#props).
   */ variant: _propTypes.default.oneOf([
        'permanent',
        'persistent',
        'temporary'
    ]),
    open: _propTypes.default.bool
};
Drawer.defaultProps = {
    showCloseButton: true,
    autoAdjustBodyPadding: false,
    variant: 'temporary',
    anchor: 'bottom'
};

//# sourceMappingURL=Drawer.js.map