"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = DrawerCloseButton;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _iconsMaterial = require("@mui/icons-material");
var _material = require("@mui/material");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFDrawerCloseButton';
var defaultClasses = {
    button: "".concat(PREFIX, "-button"),
    buttonText: "".concat(PREFIX, "-buttonText"),
    buttonFab: "".concat(PREFIX, "-buttonFab"),
    hidden: "".concat(PREFIX, "-hidden")
};
var _obj, _obj1;
function DrawerCloseButton(_param) {
    var tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, className = _param.className, ampState = _param.ampState, onClick = _param.onClick, text = _param.text, Icon = _param.Icon, fullscreen = _param.fullscreen, open = _param.open, others = _objectWithoutProperties(_param, [
        "classes",
        "className",
        "ampState",
        "onClick",
        "text",
        "Icon",
        "fullscreen",
        "open"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ButtonElement;
    if (text) {
        ButtonElement = _material.Button;
    } else if (fullscreen) {
        ButtonElement = _material.IconButton;
    } else {
        ButtonElement = function ButtonElement(props) {
            return(/*#__PURE__*/ _react.default.createElement(_material.Fab, _extends({
                color: "primary"
            }, props, {
                className: (0, _clsx).default(props.className, !open && classes.hidden)
            }), /*#__PURE__*/ _react.default.createElement(Icon, null)));
        };
    }
    var StyledButtonElement = (0, _styles).styled(ButtonElement)(function() {
        return _obj = {
        }, /**
     * Styles applied to the root element.
     */ _defineProperty(_obj, "&.".concat(classes.button), {
            color: '#999',
            alignSelf: 'flex-end',
            position: 'absolute',
            top: 0,
            right: 0,
            zIndex: 1,
            '& span': {
                textTransform: 'uppercase',
                fontWeight: 'bold'
            }
        }), /**
     * Styles applied to the root element, if [`text`](#prop-text) is defined.
     */ _defineProperty(_obj, "&.".concat(classes.buttonText), {
            border: '1px solid #999',
            margin: '0 0 10px 0'
        }), /**
     * Styles applied to the root element, if [`text`](#prop-text) is not defined and
     * [`fullscreen`](#prop-fullscreen) is `false`.
     */ _defineProperty(_obj, "&.".concat(classes.buttonFab), {
            position: 'absolute',
            right: '10px',
            top: '-28px',
            zIndex: 1,
            color: 'white'
        }), /**
     * Styles applied to hide the `Fab` button when [`open`](#prop-open) is `false`.
     */ _defineProperty(_obj, "& .".concat(classes.hidden), {
            display: 'none'
        }), _obj;
    });
    return(/*#__PURE__*/ _react.default.createElement(StyledButtonElement, _extends({
        color: "primary",
        on: "tap:AMP.setState({ ".concat(ampState, ": { open: false } })"),
        className: (0, _clsx).default(className, (_obj1 = {
        }, _defineProperty(_obj1, classes.button, true), _defineProperty(_obj1, classes.buttonText, text != null), _defineProperty(_obj1, classes.buttonFab, text == null && !fullscreen), _obj1)),
        onClick: onClick
    }, others), text || /*#__PURE__*/ _react.default.createElement(Icon, null)));
}
DrawerCloseButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * CSS class to apply to the root element.
   */ className: _propTypes.default.string,
    /**
   * The name of the amp state corresponding to the drawer.
   */ ampState: _propTypes.default.string,
    /**
   * Fired when the button is clicked.  Call `e.preventDefault()` on the
   * provided event to prevent the drawer from closing.
   */ onClick: _propTypes.default.func,
    /**
   * When set, this text will be displayed instead of an icon.
   */ text: _propTypes.default.string,
    /**
   * Overrides the default icon.
   */ Icon: _propTypes.default.elementType,
    /**
   * If `true`, the drawer is open
   */ open: _propTypes.default.bool,
    /**
   * If `true`, the drawer is fullscreen and the close button will therefore be a `Fab` button.
   */ fullscreen: _propTypes.default.bool
};
DrawerCloseButton.defaultProps = {
    Icon: _iconsMaterial.Clear,
    open: false
};

//# sourceMappingURL=DrawerCloseButton.js.map