"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _addVersion = _interopRequireDefault(require("./api/addVersion"));
var _isSameOrigin = _interopRequireDefault(require("./utils/isSameOrigin"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
/**
 * Returns the parsed URL for the specified request
 * @param {Request|String} request A request instance or a URL string
 * @return {URL}
 */ function getURL(request) {
    var url = request.url;
    if (typeof request === 'string') {
        url = request;
    }
    return new URL(url, window.location.href);
}
// Here we patch fetch and XMLHttpRequest to always add version parameter to api calls so that cached results
// from previous versions of the app aren't served to new versions.
/* istanbul ignore else */ if (typeof window !== 'undefined') {
    var originalFetch = window.fetch;
    window.fetch = function rsfVersionedFetch(url, init) {
        var parsed = getURL(url);
        if (!(0, _isSameOrigin).default(parsed)) {
            return originalFetch(url, init);
        }
        if (typeof url === 'string') {
            url = (0, _addVersion).default(parsed).toString();
        } else {
            // the first param can be a request object
            url = new Request((0, _addVersion).default(parsed).toString(), url);
        }
        return originalFetch(url, init);
    };
}
/* istanbul ignore else */ if (typeof XMLHttpRequest !== 'undefined') {
    var originalOpen = XMLHttpRequest.prototype.open;
    XMLHttpRequest.prototype.open = function rsfVersionedOpen(method, url) {
        for(var _len = arguments.length, others = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++){
            others[_key - 2] = arguments[_key];
        }
        var _originalOpen;
        var parsed = getURL(url);
        if ((0, _isSameOrigin).default(parsed)) {
            var _originalOpen1;
            return (_originalOpen1 = originalOpen).call.apply(_originalOpen1, [
                this,
                method,
                (0, _addVersion).default(parsed).toString()
            ].concat(_toConsumableArray(others)));
        }
        return (_originalOpen = originalOpen).call.apply(_originalOpen, [
            this,
            method,
            url
        ].concat(_toConsumableArray(others)));
    };
}
var _default = require('isomorphic-unfetch');
exports.default = _default;

//# sourceMappingURL=fetch.js.map