"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = require("react");
var _get = _interopRequireDefault(require("lodash/get"));
var _sessionContext = _interopRequireDefault(require("../session/SessionContext"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function useCartTotal() {
    var context = (0, _react).useContext(_sessionContext.default);
    var items = (0, _get).default(context, 'session.cart.items', []);
    var total = (0, _react).useMemo(function() {
        return items.reduce(function(totalAcc, item) {
            return item.quantity + totalAcc;
        }, 0);
    }, [
        items, 
    ]);
    return total;
}
var _default = useCartTotal;
exports.default = _default;

//# sourceMappingURL=useCartTotal.js.map