"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = useStateFromProp;
var _react = require("react");
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
function useStateFromProp(prop) {
    var state = (0, _react).useState(prop);
    var _state = _slicedToArray(state, 2), setValue = _state[1];
    var mounted = (0, _react).useRef(false);
    (0, _react).useEffect(function() {
        if (mounted.current) {
            setValue(prop);
        }
        mounted.current = true;
    }, [
        prop
    ]);
    return state;
}

//# sourceMappingURL=useStateFromProp.js.map