"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = useTraceUpdate;
var _react = require("react");
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
function useTraceUpdate(props) {
    var prev = (0, _react).useRef(null);
    (0, _react).useEffect(function() {
        if (prev.current != null) {
            // don't output during initial render
            var changedProps = Object.entries(props).reduce(function(ps, param) {
                var _param = _slicedToArray(param, 2), k = _param[0], v = _param[1];
                if (prev.current[k] !== v) {
                    ps[k] = [
                        prev.current[k],
                        v
                    ];
                }
                return ps;
            }, {
            });
            if (Object.keys(changedProps).length > 0) {
                console.log('Changed props:', changedProps);
            } else {
                console.log('nothing changed');
            }
        }
        prev.current = props;
    });
}
if (process.env.NODE_ENV !== 'production') {
    global.useTraceUpdate = useTraceUpdate;
}

//# sourceMappingURL=useTraceUpdate.js.map