"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = LinkContextProvider;
var _react = _interopRequireWildcard(require("react"));
var _router = _interopRequireDefault(require("next/router"));
var _linkContext = _interopRequireDefault(require("./LinkContext"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function LinkContextProvider(param) {
    var children = param.children;
    var linkPageData = (0, _react).useRef(null);
    (0, _react).useEffect(function() {
        var onRouteChangeComplete = function() {
            return linkPageData.current = undefined;
        };
        _router.default.events.on('routeChangeComplete', onRouteChangeComplete);
        return function() {
            _router.default.events.off('routeChangeComplete', onRouteChangeComplete);
        };
    }, []);
    return(/*#__PURE__*/ _react.default.createElement(_linkContext.default.Provider, {
        value: linkPageData
    }, children));
}

//# sourceMappingURL=LinkContextProvider.js.map