"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _clsx = _interopRequireDefault(require("clsx"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _menuContext = _interopRequireDefault(require("./MenuContext"));
var _seolinks = _interopRequireDefault(require("./SEOLinks"));
var _menuBody = _interopRequireDefault(require("./MenuBody"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
var PREFIX = 'RSFMenu';
var defaultClasses = {
    drawer: "".concat(PREFIX, "-drawer"),
    list: "".concat(PREFIX, "-list"),
    listPadding: "".concat(PREFIX, "-listPadding"),
    header: "".concat(PREFIX, "-header"),
    icon: "".concat(PREFIX, "-icon"),
    headerText: "".concat(PREFIX, "-headerText"),
    bodyWrap: "".concat(PREFIX, "-bodyWrap"),
    hidden: "".concat(PREFIX, "-hidden"),
    visible: "".concat(PREFIX, "-visible"),
    link: "".concat(PREFIX, "-link"),
    leaf: "".concat(PREFIX, "-leaf"),
    drawerFixed: "".concat(PREFIX, "-drawerFixed")
};
var Menu = /*#__PURE__*/ _react.default.memo(function(props) {
    var tmp = props.classes, c = tmp === void 0 ? {
    } : tmp, className = props.className, anchor = props.anchor, drawerWidth = props.drawerWidth, persistent = props.persistent, root = props.root, open = props.open, onClose = props.onClose, renderFooter = props.renderFooter, renderHeader = props.renderHeader, renderBack = props.renderBack, renderItem = props.renderItem, renderItemContent = props.renderItemContent, renderDrawer = props.renderDrawer, others = _objectWithoutProperties(props, [
        "classes",
        "className",
        "anchor",
        "drawerWidth",
        "persistent",
        "root",
        "open",
        "onClose",
        "renderFooter",
        "renderHeader",
        "renderBack",
        "renderItem",
        "renderItemContent",
        "renderDrawer"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = _slicedToArray((0, _react).useState(function() {
        return {
            card: 0,
            cards: [
                _objectSpread({
                }, root, {
                    root: true
                })
            ]
        };
    }), 2), state = ref[0], setState = ref[1];
    // this is needed so we can always update the *current* state, not the snapshot that
    // was present when the callbacks were memoized
    var stateRef = (0, _react).useRef(state);
    (0, _react).useEffect(function() {
        stateRef.current = state;
    }, [
        state
    ]);
    (0, _react).useEffect(function() {
        setState({
            card: 0,
            cards: [
                _objectSpread({
                }, root, {
                    root: true
                })
            ]
        });
    }, [
        root
    ]);
    // this ensures that the expanded state is reset when showing a new card
    var nextKey = (0, _react).useRef(0);
    var onItemClick = function(item, depth) {
        var cards = _toConsumableArray(stateRef.current.cards);
        var card = depth + 1;
        item.key = nextKey.current++ // this ensures that the expanded state is reset when showing a new card
        ;
        if (card >= cards.length) {
            cards.push(item);
        } else {
            cards[card] = item;
        }
        setState({
            card: card,
            cards: cards.slice(0, card + 1)
        });
    };
    var goBack = function(card) {
        setState({
            card: card,
            cards: stateRef.current.cards
        });
    };
    // it is important to memoize the context, otherwise it will cause all consumers to rerender
    // every time Menu rerenders
    var context = (0, _react).useMemo(function() {
        return {
            classes: classes,
            onItemClick: onItemClick,
            goBack: goBack,
            renderFooter: renderFooter,
            renderHeader: renderHeader,
            renderBack: renderBack,
            renderItem: renderItem,
            renderItemContent: renderItemContent,
            close: onClose,
            drawerWidth: drawerWidth
        };
    }, [
        classes
    ]);
    return(/*#__PURE__*/ _react.default.createElement(_menuContext.default.Provider, {
        value: context
    }, renderDrawer ? renderDrawer() : /*#__PURE__*/ _react.default.createElement(_material.Drawer, {
        variant: persistent ? 'persistent' : 'temporary',
        open: open || persistent,
        onClose: onClose,
        anchor: anchor,
        ModalProps: {
            keepMounted: true
        },
        PaperProps: {
            style: {
                width: "".concat(drawerWidth, "px")
            }
        },
        classes: {
            root: className,
            paper: (0, _clsx).default(classes.drawer, _defineProperty({
            }, classes.drawerFixed, persistent)),
            modal: classes.modal
        }
    }, /*#__PURE__*/ _react.default.createElement(_menuBody.default, _extends({
        card: state.card,
        cards: state.cards,
        root: root,
        drawerWidth: drawerWidth
    }, others))), /*#__PURE__*/ _react.default.createElement(_seolinks.default, {
        root: root
    })));
});
Menu.propTypes = {
    root: _propTypes.default.object,
    /**
   * The width of the drawer in pixels
   */ drawerWidth: _propTypes.default.number,
    /**
   * An element to display at the top of the root of the menu
   */ rootHeader: _propTypes.default.element,
    /**
   * An element to display at the bottom of the root of the menu
   */ rootFooter: _propTypes.default.element,
    /**
   * A function to render a custom header in menu cards.  It is passed an object
   * with:
   *
   * - item: The menu item record being rendered
   *
   * The function should return a React element or fragment.
   */ renderHeader: _propTypes.default.func,
    /**
   * A function to render a custom footer menu cards.  It is passed an object
   * with:
   *
   * - item: The menu item record being rendered
   *
   * The function should return a React element or fragment.
   */ renderFooter: _propTypes.default.func,
    /**
   * A function to render a custom back navigation for menu cards.  It is passed
   * an object with:
   *
   * - item: The menu item record being rendered
   *
   * The function should return a React element or fragment.
   */ renderBack: _propTypes.default.func,
    /**
   * Set to true to display the menu
   */ open: _propTypes.default.bool,
    /**
   * Set to true to dock the menu so that it's always open and not modal
   */ persistent: _propTypes.default.bool,
    /**
   * CSS classes for this component
   */ classes: _propTypes.default.objectOf(_propTypes.default.string),
    /**
   * Called when the menu is closed
   */ onClose: _propTypes.default.func,
    /**
   * The icon to use for collapsed groups
   */ ExpandIcon: _propTypes.default.elementType,
    /**
   * The icon to use for expanded groups
   */ CollapseIcon: _propTypes.default.elementType,
    /**
   * Sets the side of the screen from which the menu appears.
   */ anchor: _propTypes.default.oneOf([
        'left',
        'right'
    ]),
    /**
   * Overrides the default rendering of a menu item.  It is passed the following arguments:
   *
   * - item - the menu item record being rendered.
   *
   * Return undefined to render the default contents
   *
   * Example:
   *
   * ```js
   *  renderItem={item => {
   *    return item.text === 'My Special Item ? <MySpecialItem/> : null
   *  }}
   * ```
   */ renderItem: _propTypes.default.func,
    /**
   * Overrides the content of a menu item.  It is passed the following arguments:
   *
   * - item - the menu item record being rendered.
   *
   * Return null to render the default contents
   *
   * Example:
   *
   * ```js
   *  renderItemContent={item => {
   *    return leaf ? <ListItemText primary={item.text}/> : null
   *  }}
   * ```
   */ renderItemContent: _propTypes.default.func,
    /**
   * Set to `true` to show the item corresponding to the current URL as selected.
   */ trackSelected: _propTypes.default.bool,
    /**
   * A function to override the rendering the drawer
   */ renderDrawer: _propTypes.default.func,
    className: _propTypes.default.string
};
Menu.defaultProps = {
    drawerWidth: 330,
    anchor: 'left',
    trackSelected: false,
    DrawerComponent: _material.Drawer
};
var _default = Menu;
exports.default = _default;

//# sourceMappingURL=Menu.js.map