"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = MenuBack;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
var _iconsMaterial = require("@mui/icons-material");
var _menuContext = _interopRequireDefault(require("./MenuContext"));
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function MenuBack(param) {
    var goBack = param.goBack, item = param.item, backButtonProps = param.backButtonProps;
    var ref = (0, _react).useContext(_menuContext.default), classes = ref.classes, renderBack = ref.renderBack;
    return(/*#__PURE__*/ _react.default.createElement(_material.ListItem, _extends({
        divider: true,
        button: true,
        onClick: goBack
    }, backButtonProps), /*#__PURE__*/ _react.default.createElement(_material.ListItemIcon, {
        classes: {
            root: classes.header
        }
    }, /*#__PURE__*/ _react.default.createElement(_iconsMaterial.ChevronLeft, {
        className: classes.icon
    })), /*#__PURE__*/ _react.default.createElement(_material.ListItemText, {
        classes: {
            root: classes.headerText
        },
        primary: /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.headerText
        }, typeof renderBack === 'function' ? renderBack(item) : item.text)
    })));
}
MenuBack.propTypes = {
    /**
   * Goes back to the previous item in the menu hierarchy
   */ goBack: _propTypes.default.func,
    /**
   * The menu item being rendered
   */ item: _propTypes.default.shape({
        text: _propTypes.default.string
    }).isRequired,
    backButtonProps: _propTypes.default.object
};

//# sourceMappingURL=MenuBack.js.map