"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _menuContext = _interopRequireDefault(require("./MenuContext"));
var _menuCard = _interopRequireDefault(require("./MenuCard"));
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
var MenuBody = /*#__PURE__*/ _react.default.memo(function(param) {
    var CardComponent = param.CardComponent, wrapProps = param.wrapProps, card = param.card, cards = param.cards, rootHeader = param.rootHeader, rootFooter = param.rootFooter, children = param.children;
    var ref = (0, _react).useContext(_menuContext.default), classes = ref.classes, drawerWidth = ref.drawerWidth;
    var position = -drawerWidth * card;
    return(/*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, children, /*#__PURE__*/ _react.default.createElement("div", _extends({
        className: classes.bodyWrap,
        style: {
            transform: "translateX(".concat(position, "px)")
        }
    }, wrapProps), cards.map(function(item, depth) {
        /*#__PURE__*/ return _react.default.createElement(CardComponent, {
            card: card,
            key: depth,
            item: item,
            depth: depth,
            rootHeader: rootHeader,
            rootFooter: rootFooter
        });
    }))));
});
MenuBody.propTypes = {
    /**
   * Additional props for the wrap element
   */ wrapProps: _propTypes.default.object,
    /**
   * Overrides the default component used to display menu cards
   */ CardComponent: _propTypes.default.elementType.isRequired,
    card: _propTypes.default.number,
    cards: _propTypes.default.array,
    rootHeader: _propTypes.default.any,
    rootFooter: _propTypes.default.any
};
MenuBody.defaultProps = {
    wrapProps: {
    },
    CardComponent: _menuCard.default
};
var _default = MenuBody;
exports.default = _default;

//# sourceMappingURL=MenuBody.js.map