"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _menuItemContent = _interopRequireDefault(require("./MenuItemContent"));
var _expandableSection = _interopRequireDefault(require("../ExpandableSection"));
var _menuLeaf = _interopRequireDefault(require("./MenuLeaf"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
var PREFIX = 'RSFMenuBranch';
var classes = {
    expander: "".concat(PREFIX, "-expander"),
    expanderMargins: "".concat(PREFIX, "-expanderMargins"),
    expanderSummary: "".concat(PREFIX, "-expanderSummary"),
    expanderSummaryExpanded: "".concat(PREFIX, "-expanderSummaryExpanded"),
    expanderIconExpanded: "".concat(PREFIX, "-expanderIconExpanded"),
    expanderDetails: "".concat(PREFIX, "-expanderDetails"),
    expanderContent: "".concat(PREFIX, "-expanderContent")
};
var _obj;
var StyledMenuItemContent = (0, _styles).styled(_menuItemContent.default)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, _defineProperty(_obj, "& .".concat(classes.expander), {
        borderBottom: 'none'
    }), _defineProperty(_obj, "& .".concat(classes.expanderMargins), {
        padding: 0
    }), _defineProperty(_obj, "& .".concat(classes.expanderSummary), {
        textTransform: 'uppercase',
        '&:first-child': {
            padding: "10px ".concat(theme.spacing(2)),
            borderBottom: "1px solid ".concat(theme.palette.divider)
        }
    }), _defineProperty(_obj, "& .".concat(classes.expanderSummaryExpanded), {
        backgroundColor: theme.palette.secondary.main,
        color: theme.palette.secondary.contrastText
    }), _defineProperty(_obj, "& .".concat(classes.expanderIconExpanded), {
        color: theme.palette.secondary.contrastText
    }), _defineProperty(_obj, "& .".concat(classes.expanderDetails), {
        '$expander &': {
            paddingBottom: 0
        }
    }), _defineProperty(_obj, "& .".concat(classes.expanderContent), {
        textTransform: 'none'
    }), _obj;
});
var MenuBranch = /*#__PURE__*/ _react.default.memo(function(props) {
    var depth = props.depth, item = props.item, ExpanderComponent = props.ExpanderComponent, itemProps = props.itemProps;
    var isLeaf = !item.items.some(function(child) {
        return child.items && child.items.length > 0;
    });
    if (item.expanded != null && item.items && item.items.length && isLeaf) {
        return(/*#__PURE__*/ _react.default.createElement(ExpanderComponent, {
            title: item.text,
            defaultExpanded: item.expanded,
            classes: {
                root: classes.expander,
                margins: classes.expanderMargins,
                summary: classes.expanderSummary,
                summaryExpanded: classes.expanderSummaryExpanded,
                expandIconExpanded: classes.expanderIconExpanded,
                details: classes.expanderDetails
            }
        }, item.items.map(function(child, i) {
            /*#__PURE__*/ return _react.default.createElement(_menuLeaf.default, {
                key: i,
                item: child,
                depth: depth,
                classes: {
                    listItem: classes.expanderContent
                }
            });
        })));
    }
    return(/*#__PURE__*/ _react.default.createElement(StyledMenuItemContent, {
        item: item,
        depth: depth,
        leaf: false,
        listItemProps: itemProps
    }));
});
var _default = MenuBranch;
exports.default = _default;
MenuBranch.propTypes = {
    /**
   * Overrides the default component for expandable items
   */ ExpanderComponent: _propTypes.default.elementType.isRequired,
    /**
   * Additional props for the underlying ListItem
   */ itemProps: _propTypes.default.object,
    depth: _propTypes.default.number,
    item: _propTypes.default.object
};
MenuBranch.defaultProps = {
    ExpanderComponent: _expandableSection.default
};

//# sourceMappingURL=MenuBranch.js.map