"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = MenuButton;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _toolbarButton = _interopRequireDefault(require("../ToolbarButton"));
var _menuIcon = _interopRequireDefault(require("./MenuIcon"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
var PREFIX = 'RSFMenuButton';
var classes = {
    link: "".concat(PREFIX, "-link")
};
var StyledHidden = (0, _styles).styled(_material.Hidden)(function() {
    return _defineProperty({
    }, "& .".concat(classes.link), {
        textDecoration: 'none'
    });
});
function MenuButton(param) {
    var MenuIcon = param.MenuIcon, menuIconProps = param.menuIconProps, open = param.open, onClick = param.onClick, className = param.className, style = param.style;
    return(/*#__PURE__*/ _react.default.createElement(StyledHidden, {
        mdUp: true,
        implementation: "css",
        key: "menuButton"
    }, /*#__PURE__*/ _react.default.createElement("a", {
        on: "tap:AMP.setState({ rsfMenuState: { open: !rsfMenuState.open, list: '@' } }), rsfMenu.toggle",
        className: (0, _clsx).default(classes.link, className),
        style: style
    }, /*#__PURE__*/ _react.default.createElement(_toolbarButton.default, {
        "aria-label": "Menu",
        color: "inherit",
        onClick: onClick,
        icon: /*#__PURE__*/ _react.default.createElement(MenuIcon, _extends({
            open: open
        }, menuIconProps))
    }))));
}
MenuButton.propTypes = {
    /**
   * A react component to use for the menu icon
   */ MenuIcon: _propTypes.default.elementType,
    /**
   * Props for the menu icon
   */ menuIconProps: _propTypes.default.object,
    open: _propTypes.default.bool,
    onClick: _propTypes.default.func,
    className: _propTypes.default.string,
    style: _propTypes.default.object
};
MenuButton.defaultProps = {
    MenuIcon: _menuIcon.default,
    menuIconProps: {
    }
};

//# sourceMappingURL=MenuButton.js.map