"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = MenuCard;
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _menuItem = _interopRequireDefault(require("./MenuItem"));
var _menuBack = _interopRequireDefault(require("./MenuBack"));
var _menuHeader = _interopRequireDefault(require("./MenuHeader"));
var _menuFooter = _interopRequireDefault(require("./MenuFooter"));
var _menuContext = _interopRequireDefault(require("./MenuContext"));
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function MenuCard(param) {
    var item = param.item, depth = param.depth, headerProps = param.headerProps;
    var ref = (0, _react).useContext(_menuContext.default), goBack = ref.goBack, classes = ref.classes, expandFirstItem = ref.expandFirstItem, drawerWidth = ref.drawerWidth;
    return(/*#__PURE__*/ _react.default.createElement(_material.List, {
        style: {
            width: "".concat(drawerWidth, "px")
        },
        classes: {
            root: classes.list,
            padding: classes.padding
        },
        key: depth
    }, !item.root && /*#__PURE__*/ _react.default.createElement(_menuBack.default, _extends({
        classes: classes,
        goBack: function() {
            return goBack(depth - 1);
        },
        item: item,
        card: depth
    }, headerProps)), /*#__PURE__*/ _react.default.createElement(_menuHeader.default, {
        item: item
    }), item.items && item.items.map(function(child, i) {
        /*#__PURE__*/ return _react.default.createElement(_menuItem.default, {
            item: child,
            key: "".concat(item.key, "-").concat(i),
            depth: depth,
            defaultExpanded: i === 0 && expandFirstItem
        });
    }), /*#__PURE__*/ _react.default.createElement(_menuFooter.default, {
        item: item
    })));
}
MenuCard.propTypes = {
    /**
   * Addition props for the header element
   */ headerProps: _propTypes.default.object,
    item: _propTypes.default.object,
    depth: _propTypes.default.number
};
MenuCard.defaultProps = {
};

//# sourceMappingURL=MenuCard.js.map