"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _iconsMaterial = require("@mui/icons-material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _amp = require("next/amp");
var _clsx = _interopRequireDefault(require("clsx"));
var _menuContext = _interopRequireDefault(require("./MenuContext"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function ExpanderIcon(param) {
    var ExpandIcon = param.ExpandIcon, CollapseIcon = param.CollapseIcon, showExpander = param.showExpander, sublist = param.sublist, expanded = param.expanded;
    var classes = (0, _react).useContext(_menuContext.default).classes;
    var amp = (0, _amp).useAmp();
    ExpandIcon = ExpandIcon || _iconsMaterial.ExpandMore;
    CollapseIcon = CollapseIcon || _iconsMaterial.ExpandLess;
    if (!showExpander) return(/*#__PURE__*/ _react.default.createElement(_iconsMaterial.ChevronRight, {
        className: classes.icon
    }));
    if (amp) {
        return(/*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/ _react.default.createElement(CollapseIcon, {
            className: (0, _clsx).default(classes.icon, classes.hidden),
            "amp-bind": "class=>rsfMenuState.sublist == '".concat(sublist, "' ? '").concat(classes.visible, " ").concat(classes.icon, "' : '").concat(classes.hidden, " ").concat(classes.icon, "'")
        }), /*#__PURE__*/ _react.default.createElement(ExpandIcon, {
            className: (0, _clsx).default(classes.icon, classes.visible),
            "amp-bind": "class=>rsfMenuState.sublist == '".concat(sublist, "' ? '").concat(classes.hidden, " ").concat(classes.icon, "' : '").concat(classes.visible, " ").concat(classes.icon, "'")
        })));
    }
    return expanded ? /*#__PURE__*/ _react.default.createElement(CollapseIcon, {
        className: classes.icon
    }) : /*#__PURE__*/ _react.default.createElement(ExpandIcon, {
        className: classes.icon
    });
}
ExpanderIcon.propTypes = {
    ExpandIcon: _propTypes.default.any,
    CollapseIcon: _propTypes.default.any,
    showExpander: _propTypes.default.bool,
    sublist: _propTypes.default.any,
    expanded: _propTypes.default.any
};
var _default = ExpanderIcon;
exports.default = _default;

//# sourceMappingURL=MenuExpanderIcon.js.map