"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = MenuHeader;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _cmsSlot = _interopRequireDefault(require("../CmsSlot"));
var _menuContext = _interopRequireDefault(require("./MenuContext"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
var PREFIX = 'RSFMenuHeader';
var classes = {
    root: "".concat(PREFIX, "-root")
};
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _defineProperty({
    }, "&.".concat(classes.root), {
        padding: theme.spacing(2),
        borderBottom: "1px solid ".concat(theme.palette.divider)
    });
});
function MenuHeader(param) {
    var item = param.item;
    var renderHeader = (0, _react).useContext(_menuContext.default).renderHeader;
    if (typeof renderHeader === 'function') {
        return(/*#__PURE__*/ _react.default.createElement(Root, {
            className: classes.root
        }, renderHeader(item)));
    }
    if (item.header) {
        return(/*#__PURE__*/ _react.default.createElement(Root, {
            className: classes.root
        }, /*#__PURE__*/ _react.default.createElement(_cmsSlot.default, null, item.header)));
    }
    return null;
}
MenuHeader.propTypes = {
    /**
   * The menu item record
   */ item: _propTypes.default.object
};
MenuHeader.defaultProps = {
};

//# sourceMappingURL=MenuHeader.js.map