"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = MenuIcon;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _amp = require("next/amp");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
var PREFIX = 'RSFMenuIcon';
var classes = {
    root: "".concat(PREFIX, "-root"),
    active: "".concat(PREFIX, "-active"),
    withLabel: "".concat(PREFIX, "-withLabel"),
    hidden: "".concat(PREFIX, "-hidden"),
    visible: "".concat(PREFIX, "-visible"),
    label: "".concat(PREFIX, "-label")
};
var _obj;
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, _defineProperty(_obj, "& .".concat(classes.root), {
        position: 'relative',
        height: '24px',
        width: '24px',
        boxSizing: 'border-box',
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'center',
        '& .rsf-hamburger': {
            display: 'block',
            marginTop: '5px'
        },
        '& .rsf-hamburger-box': {
            width: '20px',
            height: '20px',
            display: 'block',
            position: 'relative'
        },
        '& .rsf-hamburger-inner': {
            display: 'block',
            top: '50%',
            marginTop: '-4px'
        },
        '& .rsf-hamburger-inner, & .rsf-hamburger-inner::before, & .rsf-hamburger-inner::after': {
            width: '20px',
            height: '2px',
            backgroundColor: theme.palette.text.secondary,
            borderRadius: '4px',
            position: 'absolute',
            transitionProperty: 'transform',
            transitionDuration: theme.transitions.duration.standard,
            transitionTimingFunction: 'ease'
        },
        '& .rsf-hamburger-inner::before, & .rsf-hamburger-inner::after': {
            content: '""',
            display: 'block'
        },
        '& .rsf-hamburger-inner::before': {
            top: '-10px'
        },
        '& .rsf-hamburger-inner::after': {
            bottom: '-10px'
        },
        '& .rsf-hamburger .rsf-hamburger-inner': {
            top: '5px'
        },
        '& .rsf-hamburger .rsf-hamburger-inner::before': {
            top: '5px',
            transitionProperty: 'transform, opacity',
            transitionTimingFunction: 'ease',
            transitionDuration: theme.transitions.duration.standard
        },
        '& .rsf-hamburger .rsf-hamburger-inner::after': {
            top: '10px'
        }
    }), _defineProperty(_obj, "& .".concat(classes.active), {
        '& .rsf-hamburger .rsf-hamburger-inner': {
            transform: 'translate3d(0, 5px, 0) rotate(45deg)'
        },
        '& .rsf-hamburger .rsf-hamburger-inner::before': {
            transform: 'rotate(-45deg) translate3d(-5.71429px, -5px, 0)',
            opacity: 0
        },
        '& .rsf-hamburger .rsf-hamburger-inner::after': {
            transform: 'translate3d(0, -10px, 0) rotate(-90deg)'
        }
    }), _defineProperty(_obj, "& .".concat(classes.withLabel), {
        '& .rsf-hamburger': {
            marginTop: '0'
        }
    }), _defineProperty(_obj, "& .".concat(classes.hidden), {
        display: 'none'
    }), _defineProperty(_obj, "& .".concat(classes.visible), {
        display: 'block'
    }), _defineProperty(_obj, "& .".concat(classes.label), {
        fontSize: '9px',
        lineHeight: '9px',
        fontWeight: 'bold',
        letterSpacing: '0px',
        marginTop: '-3px',
        color: theme.palette.text.secondary
    }), _obj;
});
var _obj1;
function MenuIcon(param) {
    var label = param.label, open1 = param.open;
    var amp = (0, _amp).useAmp();
    var renderIcon = function(open) {
        return(/*#__PURE__*/ _react.default.createElement("div", {
            className: (0, _clsx).default((_obj1 = {
            }, _defineProperty(_obj1, classes.root, true), _defineProperty(_obj1, classes.active, open), _defineProperty(_obj1, classes.withLabel, label), _obj1))
        }, /*#__PURE__*/ _react.default.createElement("div", {
            className: "rsf-hamburger"
        }, /*#__PURE__*/ _react.default.createElement("span", {
            className: "rsf-hamburger-box"
        }, /*#__PURE__*/ _react.default.createElement("span", {
            className: "rsf-hamburger-inner"
        }))), label && /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.label
        }, "menu")));
    };
    if (amp) {
        return(/*#__PURE__*/ _react.default.createElement(Root, null, /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.visible,
            "amp-bind": "class=>!rsfMenuState.open ? '".concat(classes.visible, "' : '").concat(classes.hidden, "'")
        }, renderIcon(false)), /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.hidden,
            "amp-bind": "class=>rsfMenuState.open ? '".concat(classes.visible, "' : '").concat(classes.hidden, "'")
        }, renderIcon(true))));
    }
    return renderIcon(open1);
}
MenuIcon.propTypes = {
    /**
   * Set to true when the menu is open, otherwise false
   */ open: _propTypes.default.bool,
    /**
   * Set to `false` to hide the text "menu" underneath the button when the menu is closed.
   */ label: _propTypes.default.bool
};
MenuIcon.defaultProps = {
    open: false,
    label: false
};

//# sourceMappingURL=MenuIcon.js.map