"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = withAmpFormParser;
var _formidable = _interopRequireDefault(require("formidable"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function withAmpFormParser(handler) {
    return function(req, res) {
        var form = (0, _formidable).default();
        if (req.method.toLowerCase() === 'post') {
            try {
                form.parse(req, function(err, fields) {
                    if (err) {
                        res.status(500).end(err.message);
                    } else {
                        req.body = fields;
                        return handler(req, res);
                    }
                });
            } catch (err) {
                /* istanbul ignore next */ res.status(500).end(err.message);
            }
        } else {
            return handler(req, res);
        }
    };
}

//# sourceMappingURL=withAmpFormParser.js.map