"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = product;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _getBase64ForImage = _interopRequireDefault(require("react-storefront/utils/getBase64ForImage"));
var _fulfillAPIRequest = _interopRequireDefault(require("../props/fulfillAPIRequest"));
var _createProduct = _interopRequireDefault(require("./utils/createProduct"));
var _createAppData = _interopRequireDefault(require("./utils/createAppData"));
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function asciiSum() {
    var string = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : '';
    return string.split('').reduce(function(s, e) {
        return s + e.charCodeAt();
    }, 0);
}
function product(params, req) {
    return _product.apply(this, arguments);
}
function _product() {
    _product = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(params, req) {
        var id, color, size, result, data, mockPrice;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    id = params.id, color = params.color, size = params.size;
                    _ctx.next = 3;
                    return (0, _fulfillAPIRequest).default(req, {
                        appData: _createAppData.default,
                        pageData: function() {
                            return getPageData(id);
                        }
                    });
                case 3:
                    result = _ctx.sent;
                    if (!(color || size)) {
                        _ctx.next = 13;
                        break;
                    }
                    _ctx.next = 7;
                    return getPageData(id);
                case 7:
                    data = _ctx.sent;
                    data.carousel = {
                        index: 0
                    };
                    mockPrice = (asciiSum(color) + asciiSum(size)) / 100;
                    data.product.price = mockPrice;
                    data.product.priceText = "$".concat(mockPrice.toFixed(2));
                    return _ctx.abrupt("return", data);
                case 13:
                    return _ctx.abrupt("return", result);
                case 14:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _product.apply(this, arguments);
}
function getPageData(id) {
    return _getPageData.apply(this, arguments);
}
function _getPageData() {
    _getPageData = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(id) {
        var result, mainProductImage;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    result = {
                        title: "Product ".concat(id),
                        product: (0, _createProduct).default(id),
                        breadcrumbs: [
                            {
                                text: 'Home',
                                href: '/'
                            },
                            {
                                text: "Subcategory ".concat(id),
                                as: "/s/".concat(id),
                                href: '/s/[subcategoryId]'
                            }, 
                        ]
                    };
                    mainProductImage = result.product.media.full[0];
                    _ctx.next = 4;
                    return (0, _getBase64ForImage).default(mainProductImage.src);
                case 4:
                    mainProductImage.src = _ctx.sent;
                    return _ctx.abrupt("return", result);
                case 6:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _getPageData.apply(this, arguments);
}

//# sourceMappingURL=product.js.map