"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = searchSuggestions;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function searchSuggestions(q) {
    return _searchSuggestions.apply(this, arguments);
}
function _searchSuggestions() {
    _searchSuggestions = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(q) {
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    return _ctx.abrupt("return", {
                        text: q,
                        groups: [
                            {
                                caption: 'Suggested Searches',
                                ui: 'list',
                                links: [
                                    "Small ".concat(q),
                                    "Large ".concat(q),
                                    "".concat(q, " with red stripes")
                                ].map(function(text) {
                                    return {
                                        text: text,
                                        as: "/search?q=".concat(encodeURIComponent(text)),
                                        href: '/search'
                                    };
                                })
                            },
                            {
                                caption: 'Suggested Categories',
                                ui: 'list',
                                links: [
                                    {
                                        text: 'Category 1',
                                        href: '/s/[subcategoryId]',
                                        as: '/s/1'
                                    },
                                    {
                                        text: 'Category 2',
                                        href: '/s/[subcategoryId]',
                                        as: '/s/2'
                                    },
                                    {
                                        text: 'Category 3',
                                        href: '/s/[subcategoryId]',
                                        as: '/s/3'
                                    }, 
                                ]
                            },
                            {
                                caption: 'Suggested Products',
                                ui: 'thumbnails',
                                links: [
                                    {
                                        text: 'Product 1',
                                        href: '/p/[productId]',
                                        as: '/p/1?s=1&c=1',
                                        thumbnail: {
                                            src: 'https://dummyimage.com/120x120',
                                            alt: 'Product 1'
                                        }
                                    },
                                    {
                                        text: 'Product 2',
                                        href: '/p/[productId]',
                                        as: '/p/2?s=1&c=1',
                                        thumbnail: {
                                            src: 'https://dummyimage.com/120x120',
                                            alt: 'Product 1'
                                        }
                                    },
                                    {
                                        text: 'Product 3',
                                        href: '/p/[productId]',
                                        as: '/p/3?s=1&c=1',
                                        thumbnail: {
                                            src: 'https://dummyimage.com/120x120',
                                            alt: 'Product 1'
                                        }
                                    },
                                    {
                                        text: 'Product 4',
                                        href: '/p/[productId]',
                                        as: '/p/3?s=1&c=1',
                                        thumbnail: {
                                            src: 'https://dummyimage.com/120x120',
                                            alt: 'Product 1'
                                        }
                                    },
                                    {
                                        text: 'Product 5',
                                        href: '/p/[productId]',
                                        as: '/p/5?s=1&c=1',
                                        thumbnail: {
                                            src: 'https://dummyimage.com/120x120',
                                            alt: 'Product 1'
                                        }
                                    }, 
                                ]
                            }, 
                        ]
                    });
                case 1:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _searchSuggestions.apply(this, arguments);
}

//# sourceMappingURL=searchSuggestions.js.map