"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = subcategory;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _fulfillAPIRequest = _interopRequireDefault(require("react-storefront/props/fulfillAPIRequest"));
var _createFacets = _interopRequireDefault(require("./utils/createFacets"));
var _createSortOptions = _interopRequireDefault(require("./utils/createSortOptions"));
var _createProduct = _interopRequireDefault(require("./utils/createProduct"));
var _colors = _interopRequireWildcard(require("./utils/colors"));
var _createAppData = _interopRequireDefault(require("./utils/createAppData"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
function subcategory(params, req) {
    return _subcategory.apply(this, arguments);
}
function _subcategory() {
    _subcategory = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(params, req) {
        var q, _slug, slug, _page, page, filters, sort, _more, more;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    q = params.q, _slug = params.slug, slug = _slug === void 0 ? '1' : _slug, _page = params.page, page = _page === void 0 ? 0 : _page, filters = params.filters, sort = params.sort, _more = params.more, more = _more === void 0 ? false : _more;
                    if (filters) {
                        filters = JSON.parse(filters);
                    } else {
                        filters = [];
                    }
                    _ctx.next = 4;
                    return (0, _fulfillAPIRequest).default(req, {
                        appData: _createAppData.default,
                        pageData: function() {
                            return Promise.resolve({
                                id: slug,
                                name: q != null ? "Results for \"".concat(q, "\"") : "Subcategory ".concat(slug),
                                title: q != null ? "Results for \"".concat(q, "\"") : "Subcategory ".concat(slug),
                                total: 100,
                                page: parseInt(page),
                                totalPages: 5,
                                filters: filters,
                                sort: sort,
                                sortOptions: (0, _createSortOptions).default(),
                                facets: (0, _createFacets).default(),
                                products: filterProducts(page, filters, more),
                                breadcrumbs: [
                                    {
                                        text: 'Home',
                                        href: '/'
                                    }, 
                                ]
                            });
                        }
                    });
                case 4:
                    return _ctx.abrupt("return", _ctx.sent);
                case 5:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _subcategory.apply(this, arguments);
}
function filterProducts(page, filters, more) {
    var products = [];
    var filteredColors = filters ? filters.filter(function(f) {
        return f.startsWith('color');
    }).map(function(f) {
        return f.replace(/^color:/, '');
    }) : [];
    var count = more ? 20 : 10;
    while(products.length < count){
        if (filteredColors && filteredColors.length) {
            var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
            try {
                var _loop = function(_iterator, _step) {
                    var color = _step.value;
                    var _products;
                    var index = (0, _colors).indexForColor(color);
                    var colorGap = function(i) {
                        return Math.floor(page * count / filteredColors.length) + i;
                    };
                    (_products = products).push.apply(_products, _toConsumableArray(Array.from({
                        length: count
                    }, function(v, i) {
                        return colorGap(i);
                    }).map(function(i) {
                        return (0, _createProduct).default("".concat(i * Object.keys(_colors.default).length + index));
                    })));
                };
                for(var _iterator = filteredColors[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)_loop(_iterator, _step);
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally{
                try {
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                } finally{
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }
        } else {
            var id = page * 10 + products.length + 1;
            products.push((0, _createProduct).default("".concat(id)));
        }
    }
    return products.sort(function(a, b) {
        return a.id - b.id;
    }).slice(0, count);
}

//# sourceMappingURL=subcategory.js.map