"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getProducts = getProducts;
exports.updateItem = updateItem;
exports.removeItem = removeItem;
exports.addItem = addItem;
var _createProduct = _interopRequireDefault(require("./createProduct"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
var CART_COOKIE = 'rsf_mock_cart';
var initialStore = [
    {
        id: 1,
        quantity: 1
    },
    {
        id: 2,
        quantity: 1
    }, 
];
function getStore(req, res) {
    if (!req.cookies[CART_COOKIE]) {
        res.setHeader('Set-Cookie', "".concat(CART_COOKIE, "=").concat(JSON.stringify(initialStore), "; Path=/"));
    }
    var store = req.cookies[CART_COOKIE] || initialStore;
    try {
        return JSON.parse(store);
    } catch (err) {
        console.log('Failed parsing store from cookie', req.cookies[CART_COOKIE]);
        return [];
    }
}
function toProduct(param) {
    var id = param.id, quantity = param.quantity;
    return _objectSpread({
    }, (0, _createProduct).default(id), {
        quantity: quantity
    });
}
function getProducts(req, res) {
    return getStore(req, res).map(toProduct);
}
function updateItem(id, quantity, req, res) {
    var newStore = _toConsumableArray(getStore(req, res));
    var item = newStore.find(function(e) {
        return e.id === id;
    });
    item.quantity = quantity;
    res.setHeader('Set-Cookie', "".concat(CART_COOKIE, "=").concat(JSON.stringify(newStore), "; Path=/"));
    return newStore.map(toProduct);
}
function removeItem(id, req, res) {
    var newStore = _toConsumableArray(getStore(req, res)).filter(function(e) {
        return e.id !== id;
    });
    res.setHeader('Set-Cookie', "".concat(CART_COOKIE, "=").concat(JSON.stringify(newStore), "; Path=/"));
    return newStore.map(toProduct);
}
function addItem(id, quantity, req, res) {
    var newStore = [
        {
            id: id,
            quantity: quantity
        }
    ].concat(_toConsumableArray(getStore(req, res)));
    res.setHeader('Set-Cookie', "".concat(CART_COOKIE, "=").concat(JSON.stringify(newStore), "; Path=/"));
    return newStore.map(toProduct);
}

//# sourceMappingURL=cartStore.js.map