"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _link = _interopRequireDefault(require("../link/Link"));
var _useMediaQuery = _interopRequireDefault(require("@mui/material/useMediaQuery"));
var _materialUiPopupState = require("material-ui-popup-state");
var _hooks = require("material-ui-popup-state/hooks");
var _hoverPopover = _interopRequireDefault(require("material-ui-popup-state/HoverPopover"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFNavTab';
var defaultClasses = {
    popover: "".concat(PREFIX, "-popover"),
    tab: "".concat(PREFIX, "-tab"),
    link: "".concat(PREFIX, "-link"),
    ripple: "".concat(PREFIX, "-ripple"),
    paper: "".concat(PREFIX, "-paper"),
    innerPaper: "".concat(PREFIX, "-innerPaper")
};
var _obj;
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the Popover element for desktop users.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.popover), {
        pointerEvents: 'none',
        maxHeight: '80%'
    }), /**
   * Styles applied to the `Tab` element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.tab), {
        paddingLeft: theme.spacing(2),
        paddingRight: theme.spacing(2)
    }), /**
   * Styles applied to the root [`Link`](/apiReference/link/Link) element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.link), {
        textDecoration: 'none',
        color: 'inherit',
        fontWeight: 300
    }), /**
   * Styles applied to the root element of the `Tab`'s `TouchRippleProps` classes.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.ripple), {
        zIndex: 2
    }), /**
   * Styles applied to the Popover element's `Paper` element for desktop users.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.paper), {
        pointerEvents: 'all',
        paddingTop: 2,
        marginTop: -2,
        background: 'transparent',
        boxShadow: '0px 5px 5px -3px rgba(0,0,0,0.2), 0px 8px 10px 1px rgba(0,0,0,0.14)'
    }), /**
   * Styles applied to the Popover element's `Paper` element for desktop users.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.innerPaper), {
        borderTop: "1px solid ".concat(theme.palette.divider)
    }), _obj;
});
/**
 * A single navigational tab, which links to another page in the app based on the `as` and `href` props.
 * Children are displayed in a menu that is shown on mouse over on desktop devices.
 *
 * Example:
 *
 * ```js
 *  <NavTab href="/c/[categoryId]" as="/c/shirts" label="Shirts">
 *    <div style={{ padding: 20 }}>
 *      <Link href="/s/[subcategoryId]" as="/s/long-sleeve-shirts">Long Sleeve Shirts</Link>
 *      <Link href="/s/[subcategoryId]" as="/s/turtlenecks">Turtlenecks</Link>
 *      <Link href="/s/[subcategoryId]" as="/s/tees">Tee Shirts</Link>
 *    </div>
 *  </NavTab>
 * ```
 *
 * Accessibility:
 *
 * This component supports keyboard navigation.  The user can open the menu by pressing the enter key when the `NavTab` is focused.
 */ var NavTab = function NavTab(_param) {
    var href = _param.href, as = _param.as, prefetch = _param.prefetch, children = _param.children, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, props = _objectWithoutProperties(_param, [
        "href",
        "as",
        "prefetch",
        "children",
        "classes"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var theme = (0, _styles).useTheme();
    var isSmall = (0, _useMediaQuery).default(theme.breakpoints.down('sm'));
    var popupState = (0, _hooks).usePopupState({
        variant: 'popover',
        popupId: 'navTabPopup'
    });
    var handleEnterKeyDown = (0, _react).useCallback(function(e) {
        if (e.key === 'Enter') {
            e.preventDefault();
            popupState.open(e);
        }
    }, []);
    var hideMenu = (0, _react).useCallback(function(e) {
        e.preventDefault();
        popupState.close(e);
    }, []);
    return(/*#__PURE__*/ _react.default.createElement(Root, null, /*#__PURE__*/ _react.default.createElement(_link.default, _extends({
        className: classes.link,
        href: href,
        as: as,
        onClick: hideMenu,
        prefetch: prefetch
    }, (0, _materialUiPopupState).bindHover(popupState)), /*#__PURE__*/ _react.default.createElement(_material.Tab, _extends({
        onKeyDown: handleEnterKeyDown,
        classes: {
            root: classes.tab
        },
        "aria-haspopup": children != null,
        "aria-expanded": popupState.isOpen
    }, props, {
        TouchRippleProps: {
            classes: {
                root: classes.ripple
            }
        }
    }))), children && !isSmall ? /*#__PURE__*/ _react.default.createElement(_hoverPopover.default, _extends({
    }, (0, _materialUiPopupState).bindPopover(popupState), {
        className: classes.popover,
        anchorOrigin: {
            vertical: 'bottom',
            horizontal: 'center'
        },
        TransitionComponent: _material.Fade,
        transformOrigin: {
            vertical: 'top',
            horizontal: 'center'
        },
        PaperProps: {
            square: true,
            className: classes.paper
        },
        classes: classes
    }), /*#__PURE__*/ _react.default.createElement(_material.Paper, {
        className: classes.innerPaper,
        square: true
    }, children)) : null));
};
NavTab.propTypes = {
    /**
   * The link path
   */ as: _propTypes.default.string.isRequired,
    /**
   * The next.js route pattern
   */ href: _propTypes.default.string.isRequired,
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    prefetch: _propTypes.default.oneOf([
        'always',
        'visible',
        false
    ])
};
var _default = /*#__PURE__*/ _react.default.memo(NavTab);
exports.default = _default;

//# sourceMappingURL=NavTab.js.map