"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = NavTabs;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireWildcard(require("react"));
var _clsx = _interopRequireDefault(require("clsx"));
var _material = require("@mui/material");
var _tabScrollButton = _interopRequireDefault(require("@mui/material/TabScrollButton"));
var _router = require("next/router");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFNavTabs';
var defaultClasses = {
    indicatorNoSelection: "".concat(PREFIX, "-indicatorNoSelection"),
    scrollButtons: "".concat(PREFIX, "-scrollButtons"),
    root: "".concat(PREFIX, "-root"),
    ripple: "".concat(PREFIX, "-ripple")
};
var _obj;
var StyledTabs = (0, _styles).styled(_material.Tabs)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element when no tab is selected.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.indicatorNoSelection), {
        display: 'none'
    }), /**
   * Styles passed through to the `scrollButtons` rule in [`Tabs`](https://mui.com/api/tabs/#css)'.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.scrollButtons), {
        position: 'absolute',
        height: '100%',
        right: 0,
        '&:first-child': {
            left: 0
        },
        '& svg': {
            zIndex: 1,
            width: theme.spacing(5),
            background: theme.palette.background.paper
        }
    }), /**
   * Styles applied to the root [`Tabs`](https://mui.com/api/tabs/) component.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        maxWidth: theme.breakpoints.values.lg,
        flex: 1,
        position: 'relative',
        '&::before, &::after': {
            content: "''",
            top: 0,
            width: '15px',
            height: 'calc(100% - 3px)',
            position: 'absolute',
            zIndex: 1
        },
        '&::before': {
            left: 0,
            background: 'linear-gradient(to right, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)'
        },
        '&::after': {
            right: 0,
            background: 'linear-gradient(to left, rgba(255, 255, 255, 1.0) 0%, rgba(255, 255, 255, 0.0) 100%)'
        }
    }), _obj;
});
function NavTabs(_param) {
    var tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, children = _param.children, others = _objectWithoutProperties(_param, [
        "classes",
        "children"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var indicator = classes.indicator, indicatorNoSelection = classes.indicatorNoSelection, ripple = classes.ripple, classNames = _objectWithoutProperties(classes, [
        "indicator",
        "indicatorNoSelection",
        "ripple"
    ]);
    var asPath = (0, _router).useRouter().asPath;
    var value = children && children.findIndex(function(tab) {
        return tab.props.as === asPath.split('?')[0];
    });
    var TabScrollButton = (0, _react).useMemo(function() {
        var Comp = function Comp(props) {
            return(/*#__PURE__*/ _react.default.createElement(_tabScrollButton.default, _extends({
            }, props, {
                TouchRippleProps: {
                    classes: {
                        root: ripple
                    }
                }
            })));
        };
        return (0, _styles).styled(Comp)(function() {
            return _defineProperty({
            }, "&.".concat(ripple), {
                zIndex: 2
            });
        });
    }, [
        ripple
    ]);
    return(/*#__PURE__*/ _react.default.createElement(StyledTabs, _extends({
        indicatorColor: "primary",
        textColor: "inherit",
        ScrollButtonComponent: TabScrollButton,
        variant: "scrollable",
        classes: _objectSpread({
        }, classNames, {
            indicator: (0, _clsx).default(indicator, _defineProperty({
            }, indicatorNoSelection, value === -1), classes.root)
        }),
        value: value === -1 ? false : value
    }, others), children));
}
NavTabs.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Child tabs.
   */ children: _propTypes.default.node
};
NavTabs.defaultProps = {
};

//# sourceMappingURL=NavTabs.js.map