"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = ProductOptionSelector;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _clsx = _interopRequireDefault(require("clsx"));
var _productOption = _interopRequireDefault(require("./ProductOption"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFProductOptionSelector';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    button: "".concat(PREFIX, "-button")
};
var Root = (0, _styles).styled('div')(function() {
    return _defineProperty({
    }, "&.".concat(defaultClasses.root), {
        display: 'flex',
        flexWrap: 'wrap'
    });
});
function ProductOptionSelector(param1) {
    var options = param1.options, name = param1.name, tmp = param1.classes, c = tmp === void 0 ? {
    } : tmp, optionProps = param1.optionProps, skeleton = param1.skeleton, value = param1.value, onChange = param1.onChange, variant = param1.variant, strikeThroughDisabled = param1.strikeThroughDisabled, OptionComponent = param1.OptionComponent;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var StyledOptionComponent = (0, _styles).styled(OptionComponent)(function(param) {
        var theme = param.theme;
        return _defineProperty({
        }, "& .".concat(classes.button), {
            margin: theme.spacing(0, 0.5, 0.5, 0)
        });
    });
    if (skeleton) {
        options = new Array(skeleton).fill(0).map(function(_item, i) {
            return {
                id: i,
                text: ''
            };
        });
    }
    if (!options) return null;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        "data-id": "ProductOptionSelector",
        className: classes.root
    }, options.map(function(option, i) {
        return(/*#__PURE__*/ _react.default.createElement(StyledOptionComponent, _extends({
            selectedOption: value,
            onSelectedOptionChange: onChange
        }, optionProps, {
            variant: variant || (option.image || option.color ? 'swatch' : 'text'),
            name: name,
            key: option.id,
            className: (0, _clsx).default(classes.button, optionProps.className),
            index: i,
            color: option.color,
            imageProps: option.image,
            value: option,
            skeleton: skeleton != null,
            strikeThroughDisabled: strikeThroughDisabled
        })));
    })));
}
ProductOptionSelector.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Props for displayed images. See <Image /> component for details
   */ imageProps: _propTypes.default.object,
    /**
   * The name of property in amp state to bind to
   */ name: _propTypes.default.string,
    /**
   * Function to call when a new option is selected. Called with the new selected
   * option or `null` when a selected option is deselected.
   */ onChange: _propTypes.default.func,
    /**
   * Props to apply to each `SwatchProductOption` or `TextProductOption` element.
   */ optionProps: _propTypes.default.object,
    /**
   * If specified, this number of skeleton buttons will be displayed instead of
   * displaying the actual buttons.
   */ skeleton: _propTypes.default.number,
    /**
   * Current selected value among provided options or `null` when no option is selected.
   */ value: _propTypes.default.object,
    /**
   * If `true`, disabled options will have a line through them.
   */ strikeThroughDisabled: _propTypes.default.bool,
    /**
   * Allows you to override the default component which is used to render a product option.
   */ OptionComponent: _propTypes.default.elementType,
    options: _propTypes.default.array,
    variant: _propTypes.default.string
};
ProductOptionSelector.defaultProps = {
    items: [],
    optionProps: {
    },
    imageProps: {
    },
    OptionComponent: _productOption.default,
    strikeThroughDisabled: false
};

//# sourceMappingURL=ProductOptionSelector.js.map