"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SwatchProductOption;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _clsx = _interopRequireDefault(require("clsx"));
var _material = require("@mui/material");
var _iconsMaterial = require("@mui/icons-material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _image = _interopRequireDefault(require("../Image"));
var _box = require("../Box");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSwatchProductOption';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    button: "".concat(PREFIX, "-button"),
    buttonDisabled: "".concat(PREFIX, "-buttonDisabled"),
    image: "".concat(PREFIX, "-image"),
    checkMark: "".concat(PREFIX, "-checkMark"),
    selected: "".concat(PREFIX, "-selected"),
    selectedLabel: "".concat(PREFIX, "-selectedLabel"),
    default: "".concat(PREFIX, "-default"),
    small: "".concat(PREFIX, "-small"),
    tiny: "".concat(PREFIX, "-tiny"),
    disabled: "".concat(PREFIX, "-disabled"),
    strikeThrough: "".concat(PREFIX, "-strikeThrough"),
    defaultStrikeThrough: "".concat(PREFIX, "-defaultStrikeThrough"),
    smallStrikeThrough: "".concat(PREFIX, "-smallStrikeThrough"),
    tinyStrikeThrough: "".concat(PREFIX, "-tinyStrikeThrough")
};
var _obj;
var StyledVbox = (0, _styles).styled(_box.Vbox)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
    }), /**
   * Styles applied to the button element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.button), {
        position: 'relative',
        marginBottom: theme.spacing(0.5),
        padding: 2,
        borderRadius: '50%',
        backgroundColor: 'transparent',
        minWidth: 0,
        borderWidth: 1,
        borderStyle: 'solid',
        borderColor: theme.palette.grey[500],
        cursor: 'pointer',
        '&:focus': {
            outline: 0
        },
        '@media not all and (hover: none)': {
            '&:hover': {
                backgroundColor: 'transparent'
            }
        }
    }), /**
   * Styles applied to the button element when [`disabled`](#prop-disabled) is `true`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.buttonDisabled), {
        cursor: 'default',
        borderColor: theme.palette.grey.A100
    }), /**
   * Styles applied to the image element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.image), {
        height: '100%',
        width: '100%',
        borderRadius: '50%'
    }), /**
   * Styles applied to the wrapper element of the selected icon.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.checkMark), {
        transition: 'opacity 0.1s linear',
        opacity: 0,
        position: 'absolute',
        zIndex: 1,
        color: 'white',
        top: 2,
        left: 2,
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        backgroundColor: 'rgba(0,0,0,0.2)',
        padding: 2,
        height: 'calc(100% - 4px)',
        width: 'calc(100% - 4px)',
        boxSizing: 'border-box',
        borderRadius: '50%',
        '.rsf-po-selected &': {
            opacity: 1
        }
    }), /**
   * Styles applied to the wrapper element of the selected icon when this option is selected.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.selected), {
        opacity: 1
    }), /**
   * Styles applied to the label element when this option is selected.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.selectedLabel), {
        fontWeight: 'bold'
    }), /**
   * Styles applied to the skeleton and button elements when [`size`](#prop-size) is `'default'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.default), {
        height: 48,
        width: 48,
        '& svg': {
            height: 24,
            width: 24
        }
    }), /**
   * Styles applied to the skeleton and button elements when [`size`](#prop-size) is `'small'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.small), {
        height: 32,
        width: 32,
        '& svg': {
            height: 16,
            width: 16
        }
    }), /**
   * Styles applied to the skeleton and button elements when [`size`](#prop-size) is `'tiny'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.tiny), {
        height: 24,
        width: 24,
        '& svg': {
            height: 12,
            width: 12
        }
    }), /**
   * Styles applied to the image element when [`disabled`](#prop-disabled) is `true`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.disabled), {
        opacity: 0.3
    }), /**
   * Styles applied to the element used as a strikethrough when [`disabled`](#prop-disabled) and
   * [`strikeThroughDisabled`](#prop-disabled) are both `true`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.strikeThrough), {
        height: '7px',
        borderWidth: '2px 0',
        borderStyle: 'solid',
        borderColor: '#f2f2f2',
        backgroundColor: '#666',
        position: 'relative',
        width: '100%',
        borderRadius: 10
    }), /**
   * Styles applied to the element used as a strikethrough when [`disabled`](#prop-disabled) and
   * [`strikeThroughDisabled`](#prop-disabled) are both `true`, and [`size`](#prop-size) is `'default'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.defaultStrikeThrough), {
        top: -24
    }), /**
   * Styles applied to the element used as a strikethrough when [`disabled`](#prop-disabled) and
   * [`strikeThroughDisabled`](#prop-disabled) are both `true`, and [`size`](#prop-size) is `'small'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.smallStrikeThrough), {
        top: -16
    }), /**
   * Styles applied to the element used as a strikethrough when [`disabled`](#prop-disabled) and
   * [`strikeThroughDisabled`](#prop-disabled) are both `true`, and [`size`](#prop-size) is `'tiny'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.tinyStrikeThrough), {
        top: -12
    }), _obj;
});
var _obj1, _obj2, _obj3, _obj4, _obj5;
function SwatchProductOption(param) {
    var selected = param.selected, label = param.label, color = param.color, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, imageProps = param.imageProps, onClick = param.onClick, SelectedIcon = param.SelectedIcon, size = param.size, skeleton = param.skeleton, ImageComponent = param.ImageComponent, className = param.className, buttonProps = param.buttonProps, disabled = param.disabled, strikeThroughDisabled = param.strikeThroughDisabled, strikeThroughAngle = param.strikeThroughAngle;
    var classes = _objectSpread({
    }, defaultClasses, c);
    if (skeleton) {
        return(/*#__PURE__*/ _react.default.createElement(_material.Skeleton, {
            variant: "circular",
            style: {
                marginTop: 0,
                marginBottom: 4,
                margintLeft: 4,
                marginRight: 4
            },
            className: (0, _clsx).default((_obj1 = {
            }, _defineProperty(_obj1, buttonProps.className, true), _defineProperty(_obj1, classes[size], true), _obj1))
        }));
    }
    return(/*#__PURE__*/ _react.default.createElement(StyledVbox, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement("button", _extends({
    }, buttonProps, {
        type: "button",
        onClick: disabled ? Function.prototype : onClick,
        className: (0, _clsx).default((_obj2 = {
        }, _defineProperty(_obj2, className, className != null), _defineProperty(_obj2, classes.button, true), _defineProperty(_obj2, classes[size], true), _defineProperty(_obj2, classes.buttonDisabled, disabled), _obj2))
    }), /*#__PURE__*/ _react.default.createElement("div", {
        className: (0, _clsx).default((_obj3 = {
        }, _defineProperty(_obj3, classes.checkMark, true), _defineProperty(_obj3, classes.selected, selected), _obj3))
    }, /*#__PURE__*/ _react.default.createElement(SelectedIcon, {
        className: classes.icon
    })), color ? /*#__PURE__*/ _react.default.createElement("div", {
        className: (0, _clsx).default((_obj4 = {
        }, _defineProperty(_obj4, classes.image, true), _defineProperty(_obj4, classes.disabled, disabled), _obj4)),
        style: {
            backgroundColor: color
        }
    }) : /*#__PURE__*/ _react.default.createElement(ImageComponent, _extends({
        className: (0, _clsx).default(_defineProperty({
        }, classes.disabled, disabled)),
        classes: {
            image: classes.image
        },
        fill: true,
        aspectRatio: 1
    }, imageProps)), disabled && strikeThroughDisabled && /*#__PURE__*/ _react.default.createElement("div", {
        className: (0, _clsx).default((_obj5 = {
        }, _defineProperty(_obj5, classes.strikeThrough, true), _defineProperty(_obj5, classes["".concat(size, "StrikeThrough")], disabled), _obj5)),
        style: {
            transform: "rotate(".concat(strikeThroughAngle, "deg)")
        }
    })), label && /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "caption",
        className: (0, _clsx).default(_defineProperty({
        }, classes.selectedLabel, selected))
    }, label)));
}
SwatchProductOption.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * A CSS class to apply to the option.
   */ className: _propTypes.default.string,
    /**
   * Text to display below the button.
   */ label: _propTypes.default.oneOfType([
        _propTypes.default.string,
        _propTypes.default.element
    ]),
    /**
   * A CSS color value to set the color of the swatch. Use either `color` or `imageProps`.
   */ color: _propTypes.default.string,
    /**
   * Props for the `Image` element. Use either `color` or `imageProps`.
   */ imageProps: _propTypes.default.shape(_image.default.propTypes),
    /**
   * Controls the size of the button.
   */ size: _propTypes.default.oneOf([
        'default',
        'small',
        'tiny'
    ]),
    /**
   * The component type to use to display images.
   */ ImageComponent: _propTypes.default.elementType,
    /**
   * If `true`, this option is selected.
   */ selected: _propTypes.default.bool,
    /**
   * Set to `true` to make the option disabled.
   */ disabled: _propTypes.default.bool,
    /**
   * Set to `true` to show a slash through the item when disabled.
   */ strikeThroughDisabled: _propTypes.default.bool,
    /**
   * The angle in degrees for the disabled indicator.
   */ strikeThroughAngle: _propTypes.default.number,
    /**
   * A function to call when this option is clicked.
   */ onClick: _propTypes.default.func,
    /**
   * An icon component type to display for when this option is selected.
   */ SelectedIcon: _propTypes.default.elementType,
    /**
   * If `true`, show this option as just a skeleton.
   */ skeleton: _propTypes.default.bool,
    /**
   * Props to pass to the button element.
   */ buttonProps: _propTypes.default.object
};
SwatchProductOption.defaultProps = {
    imageProps: {
    },
    SelectedIcon: _iconsMaterial.Check,
    ImageComponent: _image.default,
    size: 'default',
    buttonProps: {
    },
    strikeThroughDisabled: false,
    strikeThroughAngle: 45
};

//# sourceMappingURL=SwatchProductOption.js.map