"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = CheckboxFilterGroup;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
var PREFIX = 'RSFCheckboxFilterGroup';
var defaultClasses = {
    matches: "".concat(PREFIX, "-matches"),
    groupLabel: "".concat(PREFIX, "-groupLabel")
};
var _obj;
var StyledFormGroup = (0, _styles).styled(_material.FormGroup)(function() {
    return _obj = {
    }, /**
   * Styles applied to the matching text.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.matches), {
        marginLeft: '5px',
        display: 'inline'
    }), /**
   * Styles applied to the group label element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.groupLabel), {
        display: 'flex',
        alignItems: 'center'
    }), _obj;
});
function CheckboxFilterGroup(props) {
    var group = props.group, submitOnChange = props.submitOnChange, tmp = props.classes, c = tmp === void 0 ? {
    } : tmp;
    var ref = (0, _react).useContext(_searchResultsContext.default), filters = ref.pageData.filters, toggleFilter = ref.actions.toggleFilter;
    var classes = _objectSpread({
    }, defaultClasses, c);
    return (0, _react).useMemo(function() {
        /*#__PURE__*/ return _react.default.createElement(StyledFormGroup, null, group.options.map(function(facet, i) {
            /*#__PURE__*/ return _react.default.createElement(_material.FormControlLabel, {
                key: i,
                label: /*#__PURE__*/ _react.default.createElement("div", {
                    className: classes.groupLabel
                }, /*#__PURE__*/ _react.default.createElement("span", null, facet.name), /*#__PURE__*/ _react.default.createElement(_material.Typography, {
                    variant: "caption",
                    className: classes.matches,
                    component: "span"
                }, "(", facet.matches, ")")),
                control: /*#__PURE__*/ _react.default.createElement(_material.Checkbox, {
                    checked: filters.indexOf(facet.code) !== -1,
                    color: "primary",
                    onChange: function() {
                        return toggleFilter(facet, submitOnChange);
                    }
                })
            });
        }));
    }, _toConsumableArray(Object.values(props)).concat([
        filters
    ]));
}
CheckboxFilterGroup.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Contains data for the group to be rendered.
   */ group: _propTypes.default.shape({
        options: _propTypes.default.arrayOf(_propTypes.default.shape({
            code: _propTypes.default.string,
            name: _propTypes.default.string,
            matches: _propTypes.default.oneOfType([
                _propTypes.default.string,
                _propTypes.default.number
            ]),
            image: _propTypes.default.object
        }))
    }),
    /**
   * Set to `true` to refresh the results when the user toggles a filter.
   */ submitOnChange: _propTypes.default.bool
};

//# sourceMappingURL=CheckboxFilterGroup.js.map