"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _facetGroup = _interopRequireDefault(require("./FacetGroup"));
var _filterHeader = _interopRequireDefault(require("./FilterHeader"));
var _filterFooter = _interopRequireDefault(require("./FilterFooter"));
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFFilter';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    facetGroups: "".concat(PREFIX, "-facetGroups")
};
var _obj;
var Root = (0, _styles).styled('div')(function() {
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        height: '100%',
        display: 'flex',
        flexDirection: 'column',
        alignItems: 'stretch'
    }), /**
   * Styles applied to the wrapper element around the facet groups.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.facetGroups), {
        overflow: 'auto',
        overflowX: 'hidden',
        flex: '1',
        position: 'relative'
    }), _obj;
});
/**
 * UI for filtering a list of products.  This component can be used on its own, or you can use
 * [`FilterButton`](/apiReference/plp/FilterButton) to automatically display this component in a
 * drawer that slides up from the bottom of the viewport.
 */ var Filter = function Filter(param) {
    var expandAll = param.expandAll, hideClearLink = param.hideClearLink, clearLinkText = param.clearLinkText, submitOnChange = param.submitOnChange, style = param.style, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, title = param.title, onViewResultsClick = param.onViewResultsClick;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = (0, _react).useContext(_searchResultsContext.default), facets = ref.pageData.facets;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        style: style,
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(_filterHeader.default, {
        hideClearLink: hideClearLink,
        clearLinkText: clearLinkText,
        title: title,
        submitOnChange: submitOnChange
    }), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.facetGroups
    }, facets && facets.map(function(group, i) {
        /*#__PURE__*/ return _react.default.createElement(_facetGroup.default, {
            group: group,
            key: i,
            defaultExpanded: expandAll,
            submitOnChange: submitOnChange
        });
    })), /*#__PURE__*/ _react.default.createElement(_filterFooter.default, {
        onViewResultsClick: onViewResultsClick,
        submitOnChange: submitOnChange
    })));
};
Filter.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * A function to call when the user clicks the button to view updated results.  The default behavior can be
   * canceled by calling `preventDefault` on the passed in event.  The event is passed as the only argument.
   */ onViewResultsClick: _propTypes.default.func,
    /**
   * The query string parameter that should be updated when filters are changed.  The value will be an array
   * of codes for each selected facet.
   */ queryParam: _propTypes.default.string,
    /**
   * An optional title to display at the top of the component.
   */ title: _propTypes.default.string,
    /**
   * Set to `true` to expand all groups on initial render.
   */ expandAll: _propTypes.default.bool,
    /**
   * Set to `true` to refresh the results when the user toggles a filter.
   */ submitOnChange: _propTypes.default.bool,
    /**
   * If `true`, the clear link is hidden.
   */ hideClearLink: _propTypes.default.bool,
    /**
   * Text to use for the clear link.
   */ clearLinkText: _propTypes.default.string,
    /**
   * CSS styles to add to the root component.
   */ style: _propTypes.default.object
};
Filter.defaultProps = {
    onViewResultsClick: Function.prototype,
    submitOnChange: false
};
var _default = /*#__PURE__*/ (0, _react).memo(Filter);
exports.default = _default;

//# sourceMappingURL=Filter.js.map