"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _router = require("next/router");
var _actionButton = _interopRequireDefault(require("../ActionButton"));
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
var _filter = _interopRequireDefault(require("./Filter"));
var _drawer = _interopRequireDefault(require("../drawer/Drawer"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFFilterButton';
var defaultClasses = {
    drawer: "".concat(PREFIX, "-drawer")
};
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function() {
    return(/**
   * Styles applied to the drawer element.
   */ _defineProperty({
    }, "& .".concat(defaultClasses.drawer), {
        height: '75vh'
    }));
});
/**
 * A button that when clicked, opens a drawer containing the `Filter` view. Current filters
 * are displayed in the button text.
 */ var FilterButton = function FilterButton(_param) {
    var tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, title = _param.title, drawerProps = _param.drawerProps, onClick = _param.onClick, href = _param.href, props = _objectWithoutProperties(_param, [
        "classes",
        "title",
        "drawerProps",
        "onClick",
        "href"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var drawer = classes.drawer, buttonClasses = _objectWithoutProperties(classes, [
        "drawer"
    ]);
    var ref = (0, _react).useContext(_searchResultsContext.default), _pageData = ref.pageData, filters = _pageData.filters, facets = _pageData.facets, actions = ref.actions;
    var openFilter = (0, _router).useRouter().query.openFilter === '1';
    var ref1 = _slicedToArray((0, _react).useState({
        open: openFilter,
        mountDrawer: openFilter
    }), 2), state = ref1[0], setState = ref1[1];
    var open1 = state.open, mountDrawer = state.mountDrawer;
    var toggleOpen = function(open) {
        setState(_objectSpread({
        }, state, {
            open: open,
            mountDrawer: mountDrawer || true
        }));
    };
    var handleClick = function(e) {
        if (onClick) {
            onClick(e);
        }
        if (!e.defaultPrevented) {
            toggleOpen(true);
        }
    };
    var handleViewResultsClick = (0, _react).useCallback(function() {
        toggleOpen(false);
        actions.applyFilters();
    }, [
        actions
    ]);
    var getFilterList = function() {
        if (!filters || !facets || filters.length === 0) return null;
        if (filters.length > 1) return "".concat(filters.length, " selected");
        var selected = filters[0];
        var _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
        try {
            for(var _iterator = facets[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                var group = _step.value;
                var _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                try {
                    for(var _iterator1 = group.options[Symbol.iterator](), _step1; !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                        var option = _step1.value;
                        if (selected === option.code) {
                            return option.name;
                        }
                    }
                } catch (err) {
                    _didIteratorError1 = true;
                    _iteratorError1 = err;
                } finally{
                    try {
                        if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                            _iterator1.return();
                        }
                    } finally{
                        if (_didIteratorError1) {
                            throw _iteratorError1;
                        }
                    }
                }
            }
        } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
        } finally{
            try {
                if (!_iteratorNormalCompletion && _iterator.return != null) {
                    _iterator.return();
                }
            } finally{
                if (_didIteratorError) {
                    throw _iteratorError;
                }
            }
        }
        return null;
    };
    return(/*#__PURE__*/ _react.default.createElement(Root, null, /*#__PURE__*/ _react.default.createElement(_actionButton.default, _extends({
        label: title,
        href: href,
        value: getFilterList(),
        classes: buttonClasses,
        onClick: handleClick
    }, props)), !href && /*#__PURE__*/ _react.default.createElement(_drawer.default, {
        classes: {
            paper: drawer
        },
        anchor: "bottom",
        open: open1,
        onClose: toggleOpen.bind(null, false),
        ModalProps: {
            keepMounted: true
        }
    }, mountDrawer && /*#__PURE__*/ _react.default.createElement(_filter.default, _extends({
        onViewResultsClick: handleViewResultsClick
    }, drawerProps)))));
};
FilterButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Props for the underlying `Filter` component.
   */ drawerProps: _propTypes.default.object,
    /**
   * The label for the button and the drawer header.
   */ title: _propTypes.default.string,
    /**
   * When specified, clicking the button will navigate to the specified URL with a full page reload.
   */ href: _propTypes.default.string,
    /**
   * A function that will be called when the button is clicked.
   */ onClick: _propTypes.default.func
};
FilterButton.defaultProps = {
    title: 'Filter',
    drawerProps: {
    }
};
var _default = /*#__PURE__*/ (0, _react).memo(FilterButton);
exports.default = _default;

//# sourceMappingURL=FilterButton.js.map