"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = FilterFooter;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireWildcard(require("react"));
var _material = require("@mui/material");
var _box = require("../Box");
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFFilterFooter';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    itemsFound: "".concat(PREFIX, "-itemsFound")
};
var _obj;
var StyledHbox = (0, _styles).styled(_box.Hbox)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        backgroundColor: theme.palette.secondary.main,
        padding: '12px 20px',
        color: 'white',
        justifyContent: 'space-between',
        alignItems: 'center'
    }), /**
   * Styles applied to the "# items found" label.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.itemsFound), {
        color: theme.palette.secondary.contrastText
    }), _obj;
});
function FilterFooter(props) {
    var tmp = props.classes, c = tmp === void 0 ? {
    } : tmp, submitOnChange = props.submitOnChange, onViewResultsClick = props.onViewResultsClick;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = (0, _react).useContext(_searchResultsContext.default), _pageData = ref.pageData, filters = _pageData.filters, filtersChanged = _pageData.filtersChanged;
    if (!filters || !filtersChanged || submitOnChange) return null;
    return(/*#__PURE__*/ _react.default.createElement(StyledHbox, {
        className: classes.root,
        justify: "space-between"
    }, /*#__PURE__*/ _react.default.createElement(_material.Typography, {
        variant: "subtitle1",
        className: classes.itemsFound
    }, filters.length || 'No', " filter", filters.length === 1 ? '' : 's', " selected"), /*#__PURE__*/ _react.default.createElement(_material.Button, {
        variant: "contained",
        size: "large",
        onClick: onViewResultsClick,
        color: "primary"
    }, "View Results")));
}
FilterFooter.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Set to `true` if the filters will be submitted when changed. In this case, the footer will not be shown.
   */ submitOnChange: _propTypes.default.bool,
    /**
   * Function to call when the "View Results" button is clicked.
   */ onViewResultsClick: _propTypes.default.func
};

//# sourceMappingURL=FilterFooter.js.map