"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = FilterHeader;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _box = require("../Box");
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
var PREFIX = 'RSFFilterHeader';
var defaultClasses = {
    header: "".concat(PREFIX, "-header"),
    title: "".concat(PREFIX, "-title"),
    clear: "".concat(PREFIX, "-clear")
};
var _obj, _obj1, _obj2;
var StyledHbox = (0, _styles).styled(_box.Hbox)(function(param) {
    var theme = param.theme;
    return _obj2 = {
    }, _defineProperty(_obj2, "&.".concat(defaultClasses.header), (_obj = {
        borderBottom: "1px solid ".concat(theme.palette.divider)
    }, _defineProperty(_obj, theme.breakpoints.down('sm'), {
        padding: "".concat(theme.spacing(2), " ").concat(theme.spacing(4))
    }), _defineProperty(_obj, theme.breakpoints.up('sm'), {
        padding: theme.spacing(1, 2, 2, 2)
    }), _obj)), _defineProperty(_obj2, "& .".concat(defaultClasses.title), (_obj1 = {
    }, _defineProperty(_obj1, theme.breakpoints.down('sm'), _objectSpread({
    }, theme.typography.h6)), _defineProperty(_obj1, theme.breakpoints.up('sm'), {
        flex: 1,
        textTransform: 'uppercase',
        fontWeight: 'bold'
    }), _obj1)), /**
   * Styles applied to the clear link.
   */ _defineProperty(_obj2, "& .".concat(defaultClasses.clear), _objectSpread({
    }, theme.typography.caption, {
        display: 'block',
        border: 'none',
        padding: 0,
        marginLeft: '10px',
        textDecoration: 'underline',
        backgroundColor: 'transparent'
    })), _obj2;
});
function FilterHeader(props) {
    var title = props.title, clearLinkText = props.clearLinkText, hideClearLink = props.hideClearLink, submitOnChange = props.submitOnChange, tmp = props.classes, c = tmp === void 0 ? {
    } : tmp;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = (0, _react).useContext(_searchResultsContext.default), actions = ref.actions, filters = ref.pageData.filters;
    return (0, _react).useMemo(function() {
        /*#__PURE__*/ return _react.default.createElement(StyledHbox, {
            justify: "center",
            className: classes.header
        }, /*#__PURE__*/ _react.default.createElement("div", {
            className: classes.title
        }, title), hideClearLink || !filters || filters.length === 0 ? null : /*#__PURE__*/ _react.default.createElement("button", {
            onClick: function() {
                return actions.clearFilters(submitOnChange);
            },
            className: classes.clear
        }, clearLinkText));
    }, [
        filters
    ].concat(_toConsumableArray(Object.values(props))));
}
FilterHeader.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * An optional title to display at the top of the component.
   */ title: _propTypes.default.string,
    /**
   * Set to `true` to refresh the results when the user toggles a filter.
   */ submitOnChange: _propTypes.default.bool,
    /**
   * If `true`, the clear link is hidden.
   */ hideClearLink: _propTypes.default.bool,
    /**
   * Text to use for the clear link.
   */ clearLinkText: _propTypes.default.string
};
FilterHeader.defaultProps = {
    title: 'Filter By',
    clearLinkText: 'clear all'
};

//# sourceMappingURL=FilterHeader.js.map