"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = ShowMore;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
var _clsx = _interopRequireDefault(require("clsx"));
var _reactVisibilitySensor = _interopRequireDefault(require("react-visibility-sensor"));
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFShowMore';
var classes = {
    root: "".concat(PREFIX, "-root"),
    button: "".concat(PREFIX, "-button"),
    loading: "".concat(PREFIX, "-loading")
};
var _obj;
var StyledCircularProgress = (0, _styles).styled(_material.CircularProgress)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "& .".concat(classes.root), {
        margin: '15px 0',
        width: '100%',
        display: 'flex',
        justifyContent: 'center'
    }), /**
   * Styles applied to the button element.
   */ _defineProperty(_obj, "& .".concat(classes.button), _defineProperty({
    }, theme.breakpoints.down('sm'), {
        flex: 1
    })), /**
   * Styles applied to the loading icon.
   */ _defineProperty(_obj, "& .".concat(classes.loading), {
        display: 'flex',
        height: 45,
        justifyContent: 'center'
    }), _obj;
});
var VARIANTS = {
    BUTTON: 'button',
    INFINITE: 'infinite'
};
function ShowMore(_param) {
    var handleVisible = function handleVisible(isVisible) {
        if (isVisible) {
            fetchMore();
        }
    };
    var className = _param.className, style = _param.style, children = _param.children, variant = _param.variant, href = _param.href, infiniteLoadOffset = _param.infiniteLoadOffset, renderLoadingIcon = _param.renderLoadingIcon, others = _objectWithoutProperties(_param, [
        "className",
        "style",
        "children",
        "variant",
        "href",
        "infiniteLoadOffset",
        "renderLoadingIcon"
    ]);
    var ref = _slicedToArray((0, _react).useState(false), 2), loading = ref[0], setLoading = ref[1];
    var ref1 = (0, _react).useContext(_searchResultsContext.default), actions = ref1.actions, pageData = ref1.pageData;
    if (pageData && pageData.page >= pageData.totalPages - 1) return null;
    function fetchMore() {
        return _fetchMore.apply(this, arguments);
    }
    function _fetchMore() {
        _fetchMore = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
            return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                while(1)switch(_ctx.prev = _ctx.next){
                    case 0:
                        if (loading) {
                            _ctx.next = 8;
                            break;
                        }
                        setLoading(true);
                        _ctx.prev = 2;
                        _ctx.next = 5;
                        return actions.fetchMore();
                    case 5:
                        _ctx.prev = 5;
                        setLoading(false);
                        return _ctx.finish(5);
                    case 8:
                    case "end":
                        return _ctx.stop();
                }
            }, _callee, null, [
                [
                    2,
                    ,
                    5,
                    8
                ]
            ]);
        }));
        return _fetchMore.apply(this, arguments);
    }
    if (variant === VARIANTS.INFINITE) {
        return(/*#__PURE__*/ _react.default.createElement(_reactVisibilitySensor.default, {
            onChange: handleVisible,
            partialVisibility: true,
            offset: {
                bottom: -infiniteLoadOffset
            }
        }, /*#__PURE__*/ _react.default.createElement("div", {
            className: (0, _clsx).default(classes.loading, className),
            style: style
        }, renderLoadingIcon())));
    }
    return(/*#__PURE__*/ _react.default.createElement("div", {
        className: (0, _clsx).default(classes.root, className),
        style: style
    }, loading ? /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.loading
    }, renderLoadingIcon()) : /*#__PURE__*/ _react.default.createElement(_material.Button, _extends({
        variant: "contained",
        color: "primary",
        href: href,
        className: classes.button,
        onClick: fetchMore
    }, others), children || 'Show More')));
}
ShowMore.propTypes = {
    /**
   * A renderer for the loading icon.  Uses `<CircularProgress />` by default.
   */ renderLoadingIcon: _propTypes.default.func,
    /**
   * Which variant to use. One of `'button'` or `'infinite'`.
   *
   * When variant is set to `'button'`:
   *   A button is rendered with contents of `{props.children}` or `'Show More'`.
   *
   * When variant is set to `'infinite'`:
   *   The loading icon is rendered and contents of next page loaded when user
   *   scrolls to the end of the page.
   *
   * In AMP the `'button'` variant is always used.
   */ variant: _propTypes.default.oneOf([
        VARIANTS.BUTTON,
        VARIANTS.INFINITE
    ]),
    /**
   * Minimum amount of pixels from the bottom of the page to where the user has
   * scrolled before the new page is loaded. Used in conjunction with `'infinite'`
   * variant. Defaults to 200.
   */ infiniteLoadOffset: _propTypes.default.number,
    /**
   * When specified, clicking the button will navigate to the specified URL with a full page reload.
   */ href: _propTypes.default.string,
    /**
   * A CSS class to apply to the root element.
   */ className: _propTypes.default.string,
    /**
   * CSS styles to be added to the root element.
   */ style: _propTypes.default.object
};
ShowMore.defaultProps = {
    renderLoadingIcon: function() {
        /*#__PURE__*/ return _react.default.createElement(StyledCircularProgress, null);
    },
    variant: VARIANTS.BUTTON,
    infiniteLoadOffset: 200
};

//# sourceMappingURL=ShowMore.js.map