"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _material = require("@mui/material");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSort';
var defaultClasses = {
    container: "".concat(PREFIX, "-container"),
    option: "".concat(PREFIX, "-option")
};
/**
 * UI for sorting a list of products.  This component can be used on its own, or you can use
 * [`SortButton`](/apiReference/plp/SortButton) to automatically display this component in a drawer
 * that slides up from the bottom of the viewport.
 */ var Sort = function Sort(param) {
    var variant = param.variant, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, onSelect = param.onSelect;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = (0, _react).useContext(_searchResultsContext.default), _pageData = ref.pageData, sort = _pageData.sort, sortOptions = _pageData.sortOptions, setSort = ref.actions.setSort;
    var handleClick = function(option, e) {
        onSelect(option, e);
        if (!e.defaultPrevented) {
            setSort(option);
        }
    };
    var renderButtons = function() {
        /*#__PURE__*/ return _react.default.createElement("div", {
            className: classes.container
        }, sortOptions && sortOptions.map(function(option, i) {
            /*#__PURE__*/ return _react.default.createElement(_material.Button, {
                className: classes.option,
                color: sort === option.code ? 'primary' : 'secondary',
                variant: "contained",
                onClick: function(e) {
                    return handleClick(option, e);
                },
                key: i
            }, option.name);
        }));
    };
    var renderMenu = function() {
        /*#__PURE__*/ return _react.default.createElement(_react.default.Fragment, null, sortOptions && sortOptions.map(function(option, i) {
            /*#__PURE__*/ return _react.default.createElement(_material.MenuItem, {
                key: i,
                onClick: function(e) {
                    return handleClick(option, e);
                }
            }, option.name);
        }));
    };
    if (variant === 'buttons') {
        return renderButtons();
    }
    if (variant === 'menu-items') {
        return renderMenu();
    }
    return null;
};
Sort.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * A function to call when a sort option is selected.  The option and event are passed.
   * The default behavior can be prevented by called `preventDefault()` on the passed in event.
   */ onSelect: _propTypes.default.func,
    /**
   * Controls how sort options are displayed.
   */ variant: _propTypes.default.oneOf([
        'menu-items',
        'buttons'
    ])
};
Sort.defaultProps = {
    onSelect: Function.prototype,
    variant: 'buttons'
};
var _obj;
var StyledSort = (0, _styles).styled(Sort)(function() {
    return _obj = {
    }, /**
   * Styles applied to the root container if [`variant`](#prop-variant) is `'buttons'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.container), {
        padding: '15px 0 0 15px'
    }), /**
   * Styles applied to each option if [`variant`](#prop-variant) is `'buttons'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.option), {
        boxShadow: 'none',
        width: 'calc(50% - 15px)',
        margin: '0 15px 15px 0'
    }), _obj;
});
var _default = /*#__PURE__*/ (0, _react).memo(StyledSort);
exports.default = _default;

//# sourceMappingURL=Sort.js.map