"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
var _styles = require("@mui/material/styles");
var _actionButton = _interopRequireDefault(require("../ActionButton"));
var _sort = _interopRequireDefault(require("./Sort"));
var _drawer = _interopRequireDefault(require("../drawer/Drawer"));
var _searchResultsContext = _interopRequireDefault(require("./SearchResultsContext"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
/**
 * A button that when clicked, opens a drawer containing the `Sort` view. The name of the currently
 * selected sort option is displayed in the button text.
 */ var SortButton = function SortButton(_param) {
    var title = _param.title, drawerProps = _param.drawerProps, onClick = _param.onClick, sortProps = _param.sortProps, drawerBreakpoint = _param.drawerBreakpoint, href = _param.href, props = _objectWithoutProperties(_param, [
        "title",
        "drawerProps",
        "onClick",
        "sortProps",
        "drawerBreakpoint",
        "href"
    ]);
    var theme = (0, _styles).useTheme();
    var ref = _slicedToArray((0, _react).useState({
        open: false,
        mountDrawer: false,
        anchorEl: null
    }), 2), state = ref[0], setState = ref[1];
    var open1 = state.open, mountDrawer = state.mountDrawer, anchorEl1 = state.anchorEl;
    var ref1 = (0, _react).useContext(_searchResultsContext.default), _pageData = ref1.pageData, sort = _pageData.sort, sortOptions = _pageData.sortOptions;
    var buttonRef = (0, _react).useRef();
    var selectedOption = sortOptions.find(function(o) {
        return sort === o.code;
    });
    (0, _react).useEffect(function() {
        if (location.search.indexOf('openSort') !== -1) {
            setState({
                open: true,
                mountDrawer: true,
                anchorEl: buttonRef.current
            });
        }
    }, []);
    var handleClick = function(e) {
        if (onClick) {
            onClick(e);
        }
        if (!e.defaultPrevented) {
            toggleOpen(true, e.currentTarget);
        }
    };
    var close = function() {
        toggleOpen(false);
    };
    var toggleOpen = function(open, anchorEl) {
        if (open) {
            setState({
                mountDrawer: true,
                open: true,
                anchorEl: anchorEl
            });
        } else {
            setState(_objectSpread({
            }, state, {
                open: false,
                anchorEl: null
            }));
        }
    };
    var useDrawer = (0, _material).useMediaQuery(theme.breakpoints.down(drawerBreakpoint));
    return(/*#__PURE__*/ _react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/ _react.default.createElement(_actionButton.default, _extends({
        key: "button",
        label: title,
        ref: buttonRef,
        value: selectedOption && selectedOption.name,
        href: href
    }, props, {
        onClick: function(e) {
            return handleClick(e);
        }
    })), !href && useDrawer && /*#__PURE__*/ _react.default.createElement(_drawer.default, _extends({
        ModalProps: {
            keepMounted: true
        },
        key: "drawer",
        anchor: "bottom",
        title: title,
        open: open1,
        onClose: close
    }, drawerProps), mountDrawer && /*#__PURE__*/ _react.default.createElement(_sort.default, _extends({
        onSelect: close
    }, sortProps))), !href && !useDrawer && /*#__PURE__*/ _react.default.createElement(_material.Menu, {
        open: open1,
        anchorEl: anchorEl1,
        onClose: close
    }, /*#__PURE__*/ _react.default.createElement(_sort.default, _extends({
        variant: "menu-items",
        onSelect: close
    }, sortProps)))));
};
SortButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Props to pass to the underlying `Drawer` component.
   */ drawerProps: _propTypes.default.object,
    /**
   * Props to pass to the underlying [`Sort`](/apiReference/plp/Sort) component.
   */ sortProps: _propTypes.default.object,
    /**
   * Text for the button label and the drawer header.
   */ title: _propTypes.default.string,
    /**
   * The breakpoint in your theme below which a drawer UI should be used in favor of the menu UI.
   */ drawerBreakpoint: _propTypes.default.oneOf([
        'xs',
        'sm',
        'md',
        'lg',
        'xl'
    ]),
    /**
   * When specified, clicking the button will navigate to the specified URL with a full page reload.
   */ href: _propTypes.default.string,
    /**
   * A function that is called when the button is clicked.
   */ onClick: _propTypes.default.func
};
SortButton.defaultProps = {
    title: 'Sort',
    drawerProps: {
    },
    sortProps: {
    },
    drawerBreakpoint: 'xs'
};
var _default = /*#__PURE__*/ (0, _react).memo(SortButton);
exports.default = _default;

//# sourceMappingURL=SortButton.js.map