"use strict";
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var webpack = require('webpack');
var BundleAnalyzerPlugin = require('webpack-bundle-analyzer').BundleAnalyzerPlugin;
var ClearRequireCachePlugin = require('webpack-clear-require-cache-plugin');
var withServiceWorker = require('./withServiceWorker');
var _tmp;
_tmp = function() {
    var _param = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {
    };
    var prefetchQueryParam = _param.prefetchQueryParam, _connector = _param.connector, connector = _connector === void 0 ? 'react-storefront/mock-connector' : _connector, nextConfig = _objectWithoutProperties(_param, [
        "prefetchQueryParam",
        "connector"
    ]);
    var usePreact = process.env.preact === 'true';
    nextConfig.serverRuntimeConfig = _objectSpread({
    }, nextConfig.serverRuntimeConfig, {
        reactStorefront: {
            connector: connector
        }
    });
    return withServiceWorker(_objectSpread({
    }, nextConfig, {
        target: 'serverless',
        webpack: function webpack1(config, options) {
            config.resolve.symlinks = false;
            if (usePreact) {
                config.resolve.alias = _objectSpread({
                }, config.resolve.alias, {
                    react: 'preact/compat',
                    react$: 'preact/compat',
                    'react-dom/test-utils': 'preact/test-utils',
                    'react-dom': 'preact/compat',
                    'react-dom$': 'preact/compat'
                });
            }
            if (options.isServer) {
                console.log("> Using connector ".concat(connector));
                config.resolve.alias = _objectSpread({
                }, config.resolve.alias, {
                    'react-storefront-connector': connector
                });
            }
            config.plugins.push(new webpack.DefinePlugin({
                'process.env.RSF_PREFETCH_QUERY_PARAM': JSON.stringify(prefetchQueryParam),
                'process.env.SERVICE_WORKER': JSON.stringify(process.env.SERVICE_WORKER),
                'process.env.FIREBASE_CONFIG': JSON.stringify(process.env.FIREBASE_CONFIG)
            }));
            if (config.externals) {
                // Making sure the AMP optimizer is bundled
                config.externals = config.externals.filter(function(name) {
                    return name !== '@ampproject/toolbox-optimizer';
                });
                // These are optional dependencies for the optimizer
                // which are not used by default
                config.externals.push('jimp');
                config.externals.push('probe-image-size');
            }
            if (process.env.NODE_ENV === 'development') {
                // This makes it easier to develop apps against a local clone of react-storefront linked with yalc. Here
                // we ensure that the server build recompiles when any linked dependency changes.
                config.plugins.push(new ClearRequireCachePlugin([
                    /\.next\/server\/ssr-module-cache.js/,
                    /react-storefront-analytics/,
                    /react-storefront-amp/,
                    /react-storefront\//, 
                ]));
            }
            config.module.rules.push({
                test: /\.svg$/,
                use: [
                    '@svgr/webpack'
                ]
            });
            if (!options.isServer && process.env.analyze === 'true') {
                config.plugins.push(new BundleAnalyzerPlugin());
            }
            if (typeof nextConfig.webpack === 'function') {
                return nextConfig.webpack(config, options);
            }
            return config;
        }
    }));
}, /**
 * @param options
 * @param options.prefetchQueryParam If specified, this parameter will be added to the query string of all prefetch requests.
 * @param options.connector The connector package to use.  By default React Storefront's mock connector will be used.
 */ module.exports = _tmp, _tmp;

//# sourceMappingURL=withReactStorefront.js.map