"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = fetchFromAPI;
var _fetch = _interopRequireDefault(require("../fetch"));
var _getAPIURL = _interopRequireDefault(require("../api/getAPIURL"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function fetchFromAPI(param) {
    var req = param.req, asPath = param.asPath, pathname = param.pathname;
    var host = req ? process.env.API_HOST || req.headers.host : '';
    var protocol = '';
    if (req) {
        protocol = 'https://';
        if (host.startsWith('localhost') || host.startsWith('127.0.0.1')) {
            protocol = 'http://';
        }
    }
    var uri = (0, _getAPIURL).default(asPath);
    var headers = {
    };
    if (req) {
        // on the server
        if (uri.indexOf('?') === -1) {
            uri += '?_includeAppData=1';
        } else {
            uri += '&_includeAppData=1';
        }
        headers = {
            host: req.headers.host,
            'x-next-page': "/api".concat(pathname.replace(/\/$/, '')),
            cookie: req.headers.cookie
        };
    }
    var url = "".concat(protocol).concat(host).concat(uri);
    return (0, _fetch).default(url, {
        credentials: 'include',
        headers: headers
    }).then(function(res) {
        return res.json();
    });
}

//# sourceMappingURL=fetchFromAPI.js.map