"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = fetchServerSideProps;
var _fetch = _interopRequireDefault(require("../fetch"));
var _getAPIURL = _interopRequireDefault(require("../api/getAPIURL"));
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function fetchServerSideProps(param) {
    var req = param.req, resolvedUrl = param.resolvedUrl;
    var host = process.env.API_HOST || req.headers.host;
    var protocol = host.startsWith('localhost') || host.startsWith('127.0.0.1') ? 'http://' : 'https://';
    var uri = (0, _getAPIURL).default(resolvedUrl);
    if (uri.indexOf('?') === -1) {
        uri += '?_includeAppData=1';
    } else {
        uri += '&_includeAppData=1';
    }
    var headers = {
        host: req.headers.host,
        'x-next-page': "/api".concat(resolvedUrl.split('?')[0].replace(/\/$/, '')),
        cookie: req.headers.cookie
    };
    var url = "".concat(protocol).concat(host).concat(uri);
    return (0, _fetch).default(url, {
        credentials: 'include',
        headers: headers
    }).then(function(res) {
        return res.json();
    }).then(function(props) {
        return {
            props: props
        };
    });
}

//# sourceMappingURL=fetchServerSideProps.js.map