"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = useSimpleNavigation;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _delegate = _interopRequireDefault(require("delegate"));
var _react = require("react");
var _router = _interopRequireDefault(require("next/router"));
var _qs = _interopRequireDefault(require("qs"));
var _fetch = _interopRequireDefault(require("../fetch"));
var _getAPIURL = _interopRequireDefault(require("../api/getAPIURL"));
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function useSimpleNavigation() {
    var routes = (0, _react).useRef({
    });
    var nextNavigation = (0, _react).useRef(false);
    var onNextNavigation = (0, _react).useCallback(function() {
        nextNavigation.current = true;
    }, []);
    var onNextNavigationEnd = (0, _react).useCallback(function() {
        nextNavigation.current = false;
    }, []);
    (0, _react).useEffect(function() {
        function doEffect() {
            return _doEffect.apply(this, arguments);
        }
        function _doEffect() {
            _doEffect = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                    while(1)switch(_ctx.prev = _ctx.next){
                        case 0:
                            (0, _delegate).default('a', 'click', function(e) {
                                var delegateTarget = e.delegateTarget;
                                var as = delegateTarget.getAttribute('href');
                                var href = getRoute(as, routes.current);
                                // catch if not next link
                                if (href && !nextNavigation.current) {
                                    e.preventDefault();
                                    var url = toNextURL(href, as);
                                    _router.default.push(url, as);
                                }
                            });
                            _ctx.next = 3;
                            return fetchRouteManifest();
                        case 3:
                            routes.current = _ctx.sent;
                        case 4:
                        case "end":
                            return _ctx.stop();
                    }
                }, _callee);
            }));
            return _doEffect.apply(this, arguments);
        }
        doEffect();
        _router.default.events.on('routeChangeStart', onNextNavigation);
        _router.default.events.on('routeChangeComplete', onNextNavigationEnd);
        return function() {
            return _router.default.events.off('routeChangeStart', onNextNavigation);
        };
    }, []);
}
function toNextURL(href, as) {
    var url = new URL(as, "".concat(window.location.protocol, "//").concat(window.location.hostname));
    return {
        pathname: href,
        query: _qs.default.parse(url.search, {
            ignoreQueryPrefix: true
        })
    };
}
function fetchRouteManifest() {
    return (0, _fetch).default((0, _getAPIURL).default('/routes')).then(function(res) {
        return res.json();
    });
}
function getRoute(href, routes) {
    for(var pattern in routes){
        if (new RegExp(pattern, 'i').test(href)) {
            return routes[pattern].as;
        }
    }
    return null;
}

//# sourceMappingURL=useSimpleNavigation.js.map