"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchButton;
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireDefault(require("react"));
var _material = require("@mui/material");
var _iconsMaterial = require("@mui/icons-material");
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFSearchButton';
var defaultClasses = {
    icon: "".concat(PREFIX, "-icon"),
    large: "".concat(PREFIX, "-large")
};
var _obj;
var StyledIconButton = (0, _styles).styled(_material.IconButton)(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the icon, if [children](#prop-children) is empty.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.icon), {
        color: theme.palette.action.active
    }), /**
   * Styles applied to the element containing the button's label.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.large), {
        fontSize: '28px'
    }), _obj;
});
function SearchButton(_param) {
    var children = _param.children, tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, other = _objectWithoutProperties(_param, [
        "children",
        "classes"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    return(/*#__PURE__*/ _react.default.createElement(StyledIconButton, _extends({
        "aria-label": "Search",
        color: "inherit",
        classes: {
            label: classes.large
        }
    }, other, {
        size: "large"
    }), children || /*#__PURE__*/ _react.default.createElement(_iconsMaterial.Search, {
        className: classes.icon
    })));
}
SearchButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Optional content to use for the button contents. If empty, a search icon is used.
   */ children: _propTypes.default.node
};

//# sourceMappingURL=SearchButton.js.map