"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchDrawer;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _useNavigationEvent = _interopRequireDefault(require("react-storefront/hooks/useNavigationEvent"));
var _drawer = _interopRequireDefault(require("../drawer/Drawer"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSearch';
var defaultClasses = {
    paper: "".concat(PREFIX, "-paper"),
    closeButton: "".concat(PREFIX, "-closeButton")
};
var _obj;
function SearchDrawer(param1) {
    var DrawerComponent = param1.DrawerComponent, tmp = param1.classes, c = tmp === void 0 ? {
    } : tmp, open = param1.open, onClose = param1.onClose, children = param1.children;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var StyledDrawerComponent = (0, _styles).styled(DrawerComponent)(function(param) {
        var theme = param.theme;
        return _obj = {
        }, /**
     * Styles applied to the paper component in the [Drawer](/apiReference/drawer/Drawer).
     */ _defineProperty(_obj, "& .".concat(classes.paper), {
            display: 'flex'
        }), /**
     * Styles applied to the root element in the [DrawerCloseButton](/apiReference/drawer/DrawerCloseButton).
     */ _defineProperty(_obj, "& .".concat(classes.closeButton), {
            color: theme.palette.primary.contrastText
        }), _obj;
    });
    var handleNavigation = function() {
        if (onClose) {
            onClose();
        }
    };
    (0, _useNavigationEvent).default(handleNavigation);
    return(/*#__PURE__*/ _react.default.createElement(StyledDrawerComponent, {
        classes: classes,
        open: open,
        anchor: "bottom",
        onClose: onClose,
        fullscreen: true
    }, children));
}
SearchDrawer.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Children to be rendered inside the drawer.
   */ children: _propTypes.default.node,
    /**
   * If `true`, the search drawer should be open.
   */ open: _propTypes.default.bool,
    /**
   * A function that is called when the user closes the drawer.
   */ onClose: _propTypes.default.func.isRequired,
    /**
   * A component type to use for the drawer.
   */ DrawerComponent: _propTypes.default.elementType
};
SearchDrawer.defaultProps = {
    DrawerComponent: _drawer.default
};

//# sourceMappingURL=SearchDrawer.js.map