"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
var _clear = _interopRequireDefault(require("@mui/icons-material/Clear"));
var _clsx = _interopRequireDefault(require("clsx"));
var _searchSubmitButton = _interopRequireDefault(require("./SearchSubmitButton"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFSearchField';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    inputWrap: "".concat(PREFIX, "-inputWrap"),
    input: "".concat(PREFIX, "-input"),
    inputClearIcon: "".concat(PREFIX, "-inputClearIcon"),
    searchFab: "".concat(PREFIX, "-searchFab"),
    hidden: "".concat(PREFIX, "-hidden")
};
var _obj;
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        display: 'flex',
        alignItems: 'center'
    }), /**
   * Styles applied to the wrapper element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.inputWrap), {
        display: 'flex',
        flexGrow: 1,
        border: 0,
        borderRadius: '35px',
        backgroundColor: theme.palette.background.paper,
        margin: 0,
        height: '48px'
    }), /**
   * Styles applied to the input element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.input), _objectSpread({
        border: 'none',
        background: 'none',
        flex: 1,
        padding: theme.spacing(0, 2.5, 0, 2.5)
    }, theme.typography.body1, _defineProperty({
        '&:focus': {
            outline: 'none'
        }
    }, theme.breakpoints.up('sm'), {
        border: '1px solid',
        borderColor: theme.palette.divider,
        borderRadius: theme.spacing(1),
        margin: theme.spacing(0.5, 0, 0.5, 0),
        zIndex: 9999,
        transition: 'border-color linear 0.1s',
        '&:hover': {
            borderColor: (0, _styles).alpha(theme.palette.divider, 0.25)
        },
        '&:focus': {
            borderColor: theme.palette.primary.main
        }
    }))), /**
   * Styles applied to the input if showClearnButton prop is true.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.inputClearIcon), {
        paddingRight: 0
    }), /**
   * Styles applied to the submit button element if [submitButtonVariant](#prop-submitButtonVariant)
   * is `'fab'`.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.searchFab), {
        height: '48px',
        width: '48px',
        marginLeft: '10px',
        backgroundColor: theme.palette.background.paper,
        color: theme.palette.text.secondary
    }), /**
   * Styles applied to the clear and submit buttons if the search field is empty.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.hidden), {
        display: 'none'
    }), _obj;
});
var _obj1, _obj2, _obj3;
/**
 * A search text field. Additional props are spread to the underlying
 * [Input](https://mui.com/api/input/).
 */ var SearchField = /*#__PURE__*/ (0, _react).forwardRef(function(_param, ref) {
    var tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, ariaLabel = _param.ariaLabel, onChange = _param.onChange, submitButtonVariant = _param.submitButtonVariant, showClearButton = _param.showClearButton, SubmitButtonComponent = _param.SubmitButtonComponent, SubmitButtonIcon = _param.SubmitButtonIcon, clearButtonProps = _param.clearButtonProps, inputProps = _param.inputProps, value = _param.value, onFocus = _param.onFocus, submitButtonProps = _param.submitButtonProps, others = _objectWithoutProperties(_param, [
        "classes",
        "ariaLabel",
        "onChange",
        "submitButtonVariant",
        "showClearButton",
        "SubmitButtonComponent",
        "SubmitButtonIcon",
        "clearButtonProps",
        "inputProps",
        "value",
        "onFocus",
        "submitButtonProps"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var innerRef = (0, _react).useRef(null);
    var inputRef = ref || innerRef;
    var empty = value.trim().length === 0;
    var handleInputFocus = function() {
        if (onFocus) {
            onFocus();
        }
        inputRef.current.setSelectionRange(0, inputRef.current.value.length);
    };
    var handleClearClick = function() {
        onChange('');
    };
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root,
        "data-empty": value.trim().length === 0 ? 'on' : 'off'
    }, /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.inputWrap
    }, /*#__PURE__*/ _react.default.createElement("input", _extends({
    }, others, {
        "aria-label": ariaLabel,
        type: "text",
        value: value,
        onChange: function(e) {
            return onChange(e.target.value);
        },
        onFocus: handleInputFocus,
        ref: inputRef,
        className: (0, _clsx).default(classes.input, showClearButton && classes.inputClearIcon)
    }, inputProps)), showClearButton ? /*#__PURE__*/ _react.default.createElement(_material.IconButton, _extends({
    }, clearButtonProps, {
        onClick: handleClearClick,
        rel: "clear",
        className: (0, _clsx).default((_obj1 = {
        }, _defineProperty(_obj1, classes.searchReset, true), _defineProperty(_obj1, classes.hidden, empty), _obj1)),
        size: "large"
    }), /*#__PURE__*/ _react.default.createElement(_clear.default, {
        rel: "clear"
    })) : submitButtonVariant === 'icon' && /*#__PURE__*/ _react.default.createElement(SubmitButtonComponent, _extends({
        Component: _material.Button,
        className: (0, _clsx).default((_obj2 = {
        }, _defineProperty(_obj2, classes.searchButton, true), _defineProperty(_obj2, classes.hidden, empty), _obj2)),
        text: value,
        color: "primary"
    }, submitButtonProps))), submitButtonVariant === 'fab' && /*#__PURE__*/ _react.default.createElement(SubmitButtonComponent, _extends({
        Component: _material.Fab,
        className: (0, _clsx).default((_obj3 = {
        }, _defineProperty(_obj3, classes.searchFab, true), _defineProperty(_obj3, classes.hidden, empty), _obj3)),
        text: value,
        ButtonIcon: SubmitButtonIcon
    }, submitButtonProps))));
});
SearchField.propTypes = {
    /**
   * Label for accessibility, defaults to search-text
   */ ariaLabel: _propTypes.default.string,
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * The component to use for the submit button.
   */ SubmitButtonComponent: _propTypes.default.elementType,
    /**
   * An icon to use for the submit button.
   */ SubmitButtonIcon: _propTypes.default.elementType,
    /**
   * The type of submit button to display.
   */ submitButtonVariant: _propTypes.default.oneOf([
        'icon',
        'fab',
        'none'
    ]),
    /**
   * If `true`, show the clear button when text is entered.
   */ showClearButton: _propTypes.default.bool,
    /**
   * Additional props for the clear button.
   */ clearButtonProps: _propTypes.default.object,
    /**
   * Additional props for the Material UI [Input](https://mui.com/api/input/).
   */ inputProps: _propTypes.default.object,
    /**
   * Additional props for the submit button.
   */ submitButtonProps: _propTypes.default.object,
    /**
   * A function to call when the search query value is changed.
   */ onChange: _propTypes.default.func,
    /**
   * Input value.
   */ value: _propTypes.default.string,
    /**
   * A function to call when input is focused.
   */ onFocus: _propTypes.default.func
};
SearchField.defaultProps = {
    SubmitButtonComponent: _searchSubmitButton.default,
    submitButtonVariant: 'fab',
    showClearButton: true,
    placeholder: 'Search...',
    ariaLabel: 'search-text',
    name: 'q',
    value: ''
};
var _default = SearchField;
exports.default = _default;

//# sourceMappingURL=SearchField.js.map