"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchForm;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireWildcard(require("react"));
var _router = require("next/router");
var _qs = _interopRequireDefault(require("qs"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var PREFIX = 'RSFSearchForm';
var defaultClasses = {
    root: "".concat(PREFIX, "-root")
};
var Root = (0, _styles).styled('form')(function() {
    return(/**
   * Styles applied to the root element.
   */ _defineProperty({
    }, "&.".concat(defaultClasses.root), {
        position: 'relative',
        height: '100%',
        display: 'flex',
        flexDirection: 'column'
    }));
});
function SearchForm(param) {
    var tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, children = param.children, action = param.action, autoComplete = param.autoComplete;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var ref = (0, _react).useRef();
    var router = (0, _router).useRouter();
    var handleSubmit = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee(e) {
        var data, query, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _value, name, value, url;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    e.preventDefault();
                    data = new FormData(ref.current);
                    query = {
                    };
                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                    _ctx.prev = 4;
                    for(_iterator = data.entries()[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                        _value = _slicedToArray(_step.value, 2), name = _value[0], value = _value[1];
                        query[name] = value;
                    }
                    _ctx.next = 12;
                    break;
                case 8:
                    _ctx.prev = 8;
                    _ctx.t0 = _ctx["catch"](4);
                    _didIteratorError = true;
                    _iteratorError = _ctx.t0;
                case 12:
                    _ctx.prev = 12;
                    _ctx.prev = 13;
                    if (!_iteratorNormalCompletion && _iterator.return != null) {
                        _iterator.return();
                    }
                case 15:
                    _ctx.prev = 15;
                    if (!_didIteratorError) {
                        _ctx.next = 18;
                        break;
                    }
                    throw _iteratorError;
                case 18:
                    return _ctx.finish(15);
                case 19:
                    return _ctx.finish(12);
                case 20:
                    url = "".concat(action).concat(action.includes('?') ? '&' : '?').concat(_qs.default.stringify(query));
                    router.push(action.split(/\?/)[0], url);
                    return _ctx.abrupt("return", false);
                case 23:
                case "end":
                    return _ctx.stop();
            }
        }, _callee, null, [
            [
                4,
                8,
                12,
                20
            ],
            [
                13,
                ,
                15,
                19
            ]
        ]);
    }));
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        ref: ref,
        action: action,
        onSubmit: handleSubmit,
        className: classes.root,
        target: "_top",
        autoComplete: autoComplete ? 'on' : 'off'
    }, children));
}
SearchForm.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Children to be rendered inside the form.
   */ children: _propTypes.default.node,
    /**
   * An `action` attribute to use for the `<form>` element.
   */ action: _propTypes.default.string,
    /**
   * Form auto complete
   */ autoComplete: _propTypes.default.bool
};
SearchForm.defaultProps = {
    action: '/search',
    autoComplete: false
};

//# sourceMappingURL=SearchForm.js.map