"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchPopover;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _material = require("@mui/material");
var _useNavigationEvent = _interopRequireDefault(require("react-storefront/hooks/useNavigationEvent"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFSearchPopover';
var defaultClasses = {
    popoverPaper: "".concat(PREFIX, "-popoverPaper")
};
var StyledPopover = (0, _styles).styled(_material.Popover)(function(param) {
    var theme = param.theme;
    return(/**
   * Styles applied to the popover paper
   */ _defineProperty({
    }, "& .".concat(defaultClasses.popoverPaper), {
        boxShadow: '0px 5px 5px -3px rgba(0,0,0,0.2), 0px 8px 10px 1px rgba(0,0,0,0.14)',
        minWidth: theme.spacing(84),
        minHeight: theme.spacing(75),
        border: "1px solid ".concat(theme.palette.divider)
    }));
});
function SearchPopover(_param) {
    var tmp = _param.classes, c = tmp === void 0 ? {
    } : tmp, children = _param.children, open = _param.open, onClose = _param.onClose, anchor = _param.anchor, setQuery = _param.setQuery, others = _objectWithoutProperties(_param, [
        "classes",
        "children",
        "open",
        "onClose",
        "anchor",
        "setQuery"
    ]);
    var classes = _objectSpread({
    }, defaultClasses, c);
    var handleNavigation = function() {
        if (onClose) {
            onClose();
        }
        if (setQuery) {
            setQuery('');
        }
        anchor.current.blur();
    };
    (0, _useNavigationEvent).default(handleNavigation);
    return(/*#__PURE__*/ _react.default.createElement(StyledPopover, _extends({
        open: open,
        disableAutoFocus: true,
        disableEnforceFocus: true,
        disableRestoreFocus: true,
        disablePortal: true,
        disableScrollLock: true,
        keepMounted: true,
        onClose: onClose,
        anchorEl: anchor.current,
        anchorOrigin: {
            vertical: 'bottom',
            horizontal: 'right'
        },
        transformOrigin: {
            vertical: 'top',
            horizontal: 'right'
        },
        PaperProps: {
            square: true,
            className: classes.popoverPaper
        }
    }, others), children));
}
SearchPopover.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * A list of `ExpandableSection`s that will be controlled.
   */ children: _propTypes.default.node,
    /**
   * Boolean, which controls if popover is open.
   */ open: _propTypes.default.bool,
    /**
   * Function, which is triggered on navigation and popover close.
   */ onClose: _propTypes.default.func,
    /**
   * Popover anchor
   */ anchor: _propTypes.default.shape({
        current: _propTypes.default.any
    }),
    /**
   * Function, for setting query to empty after navigation
   */ setQuery: _propTypes.default.func
};

//# sourceMappingURL=SearchPopover.js.map