"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchSubmitButton;
var _search = _interopRequireDefault(require("@mui/icons-material/Search"));
var _styles = require("@mui/material/styles");
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
var PREFIX = 'RSFSearchSubmitButton';
var classes = {
    root: "".concat(PREFIX, "-root"),
    label: "".concat(PREFIX, "-label")
};
var _obj;
function SearchSubmitButton(_param) {
    var Component = _param.Component, ButtonIcon = _param.ButtonIcon, text = _param.text, others = _objectWithoutProperties(_param, [
        "Component",
        "ButtonIcon",
        "text"
    ]);
    var StyledComponent = (0, _styles).styled(Component)(function() {
        return _obj = {
        }, /**
     * Styles applied to the root element.
     */ _defineProperty(_obj, "&.".concat(classes.root), {
        }), /**
     * Styles applied to the label element.
     */ _defineProperty(_obj, "& .".concat(classes.label), {
            display: 'flex'
        }), _obj;
    });
    return(/*#__PURE__*/ _react.default.createElement(StyledComponent, _extends({
        rel: "search",
        type: "submit",
        className: classes.root,
        classes: {
            label: classes.label
        },
        disabled: text.trim().length === 0
    }, others), /*#__PURE__*/ _react.default.createElement(ButtonIcon, null)));
}
SearchSubmitButton.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * A Material UI button component to display.
   */ Component: _propTypes.default.elementType.isRequired,
    /**
   * A Material UI button component to display.
   */ ButtonIcon: _propTypes.default.elementType,
    /**
   * The current search text.
   */ text: _propTypes.default.string.isRequired
};
SearchSubmitButton.defaultProps = {
    ButtonIcon: _search.default
};

//# sourceMappingURL=SearchSubmitButton.js.map