"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchSuggestionGroup;
var _react = _interopRequireDefault(require("react"));
var _styles = require("@mui/material/styles");
var _typography = _interopRequireDefault(require("@mui/material/Typography"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _searchSuggestionItem = _interopRequireDefault(require("./SearchSuggestionItem"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSearchSuggestionGroup';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    caption: "".concat(PREFIX, "-caption"),
    list: "".concat(PREFIX, "-list")
};
var _obj;
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        listStyle: 'none',
        margin: theme.spacing(2),
        '& a strong': {
            fontWeight: 'bold',
            color: 'inherit'
        }
    }), /**
   * Styles applied to the group's caption element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.caption), {
        textTransform: 'uppercase',
        fontWeight: 'bold',
        paddingBottom: 5,
        borderBottom: "1px solid ".concat(theme.palette.divider),
        margin: theme.spacing(0, 0, 1, 0)
    }), /**
   * Styles applied to the group's list element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.list), {
        '&[data-ui=list]': {
            padding: 0,
            margin: theme.spacing(0, 0, 4, 0)
        },
        '&[data-ui=thumbnails]': {
            display: 'flex',
            listStyle: 'none',
            margin: '0 -15px',
            padding: '0 10px',
            overflowX: 'auto',
            '& > li': {
                margin: '5px'
            }
        }
    }), _obj;
});
function SearchSuggestionGroup(param) {
    var tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, ui = param.ui, caption = param.caption, links = param.links, children = param.children;
    var classes = _objectSpread({
    }, defaultClasses, c);
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(_typography.default, {
        className: classes.caption
    }, caption), /*#__PURE__*/ _react.default.createElement("ul", {
        className: classes.list,
        "data-ui": ui
    }, children || links.map(function(item, i) {
        /*#__PURE__*/ return _react.default.createElement(_searchSuggestionItem.default, {
            item: item,
            ui: ui,
            key: i
        });
    }))));
}
SearchSuggestionGroup.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Child nodes that can be used for the suggestion group instead of mapping the [links](#prop-links).
   */ children: _propTypes.default.node,
    /**
   * An array of props to pass to a [SearchSuggestionItem](/apiReference/search/SearchSuggestionItem)
   * with data for suggested searches.
   */ links: _propTypes.default.arrayOf(_propTypes.default.shape({
        as: _propTypes.default.string,
        href: _propTypes.default.string,
        text: _propTypes.default.string,
        pageData: _propTypes.default.object,
        thumbnail: _propTypes.default.object
    })),
    /**
   * A title for the list.
   */ caption: _propTypes.default.string.isRequired,
    ui: _propTypes.default.any
};
SearchSuggestionGroup.defaultProps = {
};

//# sourceMappingURL=SearchSuggestionGroup.js.map