"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchSuggestionItem;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _link = _interopRequireDefault(require("../link/Link"));
var _image = _interopRequireDefault(require("../Image"));
var _searchContext = _interopRequireDefault(require("./SearchContext"));
var _highlight = _interopRequireDefault(require("../Highlight"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSearchSuggestionItem';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    thumbnail: "".concat(PREFIX, "-thumbnail"),
    text: "".concat(PREFIX, "-text"),
    highlight: "".concat(PREFIX, "-highlight")
};
var _obj;
var Root = (0, _styles).styled('li')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, _defineProperty(_obj, "&.".concat(defaultClasses.root), {
        margin: theme.spacing(2, 0),
        listStyle: 'none',
        padding: 0,
        '& [data-ui=thumbnails]': {
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'flex-start'
        }
    }), _defineProperty(_obj, "& .".concat(defaultClasses.thumbnail), {
        marginBottom: '10px',
        display: 'none',
        '[data-ui=thumbnails] &': {
            display: 'block',
            '& img': {
                height: 120,
                width: 120,
                minWidth: 120
            }
        }
    }), _defineProperty(_obj, "& .".concat(defaultClasses.text), {
    }), _defineProperty(_obj, "& .".concat(defaultClasses.highlight), {
        backgroundColor: 'rgba(0,0,0,0.05)',
        borderRadius: '2px',
        color: theme.palette.secondary.main
    }), _obj;
});
function SearchSuggestionItem(param) {
    var ImageComponent = param.ImageComponent, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp, item = param.item, ui = param.ui, thumbnailProps = param.thumbnailProps, children = param.children;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var query = (0, _react).useContext(_searchContext.default).query;
    return(/*#__PURE__*/ _react.default.createElement(Root, {
        className: classes.root
    }, /*#__PURE__*/ _react.default.createElement(_link.default, {
        as: item.as,
        href: item.href,
        pageData: item.pageData
    }, children || /*#__PURE__*/ _react.default.createElement("a", {
        href: item.as
    }, /*#__PURE__*/ _react.default.createElement("div", {
        "data-ui": ui
    }, /*#__PURE__*/ _react.default.createElement(ImageComponent, _extends({
        className: classes.thumbnail
    }, thumbnailProps, item.thumbnail)), /*#__PURE__*/ _react.default.createElement(_highlight.default, {
        className: classes.text,
        query: query,
        text: item.text,
        classes: classes
    }))))));
}
SearchSuggestionItem.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    /**
   * Child nodes that can be used for the link body. If not included, will default to using the
   * [item](prop-item)'s `thumbnail` and `text`.
   */ children: _propTypes.default.node,
    /**
   * Contains all the metadata needed to display the search suggestion item.
   */ item: _propTypes.default.shape({
        as: _propTypes.default.string,
        href: _propTypes.default.string,
        text: _propTypes.default.string,
        pageData: _propTypes.default.object,
        thumbnail: _propTypes.default.object
    }),
    /**
   * Props to be passed to the image for thumbnails.
   */ thumbnailProps: _propTypes.default.object,
    /**
   * The component type to use to display images.
   */ ImageComponent: _propTypes.default.elementType,
    ui: _propTypes.default.any
};
SearchSuggestionItem.defaultProps = {
    ImageComponent: _image.default
};

//# sourceMappingURL=SearchSuggestionItem.js.map