"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SearchSuggestions;
var _react = _interopRequireWildcard(require("react"));
var _styles = require("@mui/material/styles");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _searchSuggestionGroup = _interopRequireDefault(require("./SearchSuggestionGroup"));
var _searchContext = _interopRequireDefault(require("./SearchContext"));
var _loadMask = _interopRequireDefault(require("../LoadMask"));
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _extends() {
    _extends = Object.assign || function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source){
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key];
                }
            }
        }
        return target;
    };
    return _extends.apply(this, arguments);
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
var PREFIX = 'RSFSearchSuggestions';
var defaultClasses = {
    root: "".concat(PREFIX, "-root"),
    group: "".concat(PREFIX, "-group")
};
var _obj;
// TODO jss-to-styled codemod: The Fragment root was replaced by div. Change the tag if needed.
var Root = (0, _styles).styled('div')(function(param) {
    var theme = param.theme;
    return _obj = {
    }, /**
   * Styles applied to the root element.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.root), {
        flex: 1,
        position: 'relative',
        overflowY: 'auto'
    }), /**
   * Styles applied to each of the group wrapper elements.
   */ _defineProperty(_obj, "& .".concat(defaultClasses.group), {
        margin: theme.spacing(0, 0, 2, 0)
    }), _obj;
});
function SearchSuggestions(param) {
    var render = param.render, tmp = param.classes, c = tmp === void 0 ? {
    } : tmp;
    var classes = _objectSpread({
    }, defaultClasses, c);
    var state = (0, _react).useContext(_searchContext.default).state;
    return(/*#__PURE__*/ _react.default.createElement(Root, null, /*#__PURE__*/ _react.default.createElement(_loadMask.default, {
        show: state.loading,
        transparent: true
    }), /*#__PURE__*/ _react.default.createElement("div", {
        className: classes.root
    }, render ? render(state) : state.groups && state.groups.map(function(group) {
        /*#__PURE__*/ return _react.default.createElement("div", {
            key: group.caption,
            className: classes.group
        }, /*#__PURE__*/ _react.default.createElement(_searchSuggestionGroup.default, _extends({
        }, group)));
    }))));
}
SearchSuggestions.propTypes = {
    /**
   * Override or extend the styles applied to the component. See [CSS API](#css) below for more details.
   */ classes: _propTypes.default.object,
    render: _propTypes.default.func
};
SearchSuggestions.defaultProps = {
};

//# sourceMappingURL=SearchSuggestions.js.map