"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = SessionProvider;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _get = _interopRequireDefault(require("lodash/get"));
var _sessionContext = _interopRequireDefault(require("./SessionContext"));
var _fetch = _interopRequireDefault(require("../fetch"));
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj;
    } else {
        var newObj = {
        };
        if (obj != null) {
            for(var key in obj){
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {
                    };
                    if (desc.get || desc.set) {
                        Object.defineProperty(newObj, key, desc);
                    } else {
                        newObj[key] = obj[key];
                    }
                }
            }
        }
        newObj.default = obj;
        return newObj;
    }
}
function _iterableToArrayLimit(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;
    try {
        for(var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance");
}
function _objectSpread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {
        };
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _defineProperty(target, key, source[key]);
        });
    }
    return target;
}
function _objectWithoutProperties(source, excluded) {
    if (source == null) return {
    };
    var target = _objectWithoutPropertiesLoose(source, excluded);
    var key, i;
    if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
        for(i = 0; i < sourceSymbolKeys.length; i++){
            key = sourceSymbolKeys[i];
            if (excluded.indexOf(key) >= 0) continue;
            if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
            target[key] = source[key];
        }
    }
    return target;
}
function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {
    };
    var target = {
    };
    var sourceKeys = Object.keys(source);
    var key, i;
    for(i = 0; i < sourceKeys.length; i++){
        key = sourceKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        target[key] = source[key];
    }
    return target;
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}
var initialState = {
    signedIn: false,
    cart: {
        items: []
    }
};
function SessionProvider(param1) {
    var url = param1.url, children = param1.children;
    var ref = _slicedToArray((0, _react).useState(initialState), 2), session = ref[0], setSession = ref[1];
    var context = (0, _react).useMemo(function() {
        return {
            session: session,
            actions: {
                signIn: /**
         * Signs an existing user in
         * @param {String} email The user's email
         * @param {String} password The user's password
         */ function signIn(param) {
                    var email = param.email, password = param.password;
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    _ctx.next = 2;
                                    return (0, _fetch).default('/api/signIn', {
                                        method: 'post',
                                        body: JSON.stringify({
                                            email: email,
                                            password: password
                                        })
                                    });
                                case 2:
                                    response = _ctx.sent;
                                    _ctx.next = 5;
                                    return response.json();
                                case 5:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 10;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 11;
                                    break;
                                case 10:
                                    throw new Error((0, _get).default(result, 'error', 'An error occurred during sign in'));
                                case 11:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                },
                signOut: /**
         * Signs the user out
         */ function signOut() {
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    _ctx.next = 2;
                                    return (0, _fetch).default('/api/signOut', {
                                        method: 'post'
                                    });
                                case 2:
                                    response = _ctx.sent;
                                    _ctx.next = 5;
                                    return response.json();
                                case 5:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 10;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 11;
                                    break;
                                case 10:
                                    throw new Error((0, _get).default(result, 'error', 'An error occurred during sign out'));
                                case 11:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                },
                signUp: /**
         * Signs the user up for a new account
         * @param {Object} options
         * @param {String} firstName The user's first name
         * @param {String} lastName The user's last name
         * @param {String} email The user's email address
         * @param {String} password The user's password
         * @param {Object} ...others Additional data to submit to api/signUp
         */ function signUp(_param) {
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var firstName, lastName, email, password, others, response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    firstName = _param.firstName, lastName = _param.lastName, email = _param.email, password = _param.password, others = _objectWithoutProperties(_param, [
                                        "firstName",
                                        "lastName",
                                        "email",
                                        "password"
                                    ]);
                                    _ctx.next = 3;
                                    return (0, _fetch).default('/api/signUp', {
                                        method: 'post',
                                        body: JSON.stringify(_objectSpread({
                                            firstName: firstName,
                                            lastName: lastName,
                                            email: email,
                                            password: password
                                        }, others))
                                    });
                                case 3:
                                    response = _ctx.sent;
                                    _ctx.next = 6;
                                    return response.json();
                                case 6:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 11;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 12;
                                    break;
                                case 11:
                                    throw new Error((0, _get).default(result, 'error', 'An error occurred during sign up'));
                                case 12:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                },
                addToCart: /**
         * Adds items to the cart
         * @param {Object} product Product data object
         * @param {Number} quantity The quantity to add to the cart
         * @param {Object} otherParams Additional data to submit to api/addToCart
         */ function addToCart(_param) {
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var product, quantity, otherParams, response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    product = _param.product, quantity = _param.quantity, otherParams = _objectWithoutProperties(_param, [
                                        "product",
                                        "quantity"
                                    ]);
                                    _ctx.next = 3;
                                    return (0, _fetch).default('/api/cart/add', {
                                        method: 'post',
                                        headers: {
                                            'Content-Type': 'application/json'
                                        },
                                        body: JSON.stringify(_objectSpread({
                                            product: product,
                                            quantity: quantity
                                        }, otherParams))
                                    });
                                case 3:
                                    response = _ctx.sent;
                                    _ctx.next = 6;
                                    return response.json();
                                case 6:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 11;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 12;
                                    break;
                                case 11:
                                    throw new Error((0, _get).default(result, 'error', 'An unknown error occurred while attempting to add the item to your cart.'));
                                case 12:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                },
                updateCart: /**
         * Updates the items in the cart. Use this function to update the quantity of a product
         * in the cart or remove a product from the cart.
         * @param {Object} item Cart item to be updated
         * @param {number} quantity Expected quantity value
         * @param {Object} otherParams Additional data to submit to api/cart/update
         */ function updateCart(_param) {
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var item, quantity, otherParams, response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    item = _param.item, quantity = _param.quantity, otherParams = _objectWithoutProperties(_param, [
                                        "item",
                                        "quantity"
                                    ]);
                                    _ctx.next = 3;
                                    return (0, _fetch).default('/api/cart/update', {
                                        method: 'post',
                                        headers: {
                                            'Content-Type': 'application/json'
                                        },
                                        body: JSON.stringify(_objectSpread({
                                            item: item,
                                            quantity: quantity
                                        }, otherParams))
                                    });
                                case 3:
                                    response = _ctx.sent;
                                    _ctx.next = 6;
                                    return response.json();
                                case 6:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 11;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 12;
                                    break;
                                case 11:
                                    throw new Error((0, _get).default(result, 'error', 'An unknown error occurred while making changes to your cart.'));
                                case 12:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                },
                removeCartItem: /**
         * Removes item in the cart.
         * @param {Object} item Cart item to be updated
         * @param {Object} otherParams Additional data to submit to /api/cart/remove
         */ function removeCartItem(_param) {
                    return _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                        var item, otherParams, response, result;
                        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                            while(1)switch(_ctx.prev = _ctx.next){
                                case 0:
                                    item = _param.item, otherParams = _objectWithoutProperties(_param, [
                                        "item"
                                    ]);
                                    _ctx.next = 3;
                                    return (0, _fetch).default('/api/cart/remove', {
                                        method: 'post',
                                        headers: {
                                            'Content-Type': 'application/json'
                                        },
                                        body: JSON.stringify(_objectSpread({
                                            item: item
                                        }, otherParams))
                                    });
                                case 3:
                                    response = _ctx.sent;
                                    _ctx.next = 6;
                                    return response.json();
                                case 6:
                                    result = _ctx.sent;
                                    if (!response.ok) {
                                        _ctx.next = 11;
                                        break;
                                    }
                                    {
                                        setSession(_objectSpread({
                                        }, session, result));
                                    }
                                    _ctx.next = 12;
                                    break;
                                case 11:
                                    throw new Error((0, _get).default(result, 'error', 'An unknown error occurred while removing item from your cart.'));
                                case 12:
                                case "end":
                                    return _ctx.stop();
                            }
                        }, _callee);
                    }))();
                }
            }
        };
    }, [
        session
    ]);
    (0, _react).useEffect(function() {
        function fetchSession() {
            return _fetchSession.apply(this, arguments);
        }
        function _fetchSession() {
            _fetchSession = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
                var response, result;
                return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
                    while(1)switch(_ctx.prev = _ctx.next){
                        case 0:
                            _ctx.next = 2;
                            return (0, _fetch).default(url);
                        case 2:
                            response = _ctx.sent;
                            _ctx.next = 5;
                            return response.json();
                        case 5:
                            result = _ctx.sent;
                            setSession(result);
                        case 7:
                        case "end":
                            return _ctx.stop();
                    }
                }, _callee);
            }));
            return _fetchSession.apply(this, arguments);
        }
        if (url) fetchSession();
    }, [
        url
    ]);
    return(/*#__PURE__*/ _react.default.createElement(_sessionContext.default.Provider, {
        value: context
    }, children));
}
SessionProvider.propTypes = {
    /**
   * A URL to fetch when the app mounts which establishes a user session and returns user and cart data
   * to be made available via `react-storefront/session/SessionContext`.
   */ url: _propTypes.default.string
};

//# sourceMappingURL=SessionProvider.js.map