"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = getBase64ForImage;
var _regeneratorRuntime = _interopRequireDefault(require("regenerator-runtime"));
var _fetch = _interopRequireDefault(require("../fetch"));
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _asyncToGenerator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
function getBase64ForImage() {
    return _getBase64ForImage.apply(this, arguments);
}
function _getBase64ForImage() {
    _getBase64ForImage = _asyncToGenerator(_regeneratorRuntime.default.mark(function _callee() {
        var _len, args, _key, res, contentType, buffer, _args = arguments;
        return _regeneratorRuntime.default.wrap(function _callee$(_ctx) {
            while(1)switch(_ctx.prev = _ctx.next){
                case 0:
                    for(_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                        args[_key] = _args[_key];
                    }
                    _ctx.next = 3;
                    return _fetch.default.apply(void 0, _toConsumableArray(args));
                case 3:
                    res = _ctx.sent;
                    contentType = res.headers.get('content-type');
                    _ctx.next = 7;
                    return res.buffer();
                case 7:
                    buffer = _ctx.sent;
                    return _ctx.abrupt("return", "data:".concat(contentType, ";base64,").concat(buffer.toString('base64')));
                case 9:
                case "end":
                    return _ctx.stop();
            }
        }, _callee);
    }));
    return _getBase64ForImage.apply(this, arguments);
}

//# sourceMappingURL=getBase64ForImage.js.map