"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = withCaching;
function withCaching(handler, maxAgeSeconds) {
    return function(req, res) {
        if (maxAgeSeconds) {
            res.setHeader('x-sw-cache-control', "max-age: ".concat(maxAgeSeconds));
        }
        return handler(req, res);
    };
}

//# sourceMappingURL=withCaching.js.map