"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = withDefaultHandler;
function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
        for(var i = 0, arr2 = new Array(arr.length); i < arr.length; i++){
            arr2[i] = arr[i];
        }
        return arr2;
    }
}
function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}
function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
}
function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}
function withDefaultHandler(handler, defaultHandler) {
    return function(e) {
        for(var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++){
            args[_key - 1] = arguments[_key];
        }
        if (handler) {
            handler.apply(void 0, [
                e
            ].concat(_toConsumableArray(args)));
        }
        if (!e.defaultPrevented) {
            defaultHandler.apply(void 0, [
                e
            ].concat(_toConsumableArray(args)));
        }
    };
}

//# sourceMappingURL=withDefaultHandler.js.map